/*3:*/
#line 19 "hill.w"

#include "psimpoll.h" 
#include "ppglobal.h" 

/*:3*//*4:*/
#line 24 "hill.w"

/*7:*/
#line 398 "hill.w"

static void cutup(real*x,int*ix,int mi,int mk);
/*:7*//*9:*/
#line 446 "hill.w"

static void eigy(real*x,real*y,real*eig,int neig,ca_t ca,int mk,
int mi,int n,real**trandat,real*y2,real*y3,real*y4,real*y5,
real*xeig1,real*xeig2,real*xeig3,int*ix1,int*ix2,int*ix3,
real*aidot,real*adotj,file_t*stat,real tol);
/*:9*//*11:*/
#line 727 "hill.w"

static void detrnd(real*x,real*aidot,int*ix,int mk,int mi);
/*:11*//*13:*/
#line 793 "hill.w"

static void segmnt(real*x,real*y,real*zn,real*zv,int mi,int mk,
int n,real*aidot,real**trandat);
/*:13*//*15:*/
#line 858 "hill.w"

static void casmooth(real*z,int mk);
/*:15*//*17:*/
#line 908 "hill.w"

static void strtch(real*x,real*y,real resth,int monit,int mi,
int n,real*aidot,real**trandat,file_t*stat);
/*:17*//*19:*/
#line 1033 "hill.w"

static void trans(real*y,real*yy,real*x,int neig,flag_t dca,
real*aidot,real*xeig1,real*xeig2,real*xeig3,int*ix1,int*ix2,
int*ix3,int mk,int mi,int n,real**trandat);
/*:19*//*21:*/
#line 1116 "hill.w"

static void xmaxmi(real*x,real*axmax,real*axmin,int n);
/*:21*//*23:*/
#line 1150 "hill.w"

static void xymult(real*x,real*y,int mi,int n,real**trandat);
/*:23*//*25:*/
#line 1187 "hill.w"

static void yxmult(real*y,real*x,int mi,int n,real**trandat);
/*:25*/
#line 25 "hill.w"


/*:4*//*6:*/
#line 33 "hill.w"

void caer
(
ca_t ca,
int nnsam,
int nntax,
real**smdat,
real*rsum,
char**taxname,
file_t*stat
)

{
char buffer[LENSTR]= "";
int mk= 0;
int naxes= 4;
static int models= 0;

loop_t i= 0;
loop_t j= 0;
loop_t jj= 0;
loop_t k= 0;
loop_t m= 0;

real amax= 0.0;
real amin= 0.0;
real eig1= 0.0;
real eig2= 0.0;
real eig3= 0.0;
real eig4= 0.0;

real tol= 0.000005;
real tot= 0.0;


int*ix1= NULL;
int*ix2= NULL;
int*ix3= NULL;
int*ix4= NULL;
int*iy1= NULL;
int*iy2= NULL;
int*iy3= NULL;
int*iy4= NULL;

real*adotj= NULL;
real*aidot= NULL;
real*v= NULL;
real*xeig1= NULL;
real*xeig2= NULL;
real*xeig3= NULL;
real*xeig4= NULL;
real*yeig1= NULL;
real*yeig2= NULL;
real*yeig3= NULL;
real*yeig4= NULL;
real*y2= NULL;
real*y3= NULL;
real*y4= NULL;
real*y5= NULL;

static real**evaluesd= NULL;
real**trandat= NULL;

ix1= avecint(nnsam+1);
ix2= avecint(nnsam+1);
ix3= avecint(nnsam+1);
ix4= avecint(nnsam+1);
iy1= avecint(nntax+1);
iy2= avecint(nntax+1);
iy3= avecint(nntax+1);
iy4= avecint(nntax+1);

adotj= avecreal(nntax+1);
aidot= avecreal(nnsam+1);
trandat= amatreal(nntax,nnsam);
v= avecreal(nntax+1);
xeig1= avecreal(nnsam+1);
xeig2= avecreal(nnsam+1);
xeig3= avecreal(nnsam+1);
xeig4= avecreal(nnsam+1);
yeig1= avecreal(nntax+1);
yeig2= avecreal(nntax+1);
yeig3= avecreal(nntax+1);
yeig4= avecreal(nntax+1);
y2= avecreal(nntax+1);
y3= avecreal(nntax+1);
y4= avecreal(nntax+1);
y5= avecreal(nntax+1);

dprint(&(*stat),"\nCorrespondence analysis\n");
rtn= fputc('\n',stat->fp);
assert(rtn!=EOF);

rtn= fprintf(stat->fp,"Options in effect:\n");
assert(rtn>0);
rtn= fprintf(stat->fp,"Detrending: %s\n",ca.dca==ON?"ON":"OFF");
assert(rtn>0);
rtn= fprintf(stat->fp,"Downweighting of rare types: %s\n",ca.iweigh==ON?"ON":"OFF");
assert(rtn>0);
rtn= fprintf(stat->fp,"Rescaling of axes: %s\n",ca.irescfg==ON?"ON":"OFF");
assert(rtn>0);
rtn= fprintf(stat->fp,"Number of times to rescale: %d %s\n",ca.iresc,
ca.irescfg==OFF?"(ignored)":"");
assert(rtn>0);
rtn= fprintf(stat->fp,"Rescaling threshold: %f\n",ca.resth);
assert(rtn>0);
rtn= fprintf(stat->fp,"Number of segments: %d\n",ca.mk);
assert(rtn>0);
rtn= fprintf(stat->fp,"Tolerance: %f\n",tol);
assert(rtn>0);
rtn= fputc('\n',stat->fp);
assert(rtn!=EOF);

if(ca.model.ci)
{
if(models==0)
{
models= ca.model.n;
evaluesd= amatreal(naxes,models);
}
dprint(&(*stat),"Model %d of %d",1+models-ca.model.n,models);
}
dprint(&(*stat),"\n");


datatran(ca.tran,nnsam,nntax,smdat,rsum,trandat,&(*stat));


mk= ca.mk+4;


for(j= 1;j<=nntax;j++)
{
yeig1[j]= 0.0;
y2[j]= 1.0e-10;
}


for(i= 1;i<=nnsam;i++)
{
for(j= 1;j<=nntax;j++)
{
yeig1[j]+= trandat[j-1][i-1];
y2[j]+= (SQUARE(trandat[j-1][i-1]));
}
}


for(j= 1;j<=nntax;j++)y2[j]= (SQUARE(yeig1[j]))/y2[j];


xmaxmi(y2,&amax,&amin,nntax);
amax/= 5.0;


for(j= 1;j<=nntax;j++)
{
v[j]= 1.0;
if(ca.iweigh==ON&&y2[j]<amax)v[j]= y2[j]/amax;
}



for(i= 1;i<=nnsam;i++)
{
for(j= 1;j<=nntax;j++)
{
trandat[j-1][i-1]*= v[j];
}
}


for(i= 1;i<=nnsam;i++)
{
xeig1[i]= 1.0;
xeig2[i]= xeig3[i]= xeig4[i]= 0.0;
}


xymult(xeig1,adotj,nnsam,nntax,trandat);
tot= 0.0;
for(j= 1;j<=nntax;j++)
{
if(adotj[j]<1.0e-11)adotj[j]= 1.0e-11;
tot+= adotj[j];
}


for(j= 1;j<=nntax;j++)yeig1[j]= 1.0;
yxmult(yeig1,aidot,nnsam,nntax,trandat);



eigy(xeig1,yeig1,&eig1,0,ca,mk,nnsam,nntax,trandat,y2,y3,y4,y5,
xeig1,xeig2,xeig3,ix1,ix2,ix3,aidot,adotj,&(*stat),tol);
if(ca.dca==ON)cutup(xeig1,ix1,nnsam,mk);

eigy(xeig2,yeig2,&eig2,1,ca,mk,nnsam,nntax,trandat,y2,y3,y4,y5,
xeig1,xeig2,xeig3,ix1,ix2,ix3,aidot,adotj,&(*stat),tol);
if(ca.dca==ON)cutup(xeig2,ix2,nnsam,mk);

eigy(xeig3,yeig3,&eig3,2,ca,mk,nnsam,nntax,trandat,y2,y3,y4,y5,
xeig1,xeig2,xeig3,ix1,ix2,ix3,aidot,adotj,&(*stat),tol);
if(ca.dca==ON)cutup(xeig3,ix3,nnsam,mk);

eigy(xeig4,yeig4,&eig4,3,ca,mk,nnsam,nntax,trandat,y2,y3,y4,y5,
xeig1,xeig2,xeig3,ix1,ix2,ix3,aidot,adotj,&(*stat),tol);


yxmult(yeig1,xeig1,nnsam,nntax,trandat);
yxmult(yeig2,xeig2,nnsam,nntax,trandat);
yxmult(yeig3,xeig3,nnsam,nntax,trandat);
yxmult(yeig4,xeig4,nnsam,nntax,trandat);



if(ca.model.ci==ON)
{
evaluesd[0][ca.model.n-1]= eig1;
evaluesd[1][ca.model.n-1]= eig2;
evaluesd[2][ca.model.n-1]= eig3;
evaluesd[3][ca.model.n-1]= eig4;
}


if(ca.model.ci==OFF&&evaluesd!=NULL)
{
real ave= 0.0;
real sd= 0.0;

for(k= 0;k<naxes;k++)
{
moment2(&sd,&ave,evaluesd[k],models);


evaluesd[k][0]= sd;

}

}





if(ca.model.ci==OFF)
{
rtn= fprintf(stat->fp,"\n\nEigenvalues\n\n"
"     Value     SD n=%-3d\n",models);
assert(rtn>0);

rtn= fprintf(stat->fp,"1 % 9.6f %9.6f\n",eig1,
evaluesd!=NULL?evaluesd[0][0]:0.0);
assert(rtn>0);

rtn= fprintf(stat->fp,"2 % 9.6f %9.6f\n",eig2,
evaluesd!=NULL?evaluesd[1][0]:0.0);
assert(rtn>0);

rtn= fprintf(stat->fp,"3 % 9.6f %9.6f\n",eig3,
evaluesd!=NULL?evaluesd[2][0]:0.0);
assert(rtn>0);

rtn= fprintf(stat->fp,"4 % 9.6f %9.6f\n",eig4,
evaluesd!=NULL?evaluesd[3][0]:0.0);
assert(rtn>0);

}

rtn= fputs("\n\n",stat->fp);
assert(rtn!=EOF);

rtn= fprintf(stat->fp,"Eigenvectors (Species scores)\n\n    ");
assert(rtn>0);


for(k= 0;k<naxes;k++)
{
rtn= fprintf(stat->fp,"%11d",k+1);
assert(rtn>0);
}
rtn= fputc('\n',stat->fp);
assert(rtn!=EOF);
for(j= 1;j<=nntax;j++)
{
m= (int)smdat[j-1][nnsam];
pstrcpy(buffer,taxname[m],7);
rtn= fprintf(stat->fp,"%-8s",buffer);
assert(rtn>0);

rtn= fprintf(stat->fp,"% 10.6f % 10.6f % 10.6f % 10.6f \n",
yeig1[j],yeig2[j],yeig3[j],yeig4[j]);
assert(rtn>0);

}

rtn= fputs("\n\n",stat->fp);
assert(rtn!=EOF);


rtn= fputs("\n\nSample scores\n\n      ",stat->fp);
assert(rtn!=EOF);
for(k= 0;k<naxes;k++)
{
rtn= fprintf(stat->fp,"%10d",k+1);
assert(rtn>0);
}
rtn= fputc('\n',stat->fp);
assert(rtn!=EOF);

for(jj= 1;jj<=nnsam;jj++)
{

rtn= fprintf(stat->fp,"%9.3f ",smdat[nntax][jj-1]);
assert(rtn>0);

rtn= fprintf(stat->fp,"% 9.6f % 9.6f % 9.6f % 9.6f \n",
xeig1[jj]/aidot[jj],xeig2[jj]/aidot[jj],xeig3[jj]/aidot[jj],
xeig4[jj]/aidot[jj]);
assert(rtn>0);

}

rtn= fputs("\n\n",stat->fp);
assert(rtn!=EOF);

if(!ca.model.ci&&evaluesd!=NULL)
{
fmatreal(evaluesd,naxes);
evaluesd= NULL;
}
fvec(yeig4);
fvec(yeig3);
fvec(yeig2);
fvec(yeig1);
fvec(y5);
fvec(y4);
fvec(y3);
fvec(y2);
fvec(xeig4);
fvec(xeig3);
fvec(xeig2);
fvec(xeig1);
fvec(v);
fvec(trandat);
fvec(aidot);
fvec(adotj);

fvec(iy4);
fvec(iy3);
fvec(iy2);
fvec(iy1);
fvec(ix4);
fvec(ix3);
fvec(ix2);
fvec(ix1);

return;
}


/*:6*//*8:*/
#line 401 "hill.w"

static void cutup
(
real*x,
int*ix,
int mi,
int mk
)

{
int iax= 0;
int mmk= 0;
int maxk= 0;

loop_t i= 0;

real axbit= 0.0;
real axmax= 0.0;
real axmin= 0.0;

mmk= mk-4;
maxk= mk-2;
xmaxmi(x,&axmax,&axmin,mi);
axbit= (axmax-axmin)/(real)mmk;
for(i= 1;i<=mi;i++)
{
iax= 3+(int)((x[i]-axmin)/axbit);
if(iax<3)iax= 3;
if(iax>maxk)iax= maxk;
ix[i]= iax;
}

return;
}


/*:8*//*10:*/
#line 452 "hill.w"

static void eigy
(
real*x,
real*y,
real*eig,
int neig,
ca_t ca,
int mk,
int mi,
int n,
real**trandat,
real*y2,
real*y3,
real*y4,
real*y5,
real*xeig1,
real*xeig2,
real*xeig3,
int*ix1,
int*ix2,
int*ix3,
real*aidot,
real*adotj,
file_t*stat,
real tol
)

{
int monit= 0;

loop_t i= 0;
loop_t icount= 0;
loop_t itimes= 0;
loop_t j= 0;

real a= 0.0;
real ax= 0.0;
real axlong= 0.0;
real axx1= 0.0;
real axx2= 0.0;
real axx3= 0.0;
real axx4= 0.0;
real ax1= 0.0;
real ax2= 0.0;
real ax3= 0.0;
real ax4= 0.0;
real ay= 0.0;
real aymax= 0.0;
real aymin= 0.0;
real a11= 0.0;
real a12= 0.0;
real a22= 0.0;
real a23= 0.0;
real a33= 0.0;
real a34= 0.0;
real a44= 0.0;
real b13= 0.0;
real b14= 0.0;
real b24= 0.0;
real ex= 0.0;
real exx= 0.0;
real resi= 0.0;
real sd= 0.0;
real sd1= 0.0;
real sign= 0.0;
real sumsq= 0.0;
real tot= 0.0;

for(j= 1;j<=n;j++)
{
tot+= adotj[j];
y[j]= (real)j;
}
y[1]= 1.1;
trans(y,y,x,neig,ca.dca,aidot,xeig1,xeig2,xeig3,ix1,ix2,ix3,mk,
mi,n,trandat);

for(icount= 0;;)
{
a= 0.0;
for(j= 1;j<=n;j++)a+= (y[j]*adotj[j]);
a/= tot;
ex= 0.0;
for(j= 1;j<=n;j++)
{
ay= y[j]-a;
ex+= (ay*ay*adotj[j]);
y[j]= ay;
}
ex= sqrte(ex);
for(j= 1;j<=n;j++)y[j]/= ex;
trans(y,y2,x,neig,ca.dca,aidot,xeig1,xeig2,xeig3,ix1,ix2,ix3,mk,
mi,n,trandat);
a= a11= a12= a22= a23= a33= a34= a44= 0.0;
for(j= 1;j<=n;j++)
{
ay= y2[j];
y2[j]= ay/adotj[j];
a+= ay;
a11+= (ay*y[j]);
}
a/= tot;
for(j= 1;j<=n;j++)
{
ay= y2[j]-(a+a11*y[j]);
a12+= (ay*ay*adotj[j]);
y2[j]= ay;
}
a12= sqrte(a12);
for(j= 1;j<=n;j++)y2[j]/= a12;
if(icount==0)fprintf(stat->fp,"\nAxis %d\n\n",neig+1);
fprintf(stat->fp,"Residual %f at iteration %d\n",a12,icount);
if(a12<tol)break;

if(icount>999)break;
icount++;
trans(y2,y3,x,neig,ca.dca,aidot,xeig1,xeig2,xeig3,ix1,ix2,ix3,mk,
mi,n,trandat);
a= b13= 0.0;
for(j= 1;j<=n;j++)
{
ay= y3[j];
y3[j]= ay/adotj[j];
a+= ay;
a22+= (ay*y2[j]);
b13+= (ay*y[j]);
}
a/= tot;
for(j= 1;j<=n;j++)
{
ay= y3[j]-(a+a22*y2[j]+b13*y[j]);
a23+= (ay*ay*adotj[j]);
y3[j]= ay;
}
a23= sqrte(a23);
if(a23>tol)
{
for(j= 1;j<=n;j++)y3[j]/= a23;
trans(y3,y4,x,neig,ca.dca,aidot,xeig1,xeig2,xeig3,ix1,ix2,ix3,
mk,mi,n,trandat);
a= b14= b24= 0.0;
for(j= 1;j<=n;j++)
{
ay= y4[j];
y4[j]/= adotj[j];
a+= ay;
a33+= (ay*y3[j]);
b14+= (ay*y[j]);
b24+= (ay*y2[j]);
}
a/= tot;
for(j= 1;j<=n;j++)
{
ay= y4[j]-(a+a33*y3[j]+b14*y[j]+b24*y2[j]);
a34+= (ay*ay*adotj[j]);
y4[j]= ay;
}
a34= sqrte(a34);
if(a34>tol)
{
for(j= 1;j<=n;j++)y4[j]/= a34;
trans(y4,y5,x,neig,ca.dca,aidot,xeig1,xeig2,xeig3,ix1,ix2,
ix3,mk,mi,n,trandat);
for(j= 1;j<=n;j++)a44+= (y4[j]*y5[j]);
}
else a34= 0.0;

}
else a23= 0.0;




ax1= 1.0;
ax2= 0.1;
ax3= 0.01;
ax4= 0.001;
for(itimes= 1;itimes<=100;itimes++)
{
axx1= a11*ax1+a12*ax2;
axx2= a12*ax1+a22*ax2+a23*ax3;
axx3= a23*ax2+a33*ax3+a34*ax4;
axx4= a34*ax3+a44*ax4;
ax1= a11*axx1+a12*axx2;
ax2= a12*axx1+a22*axx2+a23*axx3;
ax3= a23*axx2+a33*axx3+a34*axx4;
ax4= a34*axx3+a44*axx4;
ex= sqrte(SQUARE(ax1)+SQUARE(ax2)+SQUARE(ax3)+SQUARE(ax4));
ax1= ax1/ex;
ax2= ax2/ex;
ax3= ax3/ex;
ax4= ax4/ex;
if(itimes==(itimes/5)*5)
{
exx= sqrte(ex);
resi= sqrte(SQUARE(ax1-axx1/exx)+SQUARE(ax2-axx2/exx)+
SQUARE(ax3-axx3/exx)+SQUARE(ax4-axx4/exx));
if(resi<(tol*0.05))break;
}

}

for(j= 1;j<=n;j++)
{
y[j]= ax1*y[j]+ax2*y2[j]+ax3*y3[j]+ax4*y4[j];
}

}

if(a12>tol)derror(25);




xmaxmi(y,&aymax,&aymin,n);
sign= 1.0;
if(-aymin>aymax)sign= -1.0;
for(j= 1;j<=n;j++)y[j]*= sign;
yxmult(y,x,mi,n,trandat);
for(i= 1;i<=mi;i++)x[i]/= aidot[i];

if(ca.irescfg==ON&&a11<=0.999)
{
for(i= 1;i<=ca.iresc;i++)
{
monit= 0;
if(i==1||i==ca.iresc)monit= 1;
strtch(x,y,ca.resth,monit,mi,n,aidot,trandat,&(*stat));
}

*eig= a11;

return;

}

axlong= 0.0;
for(i= 1;i<=mi;i++)axlong+= (aidot[i]*SQUARE(x[i]));
axlong= sqrte(axlong);
for(i= 1;i<=mi;i++)x[i]/= axlong;
for(j= 1;j<=n;j++)y[j]/= axlong;



sumsq= 0.0;
for(i= 1;i<=mi;i++)
{
ax= x[i];
for(j= 1;j<=n;j++)
{
sumsq+= (trandat[j-1][i-1]*SQUARE(ax-y[j]));
}
}

sd= sqrte(sumsq/tot);
if(a11>0.999)
{
sd= aymax/axlong;
sd1= -aymin/axlong;
if(sd1>sd)sd= sd1;
}
for(j= 1;j<=n;j++)y[j]/= sd;
*eig= a11;

return;
}


/*:10*//*12:*/
#line 730 "hill.w"

static void detrnd
(
real*x,
real*aidot,
int*ix,
int mk,
int mi
)

{
loop_t i= 0;

int k= 0;
int mmk= 0;
int zsize= 51;

real*z= NULL;
real*zbar= NULL;
real*zn= NULL;

z= avecreal(zsize);
zbar= avecreal(zsize);
zn= avecreal(zsize);

for(k= 1;k<=mk;k++)z[k]= zn[k]= 0.0;

for(i= 1;i<=mi;i++)
{
k= ix[i];
z[k]+= (x[i]*aidot[i]);
zn[k]+= aidot[i];
}

mmk= mk-1;

for(k= 2;k<=mmk;k++)
{
zbar[k]= (z[k-1]+z[k]+z[k+1])/
(zn[k-1]+zn[k]+zn[k+1]+1.0e-12);
}
mmk--;
for(k= 3;k<=mmk;k++)z[k]= (zbar[k-1]+zbar[k]+zbar[k+1])/3.0;
for(i= 1;i<=mi;i++)
{
k= ix[i];
x[i]-= z[k];
}

fvec(zn);
fvec(zbar);
fvec(z);

return;
}


/*:12*//*14:*/
#line 797 "hill.w"

static void segmnt
(
real*x,
real*y,
real*zn,
real*zv,
int mi,
int mk,
int n,
real*aidot,
real**trandat
)

{
loop_t i= 0;
loop_t j= 0;
loop_t k= 0;

real ax= 0.0;
real axbit= 0.0;
real axmin= 0.0;
real axmax= 0.0;
real sqcorr= 0.0;
real sumsq= 0.0;

for(k= 1;k<=mk;k++)zn[k]= zv[k]= -1.0e-20;
xmaxmi(x,&axmax,&axmin,mi);
axbit= (axmax-axmin)/(real)mk;
for(i= 1;i<=mi;i++)x[i]-= axmin;
for(j= 1;j<=n;j++)y[j]-= axmin;
for(i= 1;i<=mi;i++)
{
sqcorr= 0.0;
sumsq= 2.0e-20;
ax= x[i];
for(j= 1;j<=n;j++)
{
sqcorr+= SQUARE(trandat[j-1][i-1]);
sumsq+= trandat[j-1][i-1]*SQUARE(ax-y[j]);
}
sqcorr/= SQUARE(aidot[i]);

if(sqcorr>0.9999)continue;
sumsq/= aidot[i];
k= 1+(int)(ax/axbit);
if(k>mk)k= mk;
if(k<1)k= 1;
zv[k]+= sumsq;
zn[k]+= 1.0-sqcorr;
}

return;
}


/*:14*//*16:*/
#line 861 "hill.w"

static void casmooth
(
real*z,
int mk
)

{
int istop= 1;

loop_t icount= 0;
loop_t k3= 0;

real az1= 0.0;
real az2= 0.0;
real az3= 0.0;

for(icount= 1;icount<=50;icount++)
{
az2= z[1];
az3= z[2];
if(az3==0.0)istop= 0;
z[1]= 0.75*az2+0.25*az3;
for(k3= 3;k3<=mk;k3++)
{
az1= az2;
az2= az3;
az3= z[k3];

if(az3<=0.0)istop= 0;
z[k3-1]= 0.5*(az2+0.5*(az1+az3));
}
z[mk]= 0.25*az2+0.75*az3;
istop++;
if(istop==4)break;
}

return;
}


/*:16*//*18:*/
#line 912 "hill.w"

static void strtch
(
real*x,
real*y,
real resth,
int monit,
int mi,
int n,
real*aidot,
real**trandat,
file_t*stat
)

{
int iay= 0;
int mk= 0;

loop_t i= 0;
loop_t icount= 0;
loop_t j= 0;
loop_t k= 0;

real along= 0.0;
real ax= 0.0;
real axbit= 0.0;
real az= 0.0;
real azv= 0.0;
real sd= 0.0;
real zvsum= 0.0;

real*zn= NULL;
real*zv= NULL;

zn= avecreal(50+1);
zv= avecreal(50+1);

for(icount= 1;icount<=2;icount++)
{
mk= 20;
segmnt(x,y,zn,zv,mi,mk,n,aidot,trandat);
casmooth(zv,mk);
casmooth(zn,mk);
zvsum= 0.0;
for(k= 1;k<=mk;k++)zvsum+= (zv[k]/zn[k]);
sd= sqrte(zvsum/(real)mk);


along= 0.0;
for(i= 1;i<=mi;i++)
{
ax= x[i]/sd;
x[i]= ax;
if(along<ax)along= ax;
}
if(icount==1&&monit==1)fputc('\n',stat->fp);
if(monit==1)fprintf(stat->fp,"Length of gradient = %f\n",along);
for(j= 1;j<=n;j++)y[j]/= sd;
if(along<resth)break;
if(icount==2)break;
mk= 1+(int)(along*5.0);
if(mk<10)mk= 10;
if(mk>45)mk= 45;
segmnt(x,y,zn,zv,mi,mk,n,aidot,trandat);
casmooth(zv,mk);
casmooth(zn,mk);
zvsum= 0.0;
for(k= 1;k<=mk;k++)
{
azv= 1.0/sqrte(0.2/along+zv[k]/zn[k]);
zvsum+= azv;
zv[k]= azv;
}
for(k= 1;k<=mk;k++)zv[k]*= (along/zvsum);
if(monit==1)
{
fputs("Length of segments:",stat->fp);
for(k= 1;k<=mk;k++)fprintf(stat->fp," %10.6f",zv[k]);
fputc('\n',stat->fp);
}
az= 0.0;
zn[1]= 0.0;
for(k= 1;k<=mk;k++)
{
az+= zv[k];
zn[k+1]= az;
}
axbit= along/(real)mk;
for(j= 1;j<=n;j++)
{
iay= 1+(int)(y[j]/axbit);
if(iay<1)iay= 1;
if(iay>mk)iay= mk;
y[j]= zn[iay]+zv[iay]*(y[j]/axbit-(real)(iay-1));
yxmult(y,x,mi,n,trandat);
}

for(i= 1;i<=mi;i++)x[i]/= aidot[i];

}

fvec(zv);
fvec(zn);

return;
}


/*:18*//*20:*/
#line 1038 "hill.w"

static void trans
(
real*y,
real*yy,
real*x,
int neig,
flag_t dca,
real*aidot,
real*xeig1,
real*xeig2,
real*xeig3,
int*ix1,
int*ix2,
int*ix3,
int mk,
int mi,
int n,
real**trandat
)

{
loop_t i= 0;

real a1= 0.0;
real a2= 0.0;
real a3= 0.0;

yxmult(y,x,mi,n,trandat);
for(i= 1;i<=mi;i++)x[i]/= aidot[i];
if(neig!=0)
{
if(dca==ON)
{
detrnd(x,aidot,ix1,mk,mi);
if(neig!=1)
{
detrnd(x,aidot,ix2,mk,mi);
if(neig!=2)
{
detrnd(x,aidot,ix3,mk,mi);
detrnd(x,aidot,ix2,mk,mi);
}
detrnd(x,aidot,ix1,mk,mi);
}
}
else if(dca==OFF)
{
a1= 0.0;
for(i= 1;i<=mi;i++)a1+= (aidot[i]*x[i]*xeig1[i]);
for(i= 1;i<=mi;i++)x[i]-= (a1*xeig1[i]);
if(neig!=1)
{
a2= 0.0;
for(i= 1;i<=mi;i++)a2+= (aidot[i]*x[i]*xeig2[i]);
for(i= 1;i<=mi;i++)x[i]-= (a2*xeig2[i]);
if(neig!=2)
{
a3= 0.0;
for(i= 1;i<=mi;i++)a3+= (aidot[i]*x[i]*xeig3[i]);
for(i= 1;i<=mi;i++)x[i]-= (a3*xeig3[i]);
}

}

}

}

xymult(x,yy,mi,n,trandat);

return;
}


/*:20*//*22:*/
#line 1119 "hill.w"

static void xmaxmi
(
real*x,
real*axmax,
real*axmin,
int n
)

{
loop_t j= 0;

real ax= 0.0;

*axmax= -1.0e10;
*axmin= -(*axmax);

for(j= 1;j<=n;j++)
{
ax= x[j];
if(ax>*axmax)*axmax= ax;
if(ax<*axmin)*axmin= ax;
}

return;
}


/*:22*//*24:*/
#line 1153 "hill.w"

static void xymult
(
real*x,
real*y,
int mi,
int n,
real**trandat
)

{
loop_t i= 0;
loop_t j= 0;

real ax= 0.0;

for(j= 1;j<=n;j++)y[j]= 0.0;

for(i= 1;i<=mi;i++)
{
ax= x[i];
for(j= 1;j<=n;j++)
{
y[j]+= (ax*trandat[j-1][i-1]);
}
}

return;
}


/*:24*//*26:*/
#line 1190 "hill.w"

static void yxmult
(
real*y,
real*x,
int mi,
int n,
real**trandat
)

{
loop_t i= 0;
loop_t j= 0;

real ax= 0.0;

for(i= 1;i<=mi;i++)
{
ax= 0.0;
for(j= 1;j<=n;j++)
{
ax+= (y[j]*trandat[j-1][i-1]);
}
x[i]= ax;
}

return;
}
/*:26*/
