/*3:*/
#line 14 "ppage.w"

#include "psimpoll.h" 
#include "ppglobal.h" 
#include "ppps.h" 
#include "ppfunc1.h"

/*:3*//*4:*/
#line 21 "ppage.w"

extern const char*opertext_f[9];

/*:4*//*5:*/
#line 25 "ppage.w"

static char buffer_f[LENSTR2];

/*:5*//*6:*/
#line 29 "ppage.w"

/*20:*/
#line 704 "ppage.w"

static void bernshtein_s(eval_t parms,real x,real*y,real*dy);
/*:20*//*27:*/
#line 872 "ppage.w"

static real bico_s(int n,int k);
/*:27*//*29:*/
#line 908 "ppage.w"

static int getpos_s(real*in,int l,real x);
/*:29*//*31:*/
#line 935 "ppage.w"

static void linint_s(eval_t parms,real x,real*y,real*dy);
/*:31*//*33:*/
#line 970 "ppage.w"

static void spline_s(real*x,real*y,int n,real*y2);
/*:33*//*35:*/
#line 1042 "ppage.w"

static void splint_s(eval_t parms,real x,real*y,real*dy);
/*:35*//*37:*/
#line 1084 "ppage.w"

static int test_s(real val,real target,real tol,real*x,real*x1,
real*x2);
/*:37*//*39:*/
#line 1119 "ppage.w"

static void addepax_s(file_t outfile,const caption_t head,const samp_t lev,
const xaxis_t xaxis);
/*:39*//*41:*/
#line 1195 "ppage.w"

static void xscale_s(file_t outfile,frame_t ind,const caption_t head);
/*:41*//*43:*/
#line 1291 "ppage.w"

static void psc14plot_s(file_t outfile,data_t data,ci_t ci,eval_t parms,
real*c14date,real*c14sd,real*c14dp1,real*c14dp2,const frame_t ind,
const samp_t lev);
/*:43*//*45:*/
#line 1396 "ppage.w"

static int btest_s(real val,real target,real tol,real*x,real*x1,
real*x2);
/*:45*/
#line 30 "ppage.w"


/*:6*//*8:*/
#line 40 "ppage.w"

void agedepth
(
file_t*agedep,
file_t*adplot,
data_t*data,
age_t*age,
ci_t ci,
rc14_t c14,
sed_t*sed,
samp_t*lev,
xaxis_t*xsamp,
xaxis_t*xtime,
real asize,
caption_t head,
frame_t*agerange
)

{
/*:8*//*9:*/
#line 60 "ppage.w"

const char*modeltext[]= 
{
"linear interpolation",
"cubic spline interpolation",
"general linear line-fitting by least-squares",
"general linear line-fitting by singular value "
"decomposition",
"Bernshtein polynomial"
};
char sarsdflag[9]= "estimate";
char agesdflag[9]= "estimate";

real a= 0.0;
real ar= 0.0;
real dtemp1= 0.0;
real dtemp2= 0.0;
real meanc14= 0.0;
real ssdc14= 0.0;
real sstc14= 0.0;

flag_t ier= OFF;

real bmaxlev= 0.0;
real bminlev= 0.0;
real bmaxsd= 0.0;
real bminsd= 0.0;
real temp= 0.0;
real tempval= -1.0;
real x= 0.0;

int pos= 0;

loop_t i= 0;
loop_t j= 0;
loop_t jj= 0;
loop_t m= 0;
loop_t n= 0;

eval_t parms= 
{
NULL,NULL,0,NULL,0,0
};

samp_t timdep= 
{
OFF,0,0,0,0,0,0,ON,0,0,0,0
};

void(*evalfunc[])(eval_t,real,real*,real*)= 
{NULL,linint_s,splint_s,evalpoly,evalpoly,bernshtein_s};

/*:9*//*10:*/
#line 113 "ppage.w"

real*asummem= NULL;
real*asuma= NULL;
real*asuma2= NULL;
real*asumar= NULL;
real*asumar2= NULL;
real*asumad= NULL;
real*asumad2= NULL;
real*c14mem= NULL;
real*c14date= NULL;
real*c14dp= NULL;
real*c14dp1= NULL;
real*c14dp2= NULL;
real*c14sd= NULL;
real*randate= NULL;
real*za= NULL;
real*zaa= NULL;

real**zcovar= NULL;

int*iwksp= NULL;

bmaxlev= bmaxsd= -FLT_MAX;
bminlev= bminsd= FLT_MAX;

parms.n= c14.nuse;
parms.range= lev->ex-lev->min;

/*:10*//*11:*/
#line 142 "ppage.w"

if(adplot->fname[0]=='\0')gl.flag[AD]= OFF;
else if(gl.flag[AD]==ON)
{
if(adplot->fname[0]=='\0')gl.flag[AD]= OFF;
else if(gl.flag[AD]==ON)
{
openf(&(*adplot),__FILE__,__LINE__,OFF);
if(adplot->st==CLOSED)gl.flag[AD]= OFF;
if(gl.flag[AD]==ON)
{
psinit(*adplot,data->intitle,asize);
psnpage2(*adplot);
PSPEN2(adplot->fp,10.0);
PSCOMM2(adplot->fp,"s");
getxaxis(&(*lev),age->adbc,&(*xsamp));
pscolour(adplot->fp,agerange->coldep);
addepax_s(*adplot,head,*lev,*xsamp);
}
}

}

/*:11*//*12:*/
#line 166 "ppage.w"

dprint(&(*agedep),"Age model: %s\n",modeltext[age->model-1]);
if(gl.flag[AD]==ON)
{
rtn= fprintf(agedep->fp,"Sediment accumulation coefficient of variation"
" = %.2f over 5 years\n",ci.cvsed);
assert(rtn>0);
}

sed->ar= avecreal(data->nsam);
sed->arsd= avecreal(data->nsam);
c14mem= avecreal(parms.n+parms.n+parms.n+parms.n+parms.n);
c14date= c14mem;
c14sd= c14date+parms.n;
c14dp= c14sd+parms.n;
c14dp1= c14dp+parms.n;
c14dp2= c14dp1+parms.n;

if(age->up>=-2000)
{
c14date[0]= age->up;
c14dp[0]= c14dp1[0]= c14dp2[0]= lev->min;
c14sd[0]= age->upsd;
}

if(age->base>0)
{
c14date[parms.n-1]= age->base;
c14dp[parms.n-1]= c14dp1[parms.n-1]= c14dp2[parms.n-1]= lev->max;
c14sd[parms.n-1]= age->basesd;
}

/*:12*//*13:*/
#line 199 "ppage.w"

n= (age->up>=-2000?1:0);
for(m= 0;m<c14.num;m++)
{
if(isdigit(c14.age[m][0])!=0||c14.age[m][0]=='-')
{
c14date[n]= (real)atof(c14.age[m]);
c14dp1[n]= c14.dp1[m];
c14dp2[n]= c14.dp2[m];
c14dp[n]= (c14.dp1[m]+c14.dp2[m])/2;
c14sd[n]= (real)atof(c14.sd[m]);
n++;
}

}

for(m= 0;m<parms.n;m++)
{

c14dp[m]-= lev->min;
c14dp1[m]-= lev->min;
c14dp2[m]-= lev->min;

if(age->adbc==ON)c14date[m]-= 1950;

c14sd[m]*= age->c14k;

bmaxsd= MAX(bmaxsd,c14date[m]+c14sd[m]);
bminsd= MIN(bminsd,c14date[m]-c14sd[m]);

meanc14+= c14date[m];
}


meanc14/= (real)parms.n;

/*:13*//*14:*/
#line 236 "ppage.w"

iwksp= avecint(parms.n);

indexx(parms.n,c14date,iwksp);
sortinx(parms.n,c14date,iwksp);
sortinx(parms.n,c14dp,iwksp);
sortinx(parms.n,c14dp1,iwksp);
sortinx(parms.n,c14dp2,iwksp);
sortinx(parms.n,c14sd,iwksp);

fvec(iwksp);

/*:14*//*15:*/
#line 249 "ppage.w"

rtn= fputs("Age model input (depth, age, sd)\n",gl.logf.fp);
assert(rtn!=EOF);

for(m= 0;m<parms.n;m++)
{
rtn= fprintf(gl.logf.fp,"%f %f %f\n",c14dp[m],c14date[m],c14sd[m]);
assert(rtn>0);
}

/*:15*//*16:*/
#line 260 "ppage.w"

if(age->model==2||age->model==3||age->model==4)
{
za= avecreal(parms.n);
if(age->model==2)spline_s(c14dp,c14date,parms.n,za);
else zcovar= genfit(&(*agedep),&(*age),za,c14dp,c14date,c14sd,
parms.n,0);
}

if(ci.adflag==ON)
{



if(age->model==1)pstrcpy(agesdflag,"exact",9);

if((age->model==3||age->model==4)&&age->nterm==2)
{
pstrcpy(sarsdflag,"exact",9);
a= (real)sqrte(zcovar[1][1]);
for(j= 0;j<data->nsam;j++)
{
if(data->levfg[j]==ON)sed->arsd[j]= a;
}

}

asummem= avecreal(4*data->nsam);
asuma= asummem;
asuma2= asuma+data->nsam;
asumar= asuma2+data->nsam;
asumar2= asumar+data->nsam;

asumad= avecreal(parms.n);
asumad2= avecreal(parms.n);

randate= avecreal(parms.n);

if(gl.flag[AD]==ON)
{
rtn= fprintf(agedep->fp,
"rng = %d  n = %d  seed = %ld\n",gl.mran,ci.nran,gl.idum);
assert(rtn>0);
}
rtn= printf("Sets of simulated 14C data needed = %d\nCalculated: ",
ci.nran);
assert(rtn>0);
for(i= 0;i<ci.nran;i++)
{
for(n= 0;n<parms.n;n++)
{
randate[n]= gasdev()*c14sd[n]+c14date[n];
}


if(age->model==2||age->model==3||age->model==4)
{
zaa= avecreal(parms.n);
if(age->model==2)spline_s(c14dp,randate,parms.n,zaa);
else zcovar= genfit(&(*agedep),&(*age),zaa,c14dp,randate,c14sd,
parms.n,ci.nran);
}



parms.x= c14dp;
parms.y= randate;
parms.y2a= zaa;
parms.nterm= age->nterm;
for(j= 0;j<data->nsam;j++)
{
if(data->levfg[j]==OFF)continue;

x= (real)data->alev[j]-lev->min;
ar= 0.0;
evalfunc[age->model](parms,x,&a,&ar);
asumar[j]+= ar;
asumar2[j]+= SQUARE(ar);
asuma[j]+= a;
asuma2[j]+= SQUARE(a);

}

for(m= 0;m<parms.n;m++)
{

x= c14dp[m];
ar= 0.0;
evalfunc[age->model](parms,x,&a,&ar);
asumad[m]+= a;
asumad2[m]+= SQUARE(a);

}

fvec(zaa);


rtn= printf("%d ",i+1);
assert(rtn>0);

}

rtn= putchar('\n');
assert(rtn!=EOF);

fvec(randate);

}

parms.x= c14dp;
parms.y= c14date;
parms.y2a= za;
parms.nterm= age->nterm;

/*:16*//*17:*/
#line 375 "ppage.w"

if(gl.flag[AD]==ON)
{
rtn= fputs("\nAge model input (depth, age, sd): and output estimates (age, sd)\n",
agedep->fp);
assert(rtn!=EOF);

for(m= 0;m<parms.n;m++)
{
dtemp1= 0.0;
dtemp2= 0.0;
evalfunc[age->model](parms,c14dp[m],&dtemp1,&dtemp2);
if(ci.adflag==ON)
{

if(age->model==1)
{

pos= getpos_s(c14dp,parms.n,c14dp[m]);
a= (c14dp[pos]-c14dp[m])/(c14dp[pos]-c14dp[pos-1]);
tempval= sqrte(a*a*c14sd[pos-1]*c14sd[pos-1]+
(1-a)*(1-a)*c14sd[pos]*c14sd[pos]);
}

else
{

tempval= sqrte((asumad2[m]-
(asumad[m]*asumad[m]/ci.nran))/(ci.nran-1));

}

}

ssdc14+= ((c14date[m]-dtemp1)*(c14date[m]-dtemp1));
sstc14+= ((c14date[m]-meanc14)*(c14date[m]-meanc14));

rtn= fprintf(agedep->fp,"%.2f %.2f %.2f: %.2f %.2f\n",
c14dp[m]+lev->min,c14date[m],c14sd[m],dtemp1,
ci.adflag==ON?tempval:0);
assert(rtn>0);

}

rtn= fprintf(agedep->fp,"SS (deviations) = %.2f\n",ssdc14);
assert(rtn>0);
rtn= fprintf(agedep->fp,"SS (total) = %.2f\n",sstc14);
assert(rtn>0);
rtn= fprintf(agedep->fp,"Goodness-of-fit (R-squared) = %.2f%%\n",
100.0*(1.0-(ssdc14/sstc14)));
assert(rtn>0);

rtn= fputc('\n',agedep->fp);
assert(rtn!=EOF);

rtn= fprintf(agedep->fp,
"(1) Depth  (2) Age  (3) Age sd  (4) SAR  (5) SAR sd\n"
"                        %s             %s\n",agesdflag,sarsdflag);
assert(rtn>0);
}

if(ci.adflag==ON)data->alevsd= avecreal(data->nsam);


for(j= 0;j<data->nsam;j++)
{

tempval= -1;
if(data->levfg[j]==OFF)continue;
x= (real)data->alev[j]-lev->min;


dtemp1= 0.0;
dtemp2= 0.0;
evalfunc[age->model](parms,x,&dtemp1,&dtemp2);

tempval= dtemp1;
sed->ar[j]= dtemp2;


if(sed->ar[j]<0)
{
if(sed->ar[j]>-0.0001)sed->ar[j]= 0;
else ier= ON;
}
if(ci.adflag==ON)
{

if(age->nterm!=2||(age->model!=3&&age->model!=4))
{
sed->arsd[j]= sqrte((asumar2[j]-
(asumar[j]*asumar[j]/ci.nran))/(ci.nran-1));
}




if(!ier&&gl.code.dat=='B')
{

a= sed->ar[j]*(ci.cvsed/(sqrte(data->conc.ex[7][j]*sed->ar[j]/5)));

sed->arsd[j]= pythag(sed->arsd[j],a);
}

}

if(gl.flag[AD]==ON)
{
rtn= fprintf(agedep->fp,"%8.2f",data->alev[j]);
assert(rtn>0);
}


if(age->flag==OFF&&age->timx==OFF&&gl.flag[AD]==ON)
{
rtn= fprintf(agedep->fp,"%8s %8s","-","-");
assert(rtn>0);
}


data->alevold[j]= data->alev[j];
if(tempval>=0)
{
data->alev[j]= (float)tempval;
}
else
{
dtemp2= 0.0;
evalfunc[age->model](parms,x,&dtemp1,&dtemp2);
data->alev[j]= (float)dtemp1;
tempval= dtemp2;
}

if(ci.adflag==ON)
{

if(age->model==1)
{

pos= getpos_s(c14dp,parms.n,x);
a= (c14dp[pos]-x)/(c14dp[pos]-c14dp[pos-1]);
data->alevsd[j]= sqrte(a*a*c14sd[pos-1]*c14sd[pos-1]+
(1-a)*(1-a)*c14sd[pos]*c14sd[pos]);
}

else
{

data->alevsd[j]= sqrte((asuma2[j]-
(asuma[j]*asuma[j]/ci.nran))/(ci.nran-1));
}

}

if(gl.flag[AD]==ON)
{
rtn= fprintf(agedep->fp," %8.0f %8.0f",data->alev[j],
ci.adflag==ON?data->alevsd[j]:0);
assert(rtn>0);
}

bmaxlev= MAX(bmaxlev,(real)data->alev[j]);
bminlev= MIN(bminlev,(real)data->alev[j]);

if(ci.adflag==ON)
{
bmaxsd= MAX(bmaxsd,(real)data->alev[j]+(real)data->alevsd[j]);
bminsd= MIN(bminsd,(real)data->alev[j]-(real)data->alevsd[j]);
}
else
{
bmaxsd= MAX(bmaxsd,(real)data->alev[j]);
bminsd= MIN(bminsd,(real)data->alev[j]);
}

if(gl.flag[AD]==ON)
{
rtn= fprintf(agedep->fp," %13.4f %8.4f\n",sed->ar[j],sed->arsd[j]);
assert(rtn>0);
}

}

if(ier)derror(3);


agerange->max= MAX(bmaxlev,bmaxsd);
agerange->min= MIN(bminlev,bminsd);

agerange->scale= (agerange->max-agerange->min)/100.0;

pscolour(adplot->fp,agerange->colxax);
xscale_s(*adplot,*agerange,head);


psc14plot_s(*adplot,*data,ci,parms,c14date,c14sd,c14dp1,c14dp2,
*agerange,*lev);


pstran2(adplot->fp,0,(gl.adpage.sep*2.0)+
(gl.adpage.minpl*ADFACT*(bmaxlev-bminlev)/agerange->scale));


if(age->flag==OFF)
{
for(j= 0;j<data->nsam;j++)
{
temp= data->alevold[j];
data->alevold[j]= data->alev[j];
data->alev[j]= temp;
}
}

rtn= fputs("Contents of struct Coll agerange (c):\n",gl.logf.fp);
assert(rtn!=EOF);
logcoll_x(*agerange);


if(age->flag==ON)
{
rtn= puts("Depths converted to ages");
assert(rtn!=EOF);
lev->max= bmaxlev;
lev->min= bminlev;
}

if(lev->udata==ON)
{
lev->max= lev->umax;
lev->origmin= lev->min;
lev->min= lev->umin;
}

getxaxis(&(*lev),age->adbc,&(*xsamp));

parms.range= lev->ex-lev->min;

/*:17*//*18:*/
#line 614 "ppage.w"

if(age->timx==ON)
{
real t= 0.0;
real t1= 0.0;
real t2= 0.0;
real t3= 0.0;
real tol= 0.0;
int its= 0;

dprint(&gl.logf,"Calculating timescale\n");



dtemp2= -1;
bmaxlev= lev->max-lev->min;
evalfunc[age->model](parms,bmaxlev,&dtemp1,&dtemp2);
timdep.max= dtemp1;
evalfunc[age->model](parms,0,&dtemp1,&dtemp2);
timdep.min= dtemp1;

getxaxis(&timdep,age->adbc,&(*xtime));
rtn= fputs("Contents of samp_t timdep (l):\n",gl.logf.fp);
assert(rtn!=EOF);
loglev(timdep);

tol= timdep.ex/1e5;



for(jj= 0;jj<xtime->ntick;jj++)
{
if(age->model==1)
{
pos= getpos_s(c14date,parms.n,xtime->val[jj]);
t1= xtime->val[jj]-c14date[pos-1];
t2= c14date[pos]-c14date[pos-1];
t3= t2/(c14dp[pos]-c14dp[pos-1]);
t= c14dp[pos-1]+(t1/t3);
}

else
{

t1= 0.0;
t2= lev->ex-lev->min;
t= t2/2.0;
dtemp2= -1;
for(its= 10000;its>0;its--)
{
evalfunc[age->model](parms,t,&dtemp1,&dtemp2);
if(btest_s(dtemp1,xtime->val[jj],tol,&t,&t1,&t2)!=0)
{
break;
}

}

if(its==0)derror(21);

}

rtn= printf("%d ",jj);
assert(rtn>0);
xtime->val[jj]= t+lev->min;

}

rtn= putchar('\n');
assert(rtn!=EOF);

}

/*:18*//*19:*/
#line 688 "ppage.w"

psclose2(*adplot,1);
closef(&(*adplot),__FILE__,__LINE__);

fmatreal(zcovar,parms.n);
fvec(asumad);
fvec(asumad2);
fvec(asummem);
fvec(za);
fvec(c14mem);

return;
}

/*:19*//*21:*/
#line 707 "ppage.w"

static void bernshtein_s
(
eval_t parms,
real x,
real*y,
real*dy
)

{
/*:21*//*22:*/
#line 718 "ppage.w"

real dval= 0.0;
real dval1= 0.0;
real dval2= 0.0;
real t= 0.0;
real firstt1= 0.0;
real t1= 0.0;
real firstt2= 0.0;
real t2= 0.0;
real tol= 0.0;
real xlim= 0.0;
real yval[3];
real zx= 0.0;

int its= 0;
int n= 0;

loop_t i= 0;
loop_t k= 0;

/*:22*//*23:*/
#line 739 "ppage.w"

real*realmem= NULL;
real*ageco= NULL;
real*depco= NULL;
real*powt= NULL;
real*powmt= NULL;

n= parms.n;

/*:23*//*24:*/
#line 749 "ppage.w"

realmem= avecreal(4*(n+1));
depco= realmem;
ageco= depco+n+1;
powt= ageco+n+1;
powmt= powt+n+1;

xlim= 1e-4*parms.x[n-1];
zx= x-xlim;
if(zx<0.0)zx= 0;

/*:24*//*25:*/
#line 762 "ppage.w"

for(i= 0;i<3;i++,zx+= xlim)
{
if(*dy<0&&i!=1)continue;

t1= firstt1= -xlim;
t2= firstt2= xlim+(parms.range/parms.x[n-1]);
t= t2/2.0;



tol= MAX(fabs(1e-7*zx),1e-7);

powt[0]= 1.0;
powmt[0]= 1.0;

for(k= 1;k<=n;k++)
{
dval= bico_s(n-1,k-1);
depco[k]= dval*parms.x[k-1];
ageco[k]= dval*parms.y[k-1];
}


for(its= 10000;its>0;its--)
{
dval1= 0.0;
powt[1]= t1;
powmt[1]= 1.0-t1;
for(k= 2;k<=n;k++)
{
powt[k]= powt[k-1]*powt[1];
powmt[k]= powmt[k-1]*powmt[1];
}

for(k= 1;k<=n;k++)
{

dval1+= (depco[k]*powmt[n-k]*powt[k-1]);
}

dval2= 0.0;
powt[1]= t2;
powmt[1]= 1.0-t2;
for(k= 2;k<=n;k++)
{
powt[k]= powt[k-1]*powt[1];
powmt[k]= powmt[k-1]*powmt[1];
}

for(k= 1;k<=n;k++)
{

dval2+= (depco[k]*powmt[n-k]*powt[k-1]);
}

dval= 0.0;
powt[1]= t;
powmt[1]= 1.0-t;
for(k= 2;k<=n;k++)
{
powt[k]= powt[k-1]*powt[1];
powmt[k]= powmt[k-1]*powmt[1];
}

for(k= 1;k<=n;k++)
{

dval+= (depco[k]*powmt[n-k]*powt[k-1]);
}


if(btest_s(dval,zx,tol,&t,&t1,&t2)!=0)break;

}



if(its==0)derror(12);




yval[i]= 0.0;

for(k= 1;k<=n;k++)
{
yval[i]+= (ageco[k]*powmt[n-k]*powt[k-1]);
}

}

/*:25*//*26:*/
#line 855 "ppage.w"

*y= yval[1];
if(*dy>=0)*dy= (yval[2]-yval[0])/(2*xlim);
fvec(realmem);

return;
}


/*:26*//*28:*/
#line 875 "ppage.w"

static real bico_s
(
int n,
int k
)

{
static const real factln[31]= 
{
0.000000000000000,0.000000000000000,0.693147180559945,
1.791759469228055,3.178053830347946,4.787491742782046,
6.579251212010101,8.525161361065415,10.604602902745251,
12.801827480081471,15.104412573075516,17.502307845873887,
19.987214495661888,22.552163853123425,25.191221182738683,
27.899271383840894,30.671860106080675,33.505073450136891,
36.395445208033053,39.339884187199495,42.335616460753485,
45.380138898476908,48.471181351835220,51.606675567764370,
54.784729398112319,58.003605222980518,61.261701761002001,
64.557538627006323,67.889743137181526,71.257038967168000,
74.658236348830158
};

real x= 0.0;

x= floor(0.5+expe(factln[n]-factln[k]-factln[n-k]));

return(x);
}

/*:28*//*30:*/
#line 911 "ppage.w"

static int getpos_s
(
real*in,
int l,
real x
)

{
int n= 0;
loop_t m= 0;

for(m= 1;m<l;m++)
{
if(x<=in[m])break;
}

n= MIN(m,l-1);

return(n);
}

/*:30*//*32:*/
#line 938 "ppage.w"

static void linint_s
(
eval_t parms,
real x,
real*y,
real*dy
)

{
int pos= 0;

pos= getpos_s(parms.x,parms.n,x);
if(parms.x[pos]-parms.x[pos-1]<=FLT_MIN)derror(22);
*dy= (parms.y[pos]-parms.y[pos-1])/(parms.x[pos]-parms.x[pos-1]);
*y= parms.y[pos-1]+((x-parms.x[pos-1])**dy);

return;
}

/*:32*//*34:*/
#line 973 "ppage.w"

static void spline_s
(
real*x,
real*y,
int n,
real*y2
)

{
real asig= 0;
real dum1= 0;
real dum2= 0;
real p= 0;
real qn= 0;
real un= 0;

loop_t i= 0;
loop_t k= 0;


real*u= NULL;

u= avecreal(n);

y2[0]= -0.5;
if(x[1]-x[0]<FLT_MIN&&x[1]-x[0]>-FLT_MIN)derror(23);
u[0]= (3.0/(x[1]-x[0]))*((y[1]-y[0])/(x[1]-x[0]));

for(i= 1;i<(n-1);i++)
{
if(x[i]-x[i-1]<FLT_MIN&&x[i]-x[i-1]>-FLT_MIN)derror(23);
asig= (x[i]-x[i-1])/(x[i+1]-x[i-1]);
p= asig*y2[i-1]+2.0;
y2[i]= (asig-1)/p;
dum1= (y[i+1]-y[i])/(x[i+1]-x[i]);
dum2= (y[i]-y[i-1])/(x[i]-x[i-1]);
u[i]= (6.0*(dum1-dum2)/(x[i+1]-x[i-1])-asig*u[i-1])/p;
}

qn= 0.5;
un= (3.0/(x[n-1]-x[n-2]))*(-(y[n-1]-y[n-2])/
(x[n-1]-x[n-2]));

y2[n-1]= (un-qn*u[n-2])/(qn*y2[n-2]+1);

for(k= n-2;k>=0;k--)y2[k]= y2[k]*y2[k+1]+u[k];

fvec(u);

return;
}

/*:34*//*36:*/
#line 1045 "ppage.w"

static void splint_s
(
eval_t parms,
real x,
real*y,
real*dy
)


{
real a= 0;
real b= 0;
real h= 0;

int pos= 0;

pos= getpos_s(parms.x,parms.n,x);

h= parms.x[pos]-parms.x[pos-1];
if(h<FLT_MIN&&h>-FLT_MIN)derror(9);

a= (parms.x[pos]-x)/h;
b= (x-parms.x[pos-1])/h;

*y= a*parms.y[pos-1]+b*parms.y[pos]+(((a*a*a-a)*
parms.y2a[pos-1]+(b*b*b-b)*parms.y2a[pos])*h*h/6);

if(*dy>=0)
{
*dy= (parms.y[pos]-parms.y[pos-1])/h-(3*a*a-1)*h*
parms.y2a[pos-1]/6+(3*b*b-1)*h*parms.y2a[pos]/6;
}

return;
}

/*:36*//*38:*/
#line 1088 "ppage.w"

static int test_s
(
real val,
real target,
real tol,
real*x,
real*x1,
real*x2
)

{
if(val<target+tol&&val>target-tol)return(-1);

if(val<target)
{
*x1+= ((*x-*x1)*0.01);
*x= (*x1+*x2)/2.0;
}
else
{
*x2-= ((*x2-*x)*0.01);
*x= (*x1+*x2)/2.0;
}

return(0);
}


/*:38*//*40:*/
#line 1123 "ppage.w"

static void addepax_s
(
file_t outfile,
const caption_t head,
const samp_t lev,
const xaxis_t xaxis
)

{
real leng= 0;
real leng2= 0;
real qyy= 0;
real val= 0;

loop_t j= 0;
loop_t m= 0;

buffer_f[0]= '\0';

rtn= sprintf(buffer_f,"n %s","LSSc");
assert(rtn>0&&rtn<10);

PSCOMM2(outfile.fp,buffer_f);


leng= MAX(gl.adpage.yscbeg,xaxis.leng);
pstran2(outfile.fp,0.0F,leng);
qyy= gl.adpage.sep;
m= 7;

pslineto2(outfile.fp,0,DIAGOFF,0,gl.adpage.prop,0);


for(j= 0;j<xaxis.ntick;j++)
{

val= DIAGOFF+((xaxis.val[j]-lev.min)/(lev.ex-lev.min))*
gl.adpage.prop;

assert(xaxis.annot[j]!=NULL);
if(pstrlen(xaxis.annot[j])==0)
{

pslineto2(outfile.fp,0,val,0,0,qyy/2);
}
else
{

PSOPER2(outfile.fp,3);
pstext(outfile.fp,m,val+(gl.adpage.lineht/2),
-qyy,xaxis.annot[j],"F1",ANG);
pslineto2(outfile.fp,0,val,0,0,qyy);
}

}

PSOPER2(outfile.fp,3);


leng2= strwid(head.adyaxis)*BIGFONT;
pstext(outfile.fp,6,DIAGOFF+((gl.adpage.prop/2.0)+(leng2/2.0)),
-leng*BIGFONT,head.adyaxis,"F1",ANG+90);

pstran2(outfile.fp,0,2*gl.adpage.sep);

return;
}


/*:40*//*42:*/
#line 1198 "ppage.w"

static void xscale_s
(
file_t outfile,
frame_t ind,
const caption_t head
)

{
static char text[LENSTR2]= "";

real scalepos= 0;
real scaleval= 0;
real adminpl= 0;
real allj= 0;
real fdummy1= 0;
real fdummy2= 0;
real leng= 0;

int imin= 0;
int markint= 0;

PSCOMM2(outfile.fp,"n ADP");

adminpl= gl.adpage.minpl*ADFACT;

allj= ind.max-ind.min;

buffer_f[0]= '\0';

if(adminpl>1.6e-3)markint= 10;
else if(adminpl>8e-4)markint= 20;
else markint= 40;



fdummy1= DIAGOFF+gl.adpage.prop+LINEOFF;
scalepos= adminpl*allj/ind.scale;
pslineto2(outfile.fp,1,fdummy1,adminpl/ind.scale,0,scalepos);


imin= (int)(ind.min/1000.0)*1000.0;
while((real)imin/100.0<=ind.max/100.0)
{
if((real)imin/100.0>=ind.min/100.0)
{
scaleval= ((real)imin-ind.min)*adminpl/ind.scale;


rtn= sprintf(text,"%.1f",(real)imin);
assert(rtn>0&&rtn<LENSTR2);
if(strstr(text,".0")!=NULL)text[pstrlen(text)-2]= '\0';



leng= strwid(text)*BIGFONT;
fdummy1= DIAGOFF+gl.adpage.prop+(BIGFONT*ANNOOFF);
pstext(outfile.fp,6,fdummy1,scalepos-(scaleval+(leng/2)),
text,"F1",ANG);


fdummy1= DIAGOFF+gl.adpage.prop+LINEOFF;
pslineto2(outfile.fp,0,fdummy1,scalepos-scaleval,-MARKLEN,0);

}

if(((real)imin+(real)markint/2)<=ind.max/100.0&&
((real)imin+(real)markint/2)>=ind.min/100.0)
{

fdummy1= DIAGOFF+gl.adpage.prop+LINEOFF;
fdummy2= scalepos
-(scaleval+((adminpl*markint/2)*100.0/ind.scale));
pslineto2(outfile.fp,0,fdummy1,fdummy2,-MARKLEN/2,0);
}
PSOPER2(outfile.fp,3);

imin+= (markint*100.0);

}


leng= strwid(head.adxaxis)*BIGFONT;
pstext(outfile.fp,6,DIAGOFF+gl.adpage.prop+ANNOOFF+FOOTOFF,
((adminpl*allj)/(ind.scale*2.0))-(leng/2),head.adxaxis,
"F1",ANG);

return;
}


/*:42*//*44:*/
#line 1296 "ppage.w"

static void psc14plot_s
(
file_t outfile,
data_t data,
ci_t ci,
eval_t parms,
real*c14date,
real*c14sd,
real*c14dp1,
real*c14dp2,
const frame_t ind,
const samp_t lev
)

{
real adminpl= 0;
real allj= 0;
real xlo= 0;
real xhi= 0;
real x1= 0;
real x2= 0;
real ylo= 0;
real yhi= 0;
real y1= 0;
real y2= 0;

loop_t j= 0;
loop_t m= 0;

buffer_f[0]= '\0';

adminpl= gl.adpage.minpl*ADFACT;
allj= ind.max-ind.min;


for(m= 0;m<parms.n;m++)
{
pscolour(outfile.fp,ind.col14c);
xhi= xlo= -1;


if(MAX(c14dp1[m],c14dp2[m])>=0&&
MIN(c14dp1[m],c14dp2[m])<=(lev.ex-lev.min))
{


x1= x2= DIAGOFF;
x1+= (c14dp1[m]/(lev.ex-lev.min))*gl.adpage.prop;
x2+= (c14dp2[m]/(lev.ex-lev.min))*gl.adpage.prop;
xlo= MIN(x1,x2);
xhi= MAX(x1,x2);

ylo= adminpl*(((allj+ind.min)-
(c14date[m]-c14sd[m]))/ind.scale);
yhi= adminpl*(((allj+ind.min)-
(c14date[m]+c14sd[m]))/ind.scale);

}


if(xhi>0&&xlo>0)pscross(outfile.fp,xhi,xlo,ylo,yhi);

}


for(j= 1;j<data.nsam;j++)
{
if(data.levfg[j]==ON)
{
x1= DIAGOFF+(((data.alevold[j-1]-lev.min)/(lev.ex-lev.min))*gl.adpage.prop);
x2= DIAGOFF+(((data.alevold[j]-lev.min)/(lev.ex-lev.min))*gl.adpage.prop);
y1= adminpl*(((allj+ind.min)-data.alev[j-1])/ind.scale);
y2= adminpl*(((allj+ind.min)-data.alev[j])/ind.scale);
pscolour(outfile.fp,ind.colpl);
pslineto2(outfile.fp,1,x1,y1,x2-x1,y2-y1);
if(ci.adflag==ON)
{
y1= adminpl*(((allj+ind.min)-(data.alev[j-1]+data.alevsd[j-1]))/
ind.scale);
y2= adminpl*(((allj+ind.min)-(data.alev[j]+data.alevsd[j]))/ind.scale);
pscolour(outfile.fp,ind.colsdpl);
pslineto2(outfile.fp,1,x1,y1,x2-x1,y2-y1);
y1= adminpl*(((allj+ind.min)-(data.alev[j-1]-data.alevsd[j-1]))/
ind.scale);
y2= adminpl*(((allj+ind.min)-(data.alev[j]-data.alevsd[j]))/ind.scale);
pslineto2(outfile.fp,1,x1,y1,x2-x1,y2-y1);

}

}

}

return;
}


/*:44*//*46:*/
#line 1400 "ppage.w"

static int btest_s
(
real val,
real target,
real tol,
real*x,
real*x1,
real*x2
)

{
if(fabse(fabse(*x1)-fabse(*x2))<tol)return(-1);

if(val<target)
{
*x1+= ((*x-*x1)*0.01);
*x= (*x1+*x2)/2.0;
}
else
{
*x2-= ((*x2-*x)*0.01);
*x= (*x1+*x2)/2.0;
}

return(0);
}

/*:46*/
