/*3:*/
#line 15 "ppfit.w"

#include "psimpoll.h" 
#include "ppglobal.h" 

/*:3*//*4:*/
#line 20 "ppfit.w"

/*17:*/
#line 577 "ppfit.w"

static void svdfit_s(real*x,real*y,real*asig,int ndata,real*za,
real**zcovar,int ma,int mp,real*chisq,
void(*funcs)(real,real*,int));
/*:17*/
#line 21 "ppfit.w"


/*:4*//*6:*/
#line 32 "ppfit.w"

real gammln
(
real a
)

{
real zer= 1.000000000190015;
real zmp= 0;
const real ztp= 2.5066282746310005;
real zx= 0.0;
real zy= 0.0;

static const real zcof[6]= 
{
76.18009172947146,-86.50532032941677,
24.01409824083091,-1.231739572450155,
0.1208650973866179e-2,-0.5395239384953e-5
};

loop_t i= 0;

zy= zx= (real)a;
zmp= zx+5.5;
zmp-= (zx+0.5)*loge(zmp);
for(i= 0;i<6;i++)zer+= zcof[i]/++zy;
zy= -zmp+loge(ztp*zer/zx);

return((real)zy);
}

/*:6*//*8:*/
#line 76 "ppfit.w"

real gammq
(
real a,
real x
)

{
real b= 0.0;
real an= 0.0;
real ap= 0.0;
real asum= 0.0;
real c= 0.0;
real d= 0.0;
real del= 0.0;
real eps= 3.0e-7;
real fpmin= 1.0e-30;
real h= 0.0;
real gam= 0.0;
real gln= 0.0;

int itmax= 100;
loop_t n= 0;

gln= gammln(a);

if(x<(a+1.0))
{




if(x<=0)return(0.0);
ap= a;
del= asum= 1.0/a;
for(n= 0;n<itmax;n++)
{
++ap;
del*= x/ap;
asum+= del;
if(fabs(del)<fabs(asum)*eps)break;
}

gam= 1.0-(asum*expe(-x+a*loge(x)-gln));

}



else
{





b= x+1.0-a;
c= 1.0/fpmin;
h= d= 1.0/b;
for(n= 1;n<=itmax;n++)
{
an= -(real)n*((real)n-a);;
b+= 2.0;
d= an*d+b;
if(fabs(d)<fpmin)d= fpmin;
c= b+an/c;
if(fabs(c)<fpmin)c= fpmin;
d= 1.0/d;
del= d*c;
h*= del;
if(fabs(del-1.0)<eps)break;
}
if(itmax<=n)gam= 0;
else gam= expe(-x+a*loge(x)-gln)*h;


}

return(gam);
}

/*:8*//*10:*/
#line 163 "ppfit.w"

real**genfit
(
file_t*agedep,
age_t*age,
real*za,
real*c14dp,
real*c14date,
real*c14sd,
int noc14,
int nran
)

{
real chisq= 0;
real q= 0;

flag_t lf= OFF;

int ma= 0;
int mfit= 0;
int mp= 0;

loop_t m= 0;


int*lista= NULL;
real**zcovar= NULL;

if(age->nterm!=0)lf= OFF;
else
{
age->nterm= 2;
lf= ON;
}

if(age->nterm>=noc14)
{
age->nterm= noc14-1;
rtn= printf("Too many terms requested: corrected to %d\n",age->nterm);
assert(rtn>0);
}

if(nran==0)
{
rtn= puts("Terms     Chi-squared      Goodness-of-fit");
assert(rtn!=EOF);
}

zcovar= amatreal(noc14,noc14);


for(;;)
{
mfit= ma= age->nterm;
mp= MAX(noc14,age->nterm);

if(age->model==4)
{
svdfit_s(c14dp,c14date,c14sd,noc14,za,zcovar,ma,mp,&chisq,
dpoly);
}

else if(age->model==3)
{
lista= avecint(ma);
setintarray(lista,ma,1);
lfit(c14dp,c14date,c14sd,noc14,za,zcovar,ma,lista,mfit,&chisq,
nran,dpoly);
fvec(lista);
}

if(nran==0)
{
q= gammq(0.5*((real)noc14-mfit),0.5*chisq);
rtn= printf("%2d%15.1f%20.2e\n",age->nterm,chisq,q);
assert(rtn>0);
}

if(!lf)break;
else
{
(age->nterm)++;
if(age->nterm==noc14)
{
rtn= puts("Select number of terms <Enter>");
assert(rtn!=EOF);
age->nterm= (int)(getsing(2,noc14));
lf= OFF;
}

}

}

if(nran==0&&gl.flag[AD])
{
rtn= fprintf(agedep->fp,"No. of terms = %d  Chi-squared = %f"
"  goodness-of-fit = %e\nCoefficients = ",age->nterm,chisq,q);
assert(rtn>0);
for(m= 0;m<age->nterm;m++)
{
rtn= fprintf(agedep->fp,"%e ",za[m]);
assert(rtn>0);
}
rtn= fputc('\n',agedep->fp);
assert(rtn!=EOF);

}

return(zcovar);
}

/*:10*//*12:*/
#line 287 "ppfit.w"

void dpoly
(
real x,
real*zfunc,
int ma
)

{
loop_t i= 0;

zfunc[0]= 1.0;
zfunc[1]= x;

for(i= 2;i<ma;i++)zfunc[i]= x*zfunc[i-1];

return;
}

/*:12*//*14:*/
#line 320 "ppfit.w"

void lfit
(
real*x,
real*y,
real*asig,
int ndata,
real*za,
real**zcovar,
int ma,
int*lista,
int mfit,
real*chisq,
int nran,
void(*funcs)(real,real*,int)
)
{
real asum= 0.0;
real zsig2= 0.0;
real zwt= 0.0;
real zy= 0.0;
real zbg= 0.0;
real zdum= 0.0;
real zpivinv= 0.0;
real ztemp= 0.0;

int irow= 0;
int icol= 0;

loop_t i= 0;
loop_t j= 0;
loop_t k= 0;
loop_t l= 0;
loop_t ll= 0;


real*realmem= NULL;
real*zeta= NULL;
real*zfunc= NULL;

int*intmem= NULL;
int*ipiv= NULL;
int*indxc= NULL;
int*indxr= NULL;

intmem= avecint(mfit+mfit+mfit);
ipiv= intmem;
indxc= intmem+mfit;
indxr= indxc+mfit;

realmem= avecreal(ma+ma);
zeta= realmem;
zfunc= realmem+ma;

for(j= 0;j<ma;j++)
{
setrealarray(zcovar[j],mfit,0.0);
zeta[j]= 0.0;
}

for(i= 0;i<ndata;i++)
{
(*funcs)(x[i],zfunc,ma);
zy= y[i];
if(mfit<ma)
{
for(j= 0;j<ma;j++)
{
if(!lista[j])zy-= za[j]*zfunc[j];
}

}

if(asig[i]<=0)derror(7);
zsig2= 1.0/(SQUARE(asig[i]));
for(j= 0;j<ma;j++)
{
if(lista[j])
{
zwt= zfunc[j]*zsig2;
for(k= 0;k<=j;k++)zcovar[j][k]+= zwt*zfunc[k];
zeta[j]+= zy*zwt;
}

}

}

if(mfit>0)
{
for(j= 1;j<mfit;j++)
{
for(k= 0;k<j;k++)zcovar[k][j]= zcovar[j][k];
}

}



setintarray(ipiv,mfit,0);

for(i= 0;i<mfit;i++)
{
zbg= 0;
for(j= 0;j<mfit;j++)
{
if(ipiv[j]!=1)
{
for(k= 0;k<mfit;k++)
{
if(ipiv[k]>1)derror(8);
else if(ipiv[k]==0)
{
if(fabs(zcovar[j][k])>=zbg)
{
zbg= fabs(zcovar[j][k]);
irow= j;
icol= k;
}

}

}

}

}

ipiv[icol]++;
if(irow!=icol)
{
for(l= 0;l<mfit;l++)
{
ztemp= zcovar[irow][l];
zcovar[irow][l]= zcovar[icol][l];
zcovar[icol][l]= ztemp;
}
ztemp= zeta[irow];
zeta[irow]= zeta[icol];
zeta[icol]= ztemp;
}

indxr[i]= irow;
indxc[i]= icol;
if(fabs(zcovar[icol][icol])<DBL_MIN)derror(8);
zpivinv= 1.0/zcovar[icol][icol];
zcovar[icol][icol]= 1.0;
for(l= 0;l<mfit;l++)zcovar[icol][l]*= zpivinv;
zeta[icol]*= zpivinv;
for(ll= 0;ll<mfit;ll++)
{
if(ll!=icol)
{
zdum= zcovar[ll][icol];
zcovar[ll][icol]= 0.0;
for(l= 0;l<mfit;l++)zcovar[ll][l]-= (zcovar[icol][l]*zdum);
zeta[ll]-= (zeta[icol]*zdum);
}

}

}

for(l= mfit-1;l>=0;l--)
{
if(indxr[l]!=indxc[l])
{
for(k= 0;k<mfit;k++)
{
ztemp= zcovar[k][indxr[l]];
zcovar[k][indxr[l]]= zcovar[k][indxc[l]];
zcovar[k][indxc[l]]= ztemp;
}

}

}



for(j= 0;j<mfit;j++)
{
if(lista[j])za[j]= zeta[j];
}

if(nran==0)
{
*chisq= 0;
for(i= 0;i<ndata;i++)
{
(*funcs)(x[i],zfunc,ma);
asum= 0;
for(j= 0;j<ma;j++)asum+= (za[j]*zfunc[j]);
*chisq+= SQUARE((y[i]-asum)/asig[i]);
}

}

fvec(realmem);
fvec(intmem);

return;
}

/*:14*//*16:*/
#line 537 "ppfit.w"

real pythag
(
real a,
real b
)

{
real absa= 0;
real absb= 0;

absa= fabse(a);
absb= fabse(b);

if(absa>absb)return(absa*sqrte(1.0+SQUARE(absb/absa)));
else return(absb==0.0?0.0:absb*sqrte(1.0+SQUARE(absa/absb)));
}

/*:16*//*18:*/
#line 582 "ppfit.w"

static void svdfit_s
(
real*x,
real*y,
real*asig,
int ndata,
real*za,
real**zcovar,
int ma,
int mp,
real*chisq,
void(*funcs)(real,real*,int)
)

{
real asum= 0.0;
real chisqmin= 0.0;
real temp= 0.0;
real z= 0.0;
real zc= 0.0;
real zchisq= 0.0;
real zf= 0.0;
real zg= 0.0;
real zh= 0.0;
real znorm= 0.0;
real zs= 0.0;
real zscal= 0.0;
real zsum= 0.0;
real ztp= 0.0;
real zx= 0.0;
real zy= 0.0;

flag_t flag= OFF;
flag_t nf= OFF;

int now= 0;
int nm= 0;

loop_t i= 0;
loop_t j= 0;
loop_t jj= 0;
loop_t k= 0;
loop_t kk= 0;
loop_t l= 0;
loop_t its= 0;


real*realmem= NULL;
real*zb= NULL;
real*zfunc= NULL;
real*zwti= NULL;
real*zww= NULL;
real*zr1= NULL;
real*ztemp= NULL;
real*zw= NULL;

real**zu= NULL;
real**zv= NULL;

real*wsng= NULL;

int*indxw= NULL;

wsng= avecreal(ma);
indxw= avecint(ma);
realmem= avecreal(ndata+ma+ma+ma+ma+ma+ma);
zb= realmem;
zfunc= zb+ndata;
zww= zfunc+ma;
zr1= zww+ma;
ztemp= zr1+ma;
zw= ztemp+ma;
zwti= zw+ma;

zu= amatreal(mp,ma);
zv= amatreal(ma,ma);

for(i= 0;i<ndata;i++)
{
(*funcs)(x[i],zfunc,ma);
if(asig[i]<=0)derror(7);
ztp= 1.0/asig[i];
for(j= 0;j<ma;j++)zu[i][j]= zfunc[j]*ztp;
zb[i]= y[i]*ztp;
}










if(mp<ma)derror(10);

for(i= 0;i<ma;i++)
{
l= i+1;
zr1[i]= zscal*zg;
zg= zs= zscal= 0.0;
if(i<mp)
{
for(k= i;k<mp;k++)zscal+= fabs(zu[k][i]);
if(zscal)
{
for(k= i;k<mp;k++)
{
zu[k][i]/= zscal;
zs+= SQUARE(zu[k][i]);
}
zf= zu[i][i];
zg= -SIGN(sqrte(zs),zf);
zh= zf*zg-zs;
zu[i][i]= zf-zg;
for(j= l;j<ma;j++)
{
zs= 0;
for(k= i;k<mp;k++)zs+= (zu[k][i]*zu[k][j]);
zf= zs/zh;
for(k= i;k<mp;k++)zu[k][j]+= (zf*zu[k][i]);
}

for(k= i;k<mp;k++)zu[k][i]*= zscal;

}

}

zw[i]= zscal*zg;
zg= zs= zscal= 0.0;
if(i<=(mp-1)&&i!=(ma-1))
{
for(k= l;k<ma;k++)zscal+= fabs(zu[i][k]);
if(zscal)
{
for(k= l;k<ma;k++)
{
zu[i][k]/= zscal;
zs+= (SQUARE(zu[i][k]));
}
zf= zu[i][l];
zg= -SIGN(sqrte(zs),zf);
zh= zf*zg-zs;
zu[i][l]= zf-zg;
for(k= l;k<ma;k++)zr1[k]= zu[i][k]/zh;
for(j= l;j<mp;j++)
{
zs= 0;
for(k= l;k<ma;k++)zs+= (zu[j][k]*zu[i][k]);
for(k= l;k<ma;k++)zu[j][k]+= (zs*zr1[k]);
}

for(k= l;k<ma;k++)zu[i][k]*= zscal;

}

}

znorm= MAX(znorm,(fabs(zw[i])+fabs(zr1[i])));

}

for(i= (ma-1);i>=0;i--)
{
if(i<(ma-1))
{
if(zg)
{
for(j= l;j<ma;j++)zv[j][i]= (zu[i][j]/zu[i][l])/zg;
for(j= l;j<ma;j++)
{
zs= 0;
for(k= l;k<ma;k++)zs+= (zu[i][k]*zv[k][j]);
for(k= l;k<ma;k++)zv[k][j]+= (zs*zv[k][i]);
}

}

for(j= l;j<ma;j++)zv[i][j]= zv[j][i]= 0.0;

}

zv[i][i]= 1.0;
zg= zr1[i];
l= i;

}

for(i= ma-1;i>=0;i--)
{
l= i+1;
zg= zw[i];
for(j= l;j<ma;j++)zu[i][j]= 0.0;
if(!zg)for(j= i;j<mp;j++)zu[j][i]= 0.0;
else
{
zg= 1.0/zg;
for(j= l;j<ma;j++)
{
zs= 0;
for(k= l;k<mp;k++)zs+= (zu[k][i]*zu[k][j]);
zf= (zs/zu[i][i])*zg;
for(k= i;k<mp;k++)zu[k][j]+= (zf*zu[k][i]);
}
for(j= i;j<mp;j++)zu[j][i]*= zg;

}

zu[i][i]+= 1.0;

}

for(k= (ma-1);k>=0;k--)
{
for(its= 0;its<30;its++)
{
flag= ON;
for(l= k;l>=0;l--)
{
nm= l-1;
if(fabs(zr1[l])+znorm==znorm)
{
flag= OFF;
break;
}
if(fabs(zw[nm])+znorm==znorm)break;

}

if(flag)
{
zc= 0.0;
zs= 1.0;
for(i= l;i<=k;i++)
{
zf= zs*zr1[i];
zr1[i]= zc*zr1[i];
if(fabs(zf)+znorm==znorm)break;
zg= zw[i];
zh= pythag(zf,zg);
zw[i]= zh;
zh= 1.0/zh;
zc= zg*zh;
zs= -zf*zh;
for(j= 0;j<mp;j++)
{
zy= zu[j][nm];
z= zu[j][i];
zu[j][nm]= zy*zc+z*zs;
zu[j][i]= z*zc-zy*zs;
}

}

}

z= zw[k];
if(l==k)
{
if(z<0.0)
{
zw[k]= -z;
for(j= 0;j<ma;j++)zv[j][k]= -zv[j][k];
}
break;

}
if(its==29)derror(10);
zx= zw[l];
nm= k-1;
zy= zw[nm];
zg= zr1[nm];
zh= zr1[k];
zf= ((zy-z)*(zy+z)+(zg-zh)*(zg+zh))/(2.0*zh*zy);
zg= pythag(zf,1.0);
zf= ((zx-z)*(zx+z)+zh*((zy/(zf+SIGN(zg,zf)))-zh))/zx;
zc= zs= 1.0;
for(j= l;j<=nm;j++)
{
i= j+1;
zg= zr1[i];
zy= zw[i];
zh= zs*zg;
zg= zc*zg;
z= pythag(zf,zh);
zr1[j]= z;
zc= zf/z;
zs= zh/z;
zf= zx*zc+zg*zs;
zg= zg*zc-zx*zs;
zh= zy*zs;
zy*= zc;
for(jj= 0;jj<ma;jj++)
{
zx= zv[jj][j];
z= zv[jj][i];
zv[jj][j]= zx*zc+z*zs;
zv[jj][i]= z*zc-zx*zs;
}
z= pythag(zf,zh);
zw[j]= z;
if(z)
{
z= 1.0/z;
zc= zf*z;
zs= zh*z;
}
zf= zc*zg+zs*zy;
zx= zc*zy-zs*zg;
for(jj= 0;jj<mp;jj++)
{
zy= zu[jj][j];
z= zu[jj][i];
zu[jj][j]= zy*zc+z*zs;
zu[jj][i]= z*zc-zy*zs;
}

}

zr1[l]= 0.0;
zr1[k]= zf;
zw[k]= zx;

}

}



for(k= 0;k<ma;k++)wsng[k]= zw[k];

indexx(ma,wsng,indxw);
chisqmin= 1e+10;
nf= ON;

cpyrealarray(zww,zw,ma);

k= 0;

for(;;)
{









for(j= 0;j<ma;j++)
{
zs= 0.0;
if(zww[j])
{
for(i= 0;i<ndata;i++)zs+= (zu[i][j]*zb[i]);
zs/= zww[j];
}

ztemp[j]= zs;

}

for(j= 0;j<ma;j++)
{
zs= 0.0;
for(kk= 0;kk<ma;kk++)zs+= (zv[j][kk]*ztemp[kk]);
za[j]= zs;
}


zchisq= 0;
for(i= 0;i<ndata;i++)
{
(*funcs)(x[i],zfunc,ma);
asum= 0;
for(j= 0;j<ma;j++)asum+= (za[j]*zfunc[j]);
temp= (y[i]-asum)/asig[i];
zchisq+= (temp*temp);
}
if(!nf)break;
else
{
if(chisqmin>zchisq)
{
chisqmin= zchisq;
now= k;
}
if(++k!=ma)zww[indxw[k]]= 0;
else
{
nf= OFF;
for(kk= 0;kk<now;kk++)zw[indxw[kk]]= 0;
cpyrealarray(zww,zw,ma);
}

}

}

*chisq= zchisq;



for(i= 0;i<ma;i++)
{
zwti[i]= 0.0;
if(zw[i])zwti[i]= 1.0/(SQUARE(zw[i]));
}

for(i= 0;i<ma;i++)
{
for(j= 0;j<=i;j++)
{

real zdummy= 0.0;
for(zsum= 0.0,k= 0;k<ma;k++)
{
zdummy= zv[i][k]*zv[j][k];
zdummy*= zwti[k];
zsum+= zdummy;
}
zcovar[j][i]= zcovar[i][j]= zsum;

}

}

fmatreal(zv,ma);
fmatreal(zu,mp);

fvec(realmem);

fvec(indxw);
fvec(wsng);

return;
}


/*:18*//*20:*/
#line 1039 "ppfit.w"

void fit
(
float*x,
float*y,
int ndata,
real*a,
real*b
)

{
loop_t i= 0;

real ss= 0;
real st2= 0;
real sx= 0;
real sxoss= 0;
real sy= 0;
real t= 0;

*b= 0.0;

for(i= 0;i<ndata;i++)
{
sx+= x[i];
sy+= y[i];
}

ss= (real)ndata;

sxoss= sx/ss;

for(i= 0;i<ndata;i++)
{
t= x[i]-sxoss;
st2+= (t*t);
*b+= (t*y[i]);
}

*b/= st2;
*a= (sy-sx*(*b))/ss;

}

/*:20*/
