#define SUMARRAY(var_t)  \
var_t sum##var_t##array \
( \
var_t*array, \
int n \
)  \
 \
{ \
 \
var_t x= 0; \
 \
while(n>0) x+= array[--n]; \
 \
return(x) ; \
 \
} \

#define SETARRAY(var_t)  \
void set##var_t##array \
( \
var_t*array, \
int n, \
var_t x \
)  \
 \
{ \
 \
while(n>0) array[--n]= x; \
 \
return; \
 \
} \

#define CPYARRAY(var_t)  \
void cpy##var_t##array \
( \
var_t*dest, \
const var_t*src, \
int n \
)  \
 \
{ \
 \
while(--n>=0) dest[n]= src[n]; \
 \
return; \
 \
} \

#define PRNARRAY(var_t)  \
void prn##var_t##array \
( \
FILE*fp, \
const char*fmt, \
const var_t*array, \
const int n \
)  \
 \
{ \
 \
loop_t i= 0; \
for(;i<n;i++)  \
{ \
rtn= fprintf(fp,fmt,array[i]) ; \
assert(rtn>0) ; \
} \
if(fmt[strlen(fmt) -1]!='\n') rtn= fputc('\n',fp) ; \
assert(rtn!=EOF) ; \
 \
return; \
 \
} \

#define MAXARRAY(var_t)  \
var_t max##var_t##array \
( \
const var_t*array, \
int n \
)  \
 \
{ \
 \
var_t x= 0; \
x= array[0]; \
while(n>1)  \
{ \
if(array[--n]>x) x= array[n]; \
} \
 \
return(x) ; \
 \
} \

#define MINARRAY(var_t)  \
var_t min##var_t##array \
( \
const var_t*array, \
int n \
)  \
 \
{ \
 \
var_t x= 0; \
x= array[0]; \
while(n>1)  \
{ \
if(array[--n]<x) x= array[n]; \
} \
 \
return(x) ; \
 \
} \

/*3:*/
#line 14 "ppgen.w"

#include "psimpoll.h" 
#include "ppglobal.h" 

/*:3*//*5:*/
#line 23 "ppgen.w"

void cls
(
char**screen,
int beg,
int end
)

{
for(;beg<=end;beg++)*screen[beg]= '\0';
if(end<24)pstrcpy(screen[24],"> ",SCRWID);

return;
}

/*:5*//*7:*/
#line 43 "ppgen.w"

void closef
(
file_t*f,
const char*file,
const int place
)

{
if(f->st==OPEN)
{

rtn= fprintf(gl.logf.fp,"%s closing\n",f->fname);
assert(rtn>0);
if(fclose(f->fp)!=0)
{
rtn= fprintf(stderr,"%s %d",file,place);
assert(rtn>0);
PPERROR(1);
}

f->fp= NULL;
f->st= CLOSED;
gl.openfiles--;

}

return;
}

/*:7*//*9:*/
#line 78 "ppgen.w"

int compare
(
const void*a,
const void*b
)

{
real x= 0;

x= *(real*)a-*(real*)b;

if(x>0)return(1);
if(x<0)return(-1);

return(0);
}

/*:9*//*11:*/
#line 101 "ppgen.w"

int compint
(
const void*a,
const void*b
)

{
int n= 0;

n= *(int*)a-*(int*)b;

if(n>0)return(1);
if(n<0)return(-1);

return(0);
}

/*:11*//*13:*/
#line 124 "ppgen.w"

void dlay
(
void
)

{
rtn= puts("Press <Enter>");
assert(rtn!=EOF);
CLEARIN;

return;
}

/*:13*//*15:*/
#line 143 "ppgen.w"

void dprint
(
file_t*f,
const char*fmt,
...
)

{
va_list args;

va_start(args,fmt);
if(f->st==OPEN)
{
if(vfprintf(f->fp,fmt,args)<0)PPERROR(27);
}
va_end(args);

va_start(args,fmt);
if(vprintf(fmt,args)<0)PPERROR(27);
va_end(args);

return;
}

/*:15*//*17:*/
#line 173 "ppgen.w"

char*findcolour
(
long id
)

{
loop_t i= 0;

if(gl.palette.id==NULL)return("");

for(i= 0;i<gl.palette.n;i++)
{
if(gl.palette.id[i]==id)break;
}

if(i==gl.palette.n)i= 0;

return(gl.palette.name[i]);
}

/*:17*//*19:*/
#line 199 "ppgen.w"

long findcolourid
(
char*name
)

{
static char buffer1[LENTAXN]= "";
static char buffer2[LENTAXN]= "";
loop_t i= 0;
loop_t ii= 0;

if(gl.palette.name==NULL)return(0L);

for(ii= 0;ii<pstrlen(name);ii++)buffer1[ii]= (char)lcase(name[ii]);
buffer1[ii]= '\0';

for(i= 0;i<gl.palette.n;i++)
{
for(ii= 0;ii<pstrlen(gl.palette.name[i]);ii++)
{
buffer2[ii]= (char)lcase(gl.palette.name[i][ii]);
}
buffer2[ii]= '\0';

if(!strcmp(buffer1,buffer2))break;
}
if(i==gl.palette.n)i= 0;

return(gl.palette.id[i]);
}

/*:19*//*21:*/
#line 236 "ppgen.w"

char*getbuf
(
file_t*f,
const char*const text
)

{
static char buffer[LENSTR2]= "";

flag_t flag= OFF;
int i= 0;
letter_t ss= 0;

if(feof(f->fp)!=0)
{
rtn= printf("Unexpected end of file for `%s'\n",f->fname);
assert(rtn>0);
}

else
{
while(feof(f->fp)==0)
{

ss= fgetc(f->fp);

if(ss==EOF||strchr(text,ss)!=NULL)flag= ON;

if(i==LENSTR2-1)
{
buffer[i]= '\0';
rtn= fprintf(gl.logf.fp,"Reading file %s\nOverfull buffer: '%s'\n",
f->fname,buffer);
assert(rtn>0);
derror(1);
}

if(!flag)buffer[i++]= (char)ss;
else break;

}

}

buffer[i]= '\0';

return(buffer);
}

/*:21*//*23:*/
#line 291 "ppgen.w"

char*getstr
(
int nchar
)

{
int n= 0;
static char buffer[LENSTR]= "";
int sz= 0;

n= MIN(nchar,LENSTR);
if(fgets(buffer,n,stdin)==NULL)PPERROR(6);
if((sz= pstrlen(buffer))!=0)
{
if(buffer[sz-1]=='\n')buffer[sz-1]= '\0';
else CLEARIN;
}

return(buffer);
}

/*:23*//*25:*/
#line 318 "ppgen.w"

char*getctime
(
void
)

{
static char buffer[LENSTR/2]= "";
time_t bintime= 0;

if(time(&bintime)==(time_t)-1)PPERROR(25);
if(strftime(buffer,LENSTR/2,"%X %a %d %b %Y",localtime(&bintime))==0)
{
PPERROR(26);
}

return(buffer);
}

/*:25*//*27:*/
#line 355 "ppgen.w"

void indexx
(
int n,
real*arr,
int*indx
)

{
real a= 0;

int indxt= 0;

loop_t i= 0;
loop_t j= 0;

for(j= 0;j<n;j++)indx[j]= j;

for(j= 1;j<=n-1;j++)
{
indxt= indx[j];
a= arr[indxt];
for(i= j-1;i>=0;i--)
{
if(arr[indx[i]]<=a)break;
indx[i+1]= indx[i];
}

indx[i+1]= indxt;

}

return;
}

/*:27*//*29:*/
#line 395 "ppgen.w"

letter_t lcase
(
letter_t c
)

{
letter_t l= 0;

if(isupper(c))l= tolower(c);
else l= c;

return(l);
}

/*:29*//*31:*/
#line 415 "ppgen.w"

char*mkstr
(
const char*fmt,
...
)

{
static char buffer[LENSTR]= "";
va_list args;

va_start(args,fmt);
rtn= vsprintf(buffer,fmt,args);
assert(rtn>0&&rtn<LENSTR);
va_end(args);

return(buffer);
}

/*:31*//*33:*/
#line 439 "ppgen.w"

void openf
(
file_t*f,
const char*file,
const int place,
const flag_t fail
)

{
if(gl.openfiles==FOPEN_MAX||f->st==OPEN)PPERROR(8);

if((f->fp= fopen(f->fname,f->mode))!=NULL)
{
rtn= fprintf(gl.logf.fp,"%s opened in mode '%s'\n",f->fname,f->mode);
assert(rtn>0);
f->st= OPEN;
gl.openfiles++;
}

else
{
if(f->fname!=NULL&&pstrlen(f->fname)!=0&&fail==ON)
{
rtn= fprintf(stderr,"%s %d",file,place);
assert(rtn>0);
PPERROR(8);
}

}


errno= 0;

return;
}

/*:33*//*35:*/
#line 481 "ppgen.w"

void psc
(
char**screen
)

{
loop_t i= 0;

if(screen!=NULL)
{
while(i<SCRHT-1)
{
rtn= puts(screen[i]!=NULL?screen[i]:"");
assert(rtn!=EOF);
i++;
}

rtn= fputs(screen[SCRHT-1]!=NULL?screen[SCRHT-1]:"",stdout);
assert(rtn!=EOF);

}

return;
}

/*:35*//*37:*/
#line 512 "ppgen.w"

void remsp
(
FILE*fp
)

{
letter_t ss= 0;

while(feof(fp)==0)
{
ss= fgetc(fp);
if(ss!=' '&&ss!='\n'&&ss!=EOF)
{
if(ungetc(ss,fp)==EOF)PPERROR(22);
break;
}

}

return;
}

/*:37*//*39:*/
#line 549 "ppgen.w"

void sortinx
(
int n,
real*pa,
int*iwksp
)

{
real*wksp= NULL;
loop_t j= 0;

wksp= avecreal(n);


for(j= 0;j<n;j++)wksp[j]= pa[j];


for(j= 0;j<n;j++)pa[j]= wksp[iwksp[j]];

fvec(wksp);

return;
}

/*:39*//*41:*/
#line 579 "ppgen.w"

void pstrcpy
(
char*dest,
const char*src,
const int len
)

{


assert(dest!=NULL);
assert(src!=NULL);
assert(len>0);
dest= strncpy(dest,src,len);
dest[len-1]= '\0';

return;
}

/*:41*//*43:*/
#line 604 "ppgen.w"

void shortstr
(
char*dest,
const char*src,
const int len
)

{


assert(dest!=NULL);
assert(src!=NULL);
assert(len>0);
dest= strncpy(dest,src,len);
dest[len-1]= '\0';
while((int)strlen(dest)<len-1)
{
strcat(dest," ");
}

return;
}

/*:43*//*45:*/
#line 633 "ppgen.w"

int pstrlen
(
const char*src
)

{
int n= 0;
assert(src!=NULL);
n= (int)strlen(src);

return(n);
}

/*:45*//*47:*/
#line 652 "ppgen.w"

letter_t ucase
(
letter_t c
)

{
letter_t l= 0;

if(islower(c))l= toupper(c);
else l= c;

return(l);
}

/*:47*//*49:*/
#line 672 "ppgen.w"

void vstrcat
(
int len,
char*str1,
...
)

{
char*strx= NULL;
int olen= 0;
va_list args;

olen= pstrlen(str1);


va_start(args,str1);
while((strx= va_arg(args,char*))!=NULL)
{
olen+= pstrlen(strx);
if(olen+1>len)
{
rtn= fprintf(gl.logf.fp,"%s %s\n",str1,strx);
assert(rtn>0);
lerror(13);
}
(void)strcat(str1,strx);
}

va_end(args);

return;
}

/*:49*//*51:*/
#line 728 "ppgen.w"

SUMARRAY(real)

/*:51*//*53:*/
#line 754 "ppgen.w"

SETARRAY(real)
SETARRAY(float)
SETARRAY(int)

/*:53*//*55:*/
#line 781 "ppgen.w"

CPYARRAY(real)
CPYARRAY(int)

/*:55*//*57:*/
#line 814 "ppgen.w"

PRNARRAY(real)

/*:57*//*59:*/
#line 842 "ppgen.w"

MAXARRAY(real)

/*:59*//*61:*/
#line 870 "ppgen.w"

MINARRAY(real)

/*:61*/
