/*3:*/
#line 14 "ppmainx1.w"

#include "psimpoll.h"
#include "ppglobal.h" 
#include "ppmainx1.h" 
#include "ppscreen.h" 


/*:3*//*4:*/
#line 22 "ppmainx1.w"

extern const char*opertext_f[9];
extern file_t outmain_f;

/*:4*//*6:*/
#line 33 "ppmainx1.w"

static char buffer_f[LENSTR2];

/*:6*//*7:*/
#line 37 "ppmainx1.w"

/*54:*/
#line 2474 "ppmainx1.w"

static int mod_s(int i,int j);
/*:54*/
#line 38 "ppmainx1.w"


/*:7*//*9:*/
#line 45 "ppmainx1.w"

real alevscal_x
(
real x
)

{
static const real scale= 2.5;

if(x>scale*1e5)return(1e5);
if(x>scale*1e4)return(1e4);
if(x>scale*1e3)return(1e3);
if(x>scale*1e2)return(1e2);
if(x>scale*10)return(10);
if(x>scale*1)return(1);
return(0.1);

}


/*:9*//*11:*/
#line 76 "ppmainx1.w"

void begindata_x
(
data_t*data,
char*title,
int*iex,
caption_t*head,
ci_t*ci,
frame_t*coll,
samp_t*lev,
age_t*age,
num_t*num
)

{
buffer_f[0]= '\0';




pstrcpy(buffer_f,getbuf(&inmain_f,"\n"),LENSTR2);
if(buffer_f[0]=='#')
{
gl.input= TILIA;
rtn= printf("(Tilia general format detected)\n");
assert(rtn>0);
}

if(gl.input==TILIA)pstrcpy(data->intitle,buffer_f+2,LENSTR);
else
{
pstrcpy(data->intitle,buffer_f,LENSTR);
remsp(inmain_f.fp);
}
pstrcpy(title,data->intitle,LENSTR2);


if(gl.input==TILIA)
{

while(buffer_f[0]=='#')
{
pstrcpy(buffer_f,getbuf(&inmain_f,"\n"),LENSTR2);
if(strstr(buffer_f,"Site name:")!=NULL)
{
pstrcpy(data->intitle,buffer_f+18,LENSTR);
pstrcpy(title,data->intitle,LENSTR2);
}
}
data->ntax= atoi(strtok(buffer_f," "));
data->nsam= atoi(strtok(NULL," "));



rtn= puts("Enter code for dataset type:\n'%' for percentage data\n"
"'c' for concentration data\n"
"'r' for raw data (converted to percentages)\n");
assert(rtn!=EOF);
gl.code.dat= ucase(getkey("%cCrR"));
if(gl.code.dat=='R')data->ntax+= 4;
rtn= puts("Enter code for sample type:\n'd' for depths (cm)\n"
"'m' for depths (m)\n'a' for ages\n");
assert(rtn!=EOF);
gl.code.yax= ucase(getkey("DdMmAa"));
rtn= fprintf(gl.logf.fp,"Code: %c%c\n",gl.code.dat,gl.code.yax);
assert(rtn>0);
}

else
{

data->ntax= atoi(getbuf(&inmain_f,"\n"));
remsp(inmain_f.fp);


data->nsam= atoi(getbuf(&inmain_f,"\n"));
remsp(inmain_f.fp);


pstrcpy(buffer_f,getbuf(&inmain_f,"\n"),LENSTR2);
remsp(inmain_f.fp);
rtn= fprintf(gl.logf.fp,"Code: %s\n",buffer_f);
assert(rtn>0);
gl.code.dat= ucase(buffer_f[0]);
gl.code.yax= ucase(buffer_f[1]);
}

head->base= avecchar(LENSTR2);
head->c14= avecchar(LENSTR);
head->ps1= avecchar(LENSTR);
head->ps2= avecchar(LENSTR);
head->time= avecchar(LENSTR);
head->sed= avecchar(LENSTR);
head->zone= avecchar(LENSTR);
head->subtitle= avecchar(LENSTR);
head->adxaxis= avecchar(LENSTR);
head->adyaxis= avecchar(LENSTR);

pstrcpy(head->c14,"{14}C ages (yr BP)",LENSTR);
pstrcpy(head->adxaxis,"Age ({14}C yr BP)",LENSTR);

switch(gl.code.dat)
{
case'%':
case'R':
num->thresh= 0.05F;
break;
case'A':
pstrcpy(head->c14,"Age location",LENSTR);
break;
case'B':
ci->cvsed= 0.3F;
*iex= 8;
break;
case'C':
*iex= 7;
break;
case'G':case'L':
break;
case'M':
coll->label= ON;
coll->curve= HIST;
break;
case'X':
coll->label= ON;
break;
default:
derror(4);
}


switch(gl.code.yax)
{
case'A':
pstrcpy(head->ps1,"Age",LENSTR);
if(age->adbc==OFF)pstrcpy(head->ps2,"yr BP",LENSTR);
else pstrcpy(head->ps2,"yr AD/BC",LENSTR);
gl.flag[TS]= OFF;
age->flag= OFF;
break;
case'D':
pstrcpy(head->ps1,"Depth",LENSTR);
pstrcpy(head->ps2,"cm",LENSTR);
pstrcpy(head->adyaxis,"Depth (cm)",LENSTR);
break;
case'M':
pstrcpy(head->ps1,"Depth",LENSTR);
pstrcpy(head->ps2,"m",LENSTR);
pstrcpy(head->adyaxis,"Depth (m)",LENSTR);
break;
case'F':
pstrcpy(head->ps1,"Cycles",LENSTR);
pstrcpy(head->ps2,"kyr{-1}",LENSTR);
gl.flag[ZONE]= OFF;
gl.flag[C14]= OFF;
gl.flag[TS]= OFF;
age->flag= OFF;
age->timx= OFF;
break;
case'S':
coll->bars= ON;
pstrcpy(head->ps1,"Sample",LENSTR);
gl.flag[C14]= OFF;
gl.flag[TS]= OFF;
age->flag= OFF;
age->timx= OFF;
break;
case'T':
coll->bars= ON;
gl.flag[C14]= OFF;
gl.flag[TS]= OFF;
gl.page.yscbeg= 0;
age->flag= OFF;
age->timx= OFF;
lev->max= (real)data->nsam;
lev->min= 1;
break;
default:derror(5);
}

return;
}


/*:11*//*13:*/
#line 265 "ppmainx1.w"

void chkfname_x
(
file_t*file,
letter_t drive
)

{
buffer_f[0]= '\0';


if(drive==0||pstrlen(file->fname)==0);
else if(strstr(file->fname,"COM1"));
else if(strstr(file->fname,"com1"));


else if(file->fname[1]==':')file->fname[0]= (char)drive;

else
{
rtn= sprintf(buffer_f,"%c:\\%s",drive,file->fname);
assert(rtn>0&&rtn<LENSTR);
pstrcpy(file->fname,buffer_f,LENFNAME);
}

return;
}


/*:13*//*15:*/
#line 299 "ppmainx1.w"

void getabsdata_x
(
data_t*data,
int iex,
int meth
)

{
loop_t j= 0;
loop_t k= 0;

for(k= 0;k<iex;k++)
{

for(j= 0;j<data->nsam;j++)
{

if(data->conc.ex[k][j]>=0)
{
data->conc.ex[k][j]= (real)atof(getbuf(&inmain_f,"\n "));
remsp(inmain_f.fp);
}
if(j<data->nsam-1)data->conc.ex[k][j+1]= data->conc.ex[k][j];
data->conc.ex[k][j]= fabse(data->conc.ex[k][j]);
switch(k)
{
case 0:

break;
case 1:


if(data->conc.ex[k][j]==1)
{
data->conc.ex[k][j]= sqrte(data->conc.ex[k-1][j]);
}
break;
case 2:

break;
case 3:

if(data->conc.ex[k][j]==1)
{
data->conc.ex[k][j]= data->conc.ex[k-1][j]*0.008;
}
break;
case 4:

break;
case 5:

break;
case 6:


if(data->conc.ex[k][j]==1)
{
data->conc.ex[k][j]= data->conc.ex[k-1][j]*0.01;
}
if(data->conc.ex[k-1][j]/data->conc.ex[k][j]<11)
{

dprint(&gl.logf,
"Coefficient of variation of sediment volume exceeds 11\n"
"Calculation of confidence intervals is suspect at sample "
"%f\n",data->alev[j]);
}
break;
case 7:



if(data->conc.ex[k][j]==1)
{
data->conc.ex[k][j]= powe(data->conc.ex[k-2][j],1.0/3.0);
}
break;
default:
PPERROR(9);

}

}

}


getcivar_x(&(*data),meth);

return;
}


/*:15*//*17:*/
#line 399 "ppmainx1.w"

void getaccrate_x
(
data_t data,
int numtax,
sed_t sed,
age_t age
)

{
loop_t j= 0;
loop_t k= 0;

for(j= 0;j<data.nsam;j++)
{
if(data.levfg[j]==ON)
{
for(k= 0;k<numtax;k++)
{

if(strchr("-*+@!=:",data.taxname[k][0])==NULL)
{
if(data.dat[k][j]>(float)gl.neglev)data.dat[k][j]/= sed.ar[j];
}

}

}

}

dprint(&gl.logf,"Accumulation rates calculated%s\n",
age.model==2?" - but no error value available":"");

return;
}


/*:17*//*19:*/
#line 444 "ppmainx1.w"

void getcivar_x
(
data_t*data,
int nci
)

{
real alph= 0;
real am= 0;
real amsd= 0;
real bet= 0;
real temp1= 0;
real temp2= 0;

loop_t j= 0;

for(j= 0;j<data->nsam;j++)
{
am= data->conc.ex[0][j]*data->conc.ex[2][j];

if(data->conc.ex[3][j]==0)
{
amsd= data->conc.ex[1][j]*sqrte(data->conc.ex[2][j]);
}

else amsd= errprop2(data->conc.ex[0][j],data->conc.ex[1][j],
data->conc.ex[2][j],data->conc.ex[3][j]);

temp1= am/amsd;
temp2= data->conc.ex[5][j]/data->conc.ex[6][j];

if(temp1<11)
{
rtn= printf("Coefficient of variation of exotic grains added is < 11.\n"
"Calculation of confidence intervals is suspect at level %d\n",j);
assert(rtn>0);
}

if(nci==1)
{
alph= atane(temp1/temp2);
bet= asine(sqrte(1.0/(temp1*temp1+temp2*temp2)));
data->conc.lgmv[j]= log10e(am/data->conc.ex[5][j]);
data->conc.lgsmv[j]= log10e((amsd*tane(alph+bet))/
data->conc.ex[6][j]);
data->conc.lgsmv[j]-= log10e((amsd*tane(alph-bet))/
data->conc.ex[6][j]);
data->conc.lgsmv[j]*= (data->conc.lgsmv[j]/2.0);
}
else if(nci==2)
{
data->conc.mv[j]= am/data->conc.ex[5][j];
data->conc.mvsd[j]= errprop3(am,amsd,data->conc.ex[5][j],
data->conc.ex[6][j]);
}

}

return;
}


/*:19*//*21:*/
#line 514 "ppmainx1.w"

void getpsidata_x
(
data_t*data,
samp_t*lev,
frame_t coll,
rare_t*rarer,
roc_t roc,
xaxis_t*xsamp,
flag_t intfg,
int*nosm,
int*nnsam,
int*nsum,
flag_t ageflag,
flag_t adbc
)

{
real dathold= 0;

flag_t rare= OFF;
flag_t sum= OFF;

loop_t j= 0;
loop_t k= 0;
loop_t l= 0;
loop_t m= 0;
loop_t n= 0;

buffer_f[0]= '\0';


*nnsam= data->nsam;


for(j= 0;j<data->nsam;j++)
{
if(gl.code.yax=='T')
{
data->alev[j]= (float)j+1;
pstrcpy(xsamp->annot[j],getbuf(&inmain_f,"\n,"),XLABLEN);
remsp(inmain_f.fp);
data->levfg[j]= ON;
}
else
{
pstrcpy(buffer_f,getbuf(&inmain_f,"\n "),LENSTR2);
remsp(inmain_f.fp);
data->alev[j]= (float)atof(buffer_f);
if((coll.skip!=0&&mod_s(j,coll.skip)==0)||
strchr(buffer_f,'x')!=NULL||
strchr(buffer_f,'X')!=NULL
)
{
(*nnsam)--;
data->levfg[j]= OFF;
}
else data->levfg[j]= ON;


if(data->levfg[j]==ON)
{
if(data->alev[j]>(float)lev->max)
{
lev->max= data->alev[j];
lev->maxpos= j;
}
if(data->alev[j]<(float)lev->min)
{
lev->min= data->alev[j];
lev->minpos= j;
}

}

}

if(coll.curve==HIST)
{
pstrcpy(buffer_f,getbuf(&inmain_f,"\n "),LENSTR2);
remsp(inmain_f.fp);
data->histwid[j]= (real)atof(buffer_f);
}

}


lev->max+= (data->histwid[lev->maxpos]/2);
lev->min-= (data->histwid[lev->minpos]/2);

if(lev->udata==ON&&ageflag==OFF)
{
lev->max= lev->umax;
lev->origmin= lev->min;
lev->min= lev->umin;
}

getxaxis(&(*lev),adbc,&(*xsamp));







for(k= 0;k<(data->ntax+rarer->flag+roc.flag);k++)
{

pstrcpy(buffer_f,getbuf(&inmain_f,"\n,"),LENSTR2);
if(pstrlen(buffer_f)+1>LENTAXN)
{
data->taxname[k]= rvecchar(data->taxname[k],pstrlen(buffer_f)+1);
}
pstrcpy(data->taxname[k],buffer_f,MAX(LENTAXN,pstrlen(buffer_f)+1));
if(coll.label==OFF)remsp(inmain_f.fp);



if(intfg==ON&&data->taxname[k][0]=='-')
{
pstrcpy(buffer_f,data->taxname[k],LENSTR2);
pstrcpy(data->taxname[k],buffer_f+1,pstrlen(data->taxname[k])+1);
}


if(coll.label==ON)
{
pstrcpy(buffer_f,getbuf(&inmain_f,"\n,"),LENSTR2);
if(pstrlen(buffer_f)+1>LENTAXN)
{
data->exlabel[k]= rvecchar(data->exlabel[k],pstrlen(buffer_f)+1);
}
pstrcpy(data->exlabel[k],buffer_f,MAX(LENTAXN,pstrlen(buffer_f)+1));
remsp(inmain_f.fp);
}

rare= sum= OFF;


if(data->taxname[k][0]=='*'||data->taxname[k][1]=='*')
{
nsum[(*nosm)++]= k;
if(*nosm>9)derror(20);
}

else if(data->taxname[k][0]=='!'||data->taxname[k][1]=='!')
{

rare= ON;
rarer->n= atoi(getbuf(&inmain_f,"\n"));
remsp(inmain_f.fp);
}

else if(data->taxname[k][0]=='<'||data->taxname[k][1]=='<')
{
int nchar= 0;

sum= ON;
data->summary.n= atoi(getbuf(&inmain_f,"\n"));
remsp(inmain_f.fp);

data->summary.grey= avecreal(data->summary.n);
data->summary.colid= aveclong(data->summary.n);
data->summary.grey[0]= 0;
data->summary.colid[0]= 0L;
for(l= 1;l<data->summary.n;l++)
{
data->summary.colid[l]= 0L;
data->summary.grey[l]= data->summary.grey[l-1]+
(1.0/((real)data->summary.n-1.0));
}


nchar= 0;
pstrcpy(buffer_f,data->taxname[k],LENSTR2);
for(l= 0;l<data->summary.n;l++)
{
while(isdigit(buffer_f[nchar])==0&&buffer_f[nchar]!='.'
&&buffer_f[nchar]!='-'&&nchar<LENSTR2)
{
nchar++;
}

if(nchar>=(int)strlen(data->taxname[k]))break;

if(buffer_f[nchar]=='-')
{
data->summary.colid[l]= atol(buffer_f+nchar);
}
else data->summary.grey[l]= MIN(1.0,(real)atof(buffer_f+nchar));

while((isdigit(buffer_f[nchar])!=0||buffer_f[nchar]=='.'
||buffer_f[nchar]=='-')&&nchar<LENSTR2)
{
nchar++;
}

if(nchar>=(int)strlen(data->taxname[k]))break;

}

}

m= (sum==ON?data->summary.n:1);

l= 1;


do
{
if(sum==ON)
{
pstrcpy(buffer_f,getbuf(&inmain_f,"\n,"),LENSTR2);
if(pstrlen(buffer_f)+1>LENTAXN)
{
data->summary.name[l-1]= rvecchar(data->summary.name[l-1],
pstrlen(buffer_f)+1);
}
pstrcpy(data->summary.name[l-1],buffer_f,
MAX(LENTAXN,pstrlen(buffer_f)+1));
remsp(inmain_f.fp);
}

for(j= 0;j<data->nsam;j++)
{
dathold= (real)atof(getbuf(&inmain_f,"\n "));
remsp(inmain_f.fp);
if(l==1)data->dat[k][j]= (float)dathold;
else if(l==2)
{
data->dat[data->ntax+l+1][j]= (float)(100*(dathold+data->dat[k][j]));
}
else
{
data->dat[data->ntax+l+1][j]= (float)(100*dathold+
data->dat[data->ntax+l][j]);
}



if(rare==ON)
{
for(n= 1;n<=2;n++)
{
data->dat[data->ntax+n][j]= atof(getbuf(&inmain_f,"\n "));
remsp(inmain_f.fp);
}

}

}

}while(++l<=m);

}

return;
}


/*:21*//*23:*/
#line 781 "ppmainx1.w"

void gettildata_x
(
data_t*data,
samp_t*lev,
frame_t coll,
rare_t*rarer,
roc_t roc,
xaxis_t*xsamp,
flag_t intfg,
int*nosm,
int*nnsam,
int*nsum,
flag_t ageflag,
flag_t adbc
)

{
char*taxcode= NULL;
char inkey= 0;
flag_t rare= OFF;
flag_t sum= OFF;

loop_t j= 0;
loop_t k= 0;
loop_t l= 0;
loop_t m= 0;
loop_t n= 0;

real dathold= 0;

taxcode= avecchar(data->ntax);

buffer_f[0]= '\0';


*nnsam= data->nsam;


for(k= 0;k<(data->ntax-4);k++)
{

pstrcpy(buffer_f,getbuf(&inmain_f,"\n"),LENSTR2);
if(pstrlen(buffer_f)+1>LENTAXN)
{
data->taxname[k]= rvecchar(data->taxname[k],pstrlen(buffer_f)+1);
}
if(pstrlen(buffer_f)<=15)derror(26);
if(pstrlen(buffer_f)<=17)
{
pstrcpy(data->taxname[k]," ",2);
}
else
{
pstrcpy(data->taxname[k],buffer_f+17,
MAX(LENTAXN,pstrlen(buffer_f)+1));
}
taxcode[k]= buffer_f[15];
if(inkey!='A')
{
rtn= printf("Taxon name is '%s': modify (y/n) or accept all (a)?\n",data->taxname[k]);
assert(rtn>0);
if((inkey= ucase(getkey("nNyYaA")))=='Y')
{
rtn= puts("Enter new name, with any prefixed codes: ");
assert(rtn!=EOF);
pstrcpy(data->taxname[k],getstr(LENTAXN),LENTAXN);
}
}

rare= sum= OFF;

}

if(gl.code.dat=='R')
{
pstrcpy(data->taxname[data->ntax-4],"*Sum ABF",9);
pstrcpy(data->taxname[data->ntax-3],"*Sum M",7);
pstrcpy(data->taxname[data->ntax-2],"*Sum Q",7);
pstrcpy(data->taxname[data->ntax-1],"*Sum X",7);
taxcode[data->ntax-4]= ' ';
taxcode[data->ntax-3]= ' ';
taxcode[data->ntax-2]= ' ';
taxcode[data->ntax-1]= ' ';
}


for(j= 0;j<data->nsam;j++)
{
pstrcpy(buffer_f,getbuf(&inmain_f,"\n"),LENSTR2);
remsp(inmain_f.fp);
data->alev[j]= (float)atof(buffer_f);
if((coll.skip!=0&&mod_s(j,coll.skip)==0))
{
(*nnsam)--;
data->levfg[j]= OFF;
}
else data->levfg[j]= ON;


if(data->levfg[j]==ON)
{
if(data->alev[j]>(float)lev->max)
{
lev->max= data->alev[j];
lev->maxpos= j;
}
if(data->alev[j]<(float)lev->min)
{
lev->min= data->alev[j];
lev->minpos= j;
}

}




for(k= 0;k<(data->ntax-4);k++)
{
data->dat[k][j]= atof(getbuf(&inmain_f,"\n "));
remsp(inmain_f.fp);
if(gl.code.dat=='%'&&taxcode[k]!=' ')data->dat[k][j]/= 100;
if(gl.code.dat=='R')
{
switch(taxcode[k])
{
case'A':case'B':case'F':
data->dat[data->ntax-4][j]+= data->dat[k][j];
break;
case'M':
data->dat[data->ntax-3][j]+= data->dat[k][j];
break;
case'Q':
data->dat[data->ntax-2][j]+= data->dat[k][j];
break;
case'X':
data->dat[data->ntax-1][j]+= data->dat[k][j];
break;
}

}

}

if(gl.code.dat=='R')
{

data->dat[data->ntax-3][j]+= data->dat[data->ntax-4][j];
data->dat[data->ntax-2][j]+= data->dat[data->ntax-4][j];
data->dat[data->ntax-1][j]+= data->dat[data->ntax-4][j];

for(k= 0;k<data->ntax-4;k++)
{
switch(taxcode[k])
{
case'A':case'B':case'F':
if(data->dat[k][j]>0.0)data->dat[k][j]/= data->dat[data->ntax-4][j];
break;
case'M':
if(data->dat[k][j]>0.0)data->dat[k][j]/= data->dat[data->ntax-3][j];
break;
case'Q':
if(data->dat[k][j]>0.0)data->dat[k][j]/= data->dat[data->ntax-2][j];
break;
case'X':
if(data->dat[k][j]>0.0)data->dat[k][j]/= data->dat[data->ntax-1][j];
break;
}

}

}

}

if(gl.code.dat=='R')gl.code.dat= '%';

if(lev->udata==ON&&ageflag==OFF)
{
lev->max= lev->umax;
lev->min= lev->umin;
}


lev->max+= (data->histwid[lev->maxpos]/2);
lev->min-= (data->histwid[lev->minpos]/2);

getxaxis(&(*lev),adbc,&(*xsamp));

fvec(taxcode);

return;
}


/*:23*//*25:*/
#line 982 "ppmainx1.w"

void getxaxis
(
samp_t*samp,
flag_t adbc,
xaxis_t*xaxis
)

{
real a= 0;
real b= 0;
real leng= 0;

loop_t j= 0;


samp->ex= samp->max+(0.001*(samp->max-samp->min));


if(samp->adsc==ON)
{

samp->majmark= alevscal_x(samp->max-samp->min);
samp->minmark= samp->majmark/10.0;
}

if(gl.code.yax=='T')
{
for(j= 0;j<xaxis->ntick;j++)xaxis->val[j]= (real)j+1;
return;
}

j= 0;
a= (real)(int1(samp->min/samp->majmark))*samp->majmark;
assert(samp->majmark>0);
for(;a<samp->ex;a+= samp->majmark)
{
if(a>=samp->min)
{
if(j>xaxis->ntick-15)

{

xaxis->val= rvecreal(xaxis->val,xaxis->ntick+100);
xaxis->annot= rmatchar(xaxis->annot,xaxis->ntick,
xaxis->ntick+100,XLABLEN);
xaxis->ntick+= 100;

}


xaxis->val[j]= a;


xaxis->annot[j][0]= '\0';
if(samp->max>=10)
{
if(adbc==OFF)rtn= sprintf(xaxis->annot[j],"%ld",long2(a));
else rtn= sprintf(xaxis->annot[j],"%ld",labs(long2(a)));
assert(rtn>0&&rtn<XLABLEN);
}
else
{
if(adbc==OFF)rtn= sprintf(xaxis->annot[j],"%.1f",a);
else rtn= sprintf(xaxis->annot[j],"%.1f",fabse(a));
assert(rtn>0&&rtn<XLABLEN);
}


leng= strwid(xaxis->annot[j])+strwid(" ");
xaxis->leng= MAX(xaxis->leng,leng);

j++;

}


assert(samp->minmark>0);
for(b= samp->minmark;
b<samp->majmark;
b+= samp->minmark
)
{
if(a+b>=samp->min&&a+b<=samp->ex)
{
xaxis->val[j]= a+b;
xaxis->annot[j][0]= '\0';
j++;
}

}

}

xaxis->val= rvecreal(xaxis->val,j);
xaxis->annot= rmatchar(xaxis->annot,xaxis->ntick,j,XLABLEN);
xaxis->ntick= j;

return;
}


/*:25*//*27:*/
#line 1089 "ppmainx1.w"

void loglev
(
samp_t l
)

{
TOLOGI(l.udata);
TOLOGF(l.max);
TOLOGF(l.min);
TOLOGF(l.umax);
TOLOGF(l.umin);
TOLOGF(l.origmin);
TOLOGF(l.ex);
TOLOGI(l.adsc);
TOLOGF(l.majmark);
TOLOGF(l.minmark);
TOLOGI(l.maxpos);
TOLOGI(l.minpos);
TOLOGF(l.interp);
TOLOGF(l.intstart);
TOLOGF(l.intstop);
(void)fprintf(gl.logf.fp,"l.inttype: %s\n",l.inttype==PAIR?"PAIR":"LINEFIT");
return;
}


/*:27*//*29:*/
#line 1121 "ppmainx1.w"

void logpage_x
(
void
)

{
rtn= fputs("Contents of gl.page:\n",gl.logf.fp);
assert(rtn!=EOF);
TOLOGF(gl.page.high);
TOLOGF(gl.page.wide);
TOLOGF(gl.page.prop);
TOLOGF(gl.page.minpl);
TOLOGF(gl.page.sep);
TOLOGF(gl.page.xmg);
TOLOGF(gl.page.ymg);
TOLOGF(gl.page.yscbeg);
TOLOGF(gl.page.ad);
TOLOGF(gl.page.ts);
TOLOGF(gl.page.zon);
TOLOGF(gl.page.c14);
TOLOGF(gl.page.ylo);
TOLOGF(gl.page.charsc);
TOLOGF(gl.page.lineht);

return;

}


/*:29*//*31:*/
#line 1157 "ppmainx1.w"

void mkdapsim_x
(
file_t*dat,
data_t data,
xaxis_t xsamp,
rare_t rarer,
frame_t coll
)

{
loop_t j= 0;
loop_t k= 0;
loop_t l= 0;
loop_t m= 0;

dprint(&gl.logf,"Printing dataset to %s (psimpoll format)\n",dat->fname);

rtn= fprintf(dat->fp,"%s\n%d\n%d\n%c%c\n",data.intitle,data.ntax,
data.nsam,gl.code.dat,gl.code.yax);
assert(rtn>0);

for(j= 0;j<data.nsam;j++)
{
if(gl.code.yax=='T')
{
rtn= fprintf(dat->fp,"%s\n",xsamp.annot[j]);
assert(rtn>0);
}
else
{
rtn= fprintf(dat->fp,"%-8.4f ",data.alev[j]);
assert(rtn>0);
}

}

rtn= fputc('\n',dat->fp);
assert(rtn!=EOF);

for(k= 0;k<data.ntax;k++)
{
l= 1;
rtn= fprintf(dat->fp,"%s",data.taxname[k]);
assert(rtn>0);
if(coll.label==ON)
{
rtn= fprintf(dat->fp,", %s, ",data.exlabel[k]);
}
else if(data.taxname[k][0]=='!')
{
rtn= fprintf(dat->fp,"\n%d\n",rarer.n);
assert(rtn>0);
}
else if(data.taxname[k][0]=='<')
{
rtn= fprintf(dat->fp,"\n%d\n",l= data.summary.n);
assert(rtn>0);
}
else
{
rtn= fprintf(dat->fp,", ");
assert(rtn>0);
}

for(m= 1;m<=l;m++)
{
if(l>1)
{
rtn= fprintf(dat->fp,"%s, ",data.summary.name[m-1]);
assert(rtn>0);
}
for(j= 0;j<data.nsam;j++)
{

assert(data.ntax+m+1<data.ntax+EXTRATAXN);
if(m==1)
{
rtn= fprintf(dat->fp,"%-8.4f ",data.dat[k][j]);
assert(rtn>0);
}
else if(m==2)
{
rtn= fprintf(dat->fp,"%-8.4f ",
(data.dat[data.ntax+m+1][j]/100.0)-data.dat[k][j]);
assert(rtn>0);
}
else if(m>2)
{
rtn= fprintf(dat->fp,"%-8.4f ",
(data.dat[data.ntax+m+1][j]-data.dat[data.ntax+m][j])/
100.0);
assert(rtn>0);
}
if(data.taxname[k][0]=='!')
{
rtn= fprintf(dat->fp,"%-8.4f%-8.4f ",data.dat[data.ntax+1][j],
data.dat[data.ntax+2][j]);
assert(rtn>0);
}

}

rtn= fputc('\n',dat->fp);
assert(rtn!=EOF);

}

}

return;
}


/*:31*//*33:*/
#line 1276 "ppmainx1.w"

void mkdacorn_x
(
file_t*dat,
data_t data,
xaxis_t xsamp,
age_t age
)

{
loop_t j= 0;
loop_t k= 0;

dprint(&gl.logf,"Printing dataset to %s (cornell format)\n",dat->fname);

rtn= fprintf(dat->fp,"%5d%5d%s\n",data.ntax,data.nsam,data.intitle);
assert(rtn>0);
rtn= fprintf(dat->fp,"(I5,5(I5,F10.4))%54d",5);
assert(rtn>0);

for(j= 0;j<data.nsam;j++)
{
for(k= 0;k<data.ntax;k++)
{
if(k%5==0)
{
rtn= fprintf(dat->fp,"\n%5d",j+1);
assert(rtn>0);
}
rtn= fprintf(dat->fp,"%5d%10.4f",k+1,data.dat[k][j]);
assert(rtn>0);
}
}
rtn= fprintf(dat->fp,"\n%5d",0);
assert(rtn>0);

for(k= 0;k<data.ntax;k++)
{
if(k%10==0)
{
rtn= fputc('\n',dat->fp);
assert(rtn!=EOF);
}


shortstr(buffer_f,data.taxname[k],8);
rtn= fputs(buffer_f,dat->fp);
assert(rtn!=EOF);
rtn= fputc(' ',dat->fp);
assert(rtn!=EOF);
if(data.taxname[k][0]=='<')
{
rtn= puts("Warning: dataset includes first item only of a summary");
assert(rtn!=EOF);
}
}

for(j= 0;j<data.nsam;j++)
{
if(j%10==0)
{
rtn= fputc('\n',dat->fp);
assert(rtn!=EOF);
}
if(gl.code.yax=='T')
{
if(pstrlen(xsamp.annot[j])>7)
{
pstrcpy(buffer_f,xsamp.annot[j],8);
}
else
{
rtn= sprintf(buffer_f,"%-*s",7,xsamp.annot[j]);
assert(rtn>0&&rtn<LENSTR);
}
rtn= fputs(buffer_f,dat->fp);
assert(rtn!=EOF);
rtn= fputc(' ',dat->fp);
assert(rtn!=EOF);
}
else
{
rtn= fprintf(dat->fp,"%8.2f",
age.flag==ON?data.alevold[j]:data.alev[j]);
assert(rtn>0);
}

}

rtn= fputc('\n',dat->fp);
assert(rtn!=EOF);

if(age.flag==ON)
{
rtn= fprintf(dat->fp,"%5d%5d%s\n",1,data.nsam,data.intitle);
assert(rtn>0);
rtn= fprintf(dat->fp,"(I5,5(I5,F9.0))%54d\n",5);
assert(rtn>0);
for(j= 0;j<data.nsam;j++)
{
rtn= fprintf(dat->fp,"%5d%5d%9.0f\n",j+1,1,data.alev[j]);
assert(rtn>0);
}
rtn= fprintf(dat->fp,"%5d\nTime",0);
assert(rtn>0);
for(j= 0;j<data.nsam;j++)
{
if(j%10==0)
{
rtn= fputc('\n',dat->fp);
assert(rtn!=EOF);
}
rtn= fprintf(dat->fp,"%8.2f",data.alevold[j]);
assert(rtn>0);
}
}

return;
}


/*:33*//*35:*/
#line 1402 "ppmainx1.w"

void obtdmax_x
(
data_t data,
frame_t*coll
)

{
loop_t j= 0;
loop_t k= 0;








for(k= 0;k<data.ntax;k++)
{

if(strchr("-*#&+@!=%:\'",data.taxname[k][0])!=NULL)continue;

for(j= 0;j<data.nsam;j++)
{

if(data.levfg[j]==ON||coll->all==ON)
{
if(gl.code.dat=='%'&&data.dat[k][j]>(float)gl.neglev)
{
data.dat[k][j]*= 100;
}
coll->max= MAX(coll->max,data.dat[k][j]);
if(data.dat[k][j]>(float)gl.neglev)
{
coll->min= MIN(coll->min,data.dat[k][j]);
}

}

}

}

return;
}


/*:35*//*37:*/
#line 1460 "ppmainx1.w"

void readcfg_x
(
file_t*cfg,
frame_t*coll,
file_t*agedep,
file_t*adplot,
file_t*outmain,
caption_t*head,
frame_t*agerange,
flag_t*intfg,
age_t*age,
file_t*zone,
file_t*inage,
file_t*ints,
ci_t*ci,
rare_t*rarer,
zoner_t*zoner,
four_t*four,
num_t*num,
roc_t*roc,
file_t*stat,
file_t*dat,
pca_t*pca,
ca_t*ca,
samp_t*lev,
flag_t*ipdat,
format_t*ipform,
char sunit[12][LENSTR/2]
)

{
loop_t i= 0;

buffer_f[0]= '\0';

cfg->mode[0]= 'r';
openf(&(*cfg),__FILE__,__LINE__,OFF);
if(cfg->st==CLOSED)
{
gl.flag[CFG]= OFF;
return;
}


pstrcpy(buffer_f,getbuf(&(*cfg),"\n "),LENSTR2);
if(feof(cfg->fp)==0)gl.page.minpl= (real)atof(buffer_f);
pstrcpy(buffer_f,getbuf(&(*cfg),"\n "),LENSTR2);
if(feof(cfg->fp)==0)gl.page.wide= (real)atof(buffer_f);
pstrcpy(buffer_f,getbuf(&(*cfg),"\n "),LENSTR2);
if(feof(cfg->fp)==0)gl.page.prop= (real)atof(buffer_f);
pstrcpy(buffer_f,getbuf(&(*cfg),"\n "),LENSTR2);
if(buffer_f[0]=='O'&&feof(cfg->fp)==0)coll->style= OUTL;
else coll->style= FILL;
pstrcpy(buffer_f,getbuf(&(*cfg),"\n "),LENSTR2);
if(feof(cfg->fp)==0)coll->ix10= ATOFG(buffer_f);
pstrcpy(buffer_f,getbuf(&(*cfg),"\n "),LENSTR2);
if(feof(cfg->fp)==0)pstrcpy(agedep->fname,buffer_f,LENFNAME);
pstrcpy(buffer_f,getbuf(&(*cfg),"\n "),LENSTR2);
if(feof(cfg->fp)==0)pstrcpy(outmain->fname,buffer_f,LENFNAME);
pstrcpy(buffer_f,getbuf(&(*cfg),"\n "),LENSTR2);
if(feof(cfg->fp)==0)gl.font.code= buffer_f[0];
pstrcpy(buffer_f,getbuf(&(*cfg),"\n "),LENSTR2);
if(feof(cfg->fp)==0)gl.font.ufac= (real)atof(buffer_f);
pstrcpy(buffer_f,getbuf(&(*cfg),"\n "),LENSTR2);
if(feof(cfg->fp)==0)coll->rot= atoi(buffer_f);
pstrcpy(buffer_f,getbuf(&(*cfg),"\n"),LENSTR2);
if(feof(cfg->fp)==0)pstrcpy(head->base,buffer_f,LENSTR2);
pstrcpy(buffer_f,getbuf(&(*cfg),"\n"),LENSTR2);
if(feof(cfg->fp)==0)pstrcpy(head->subtitle,buffer_f,LENSTR);
pstrcpy(buffer_f,getbuf(&(*cfg),"\n"),LENSTR2);
if(feof(cfg->fp)==0)pstrcpy(head->zone,buffer_f,LENSTR);
pstrcpy(buffer_f,getbuf(&(*cfg),"\n"),LENSTR2);
if(feof(cfg->fp)==0)pstrcpy(head->sed,buffer_f,LENSTR);
pstrcpy(buffer_f,getbuf(&(*cfg),"\n "),LENSTR2);
if(feof(cfg->fp)==0)coll->join= ATOFG(buffer_f);
pstrcpy(buffer_f,getbuf(&(*cfg),"\n "),LENSTR2);
if(feof(cfg->fp)==0)*intfg= ATOFG(buffer_f);
pstrcpy(buffer_f,getbuf(&(*cfg),"\n "),LENSTR2);
if(feof(cfg->fp)==0)age->flag= ATOFG(buffer_f);
pstrcpy(buffer_f,getbuf(&(*cfg),"\n "),LENSTR2);
if(feof(cfg->fp)==0)age->up= (real)atof(buffer_f);
pstrcpy(buffer_f,getbuf(&(*cfg),"\n "),LENSTR2);
if(feof(cfg->fp)==0)age->upsd= (real)atof(buffer_f);
pstrcpy(buffer_f,getbuf(&(*cfg),"\n "),LENSTR2);
if(feof(cfg->fp)==0)age->base= (real)atof(buffer_f);
pstrcpy(buffer_f,getbuf(&(*cfg),"\n "),LENSTR2);
if(feof(cfg->fp)==0)age->basesd= (real)atof(buffer_f);
pstrcpy(buffer_f,getbuf(&(*cfg),"\n "),LENSTR2);
if(feof(cfg->fp)==0)age->model= atoi(buffer_f);
pstrcpy(buffer_f,getbuf(&(*cfg),"\n "),LENSTR2);
if(feof(cfg->fp)==0)age->nterm= atoi(buffer_f);
pstrcpy(buffer_f,getbuf(&(*cfg),"\n "),LENSTR2);
if(feof(cfg->fp)==0)age->c14k= (real)atof(buffer_f);
pstrcpy(buffer_f,getbuf(&(*cfg),"\n "),LENSTR2);
if(feof(cfg->fp)==0)pstrcpy(zone->fname,buffer_f,LENFNAME);
pstrcpy(buffer_f,getbuf(&(*cfg),"\n "),LENSTR2);
if(feof(cfg->fp)==0)pstrcpy(inage->fname,buffer_f,LENFNAME);
pstrcpy(buffer_f,getbuf(&(*cfg),"\n "),LENSTR2);
if(feof(cfg->fp)==0)pstrcpy(ints->fname,buffer_f,LENFNAME);
pstrcpy(buffer_f,getbuf(&(*cfg),"\n "),LENSTR2);
if(feof(cfg->fp)==0)ci->flag= ATOFG(buffer_f);
pstrcpy(buffer_f,getbuf(&(*cfg),"\n "),LENSTR2);
if(feof(cfg->fp)==0)ci->cvsed= (real)atof(buffer_f);
pstrcpy(buffer_f,getbuf(&(*cfg),"\n "),LENSTR2);
if(feof(cfg->fp)==0)ci->meth= atoi(buffer_f);
pstrcpy(buffer_f,getbuf(&(*cfg),"\n "),LENSTR2);
if(feof(cfg->fp)==0)gl.mran= atoi(buffer_f);
pstrcpy(buffer_f,getbuf(&(*cfg),"\n "),LENSTR2);
if(feof(cfg->fp)==0)pstrcpy(gl.seed,buffer_f,11);
pstrcpy(buffer_f,getbuf(&(*cfg),"\n "),LENSTR2);
if(feof(cfg->fp)==0)ci->nran= atoi(buffer_f);
pstrcpy(buffer_f,getbuf(&(*cfg),"\n "),LENSTR2);
if(feof(cfg->fp)==0)rarer->flag= ATOFG(buffer_f);
pstrcpy(buffer_f,getbuf(&(*cfg),"\n "),LENSTR2);
if(feof(cfg->fp)==0)rarer->n= atoi(buffer_f);
pstrcpy(buffer_f,getbuf(&(*cfg),"\n "),LENSTR2);
if(feof(cfg->fp)==0)zoner->flag= ATOFG(buffer_f);
pstrcpy(buffer_f,getbuf(&(*cfg),"\n "),LENSTR2);
if(feof(cfg->fp)==0)num->thresh= (real)atof(buffer_f);
pstrcpy(buffer_f,getbuf(&(*cfg),"\n "),LENSTR2);
if(feof(cfg->fp)==0)zoner->n= atoi(buffer_f);
pstrcpy(buffer_f,getbuf(&(*cfg),"\n "),LENSTR2);
if(feof(cfg->fp)==0)zoner->meth= atoi(buffer_f);
pstrcpy(buffer_f,getbuf(&(*cfg),"\n"),LENSTR2);
if(feof(cfg->fp)==0)pstrcpy(zoner->pre,buffer_f,LENSTR/4);
pstrcpy(buffer_f,getbuf(&(*cfg),"\n "),LENSTR2);
if(feof(cfg->fp)==0)roc->flag= ATOFG(buffer_f);
pstrcpy(buffer_f,getbuf(&(*cfg),"\n "),LENSTR2);
if(feof(cfg->fp)==0)roc->diss= atoi(buffer_f);
pstrcpy(buffer_f,getbuf(&(*cfg),"\n"),LENSTR2);
if(feof(cfg->fp)==0)pstrcpy(head->c14,buffer_f,LENSTR);
pstrcpy(buffer_f,getbuf(&(*cfg),"\n"),LENSTR2);
if(feof(cfg->fp)==0)pstrcpy(head->ps1,buffer_f,LENSTR);
pstrcpy(buffer_f,getbuf(&(*cfg),"\n"),LENSTR2);
if(feof(cfg->fp)==0)pstrcpy(head->ps2,buffer_f,LENSTR);
pstrcpy(buffer_f,getbuf(&(*cfg),"\n "),LENSTR2);
if(feof(cfg->fp)==0)num->stat= ATOFG(buffer_f);
pstrcpy(buffer_f,getbuf(&(*cfg),"\n "),LENSTR2);
if(feof(cfg->fp)==0)pstrcpy(stat->fname,buffer_f,LENFNAME);
pstrcpy(buffer_f,getbuf(&(*cfg),"\n "),LENSTR2);
if(feof(cfg->fp)==0)pca->flag= ATOFG(buffer_f);
pstrcpy(buffer_f,getbuf(&(*cfg),"\n "),LENSTR2);
if(feof(cfg->fp)==0)pca->matrix= atoi(buffer_f);
pstrcpy(buffer_f,getbuf(&(*cfg),"\n "),LENSTR2);
if(feof(cfg->fp)==0)pca->naxes= atoi(buffer_f);
pstrcpy(buffer_f,getbuf(&(*cfg),"\n "),LENSTR2);
if(feof(cfg->fp)==0)four->flag= ATOFG(buffer_f);
pstrcpy(buffer_f,getbuf(&(*cfg),"\n "),LENSTR2);
if(feof(cfg->fp)==0)lev->adsc= ATOFG(buffer_f);
pstrcpy(buffer_f,getbuf(&(*cfg),"\n "),LENSTR2);
if(feof(cfg->fp)==0)pca->tran= atoi(buffer_f);
pstrcpy(buffer_f,getbuf(&(*cfg),"\n "),LENSTR2);
if(feof(cfg->fp)==0)zoner->tran= atoi(buffer_f);
pstrcpy(buffer_f,getbuf(&(*cfg),"\n "),LENSTR2);
if(feof(cfg->fp)==0)coll->indspl= ATOFG(buffer_f);
pstrcpy(buffer_f,getbuf(&(*cfg),"\n "),LENSTR2);
if(feof(cfg->fp)==0)zoner->ransam= ATOFG(buffer_f);
pstrcpy(buffer_f,getbuf(&(*cfg),"\n "),LENSTR2);
if(feof(cfg->fp)==0)gl.recalc= ATOFG(buffer_f);
pstrcpy(buffer_f,getbuf(&(*cfg),"\n "),LENSTR2);
if(feof(cfg->fp)==0)coll->shade= (real)atof(buffer_f);
pstrcpy(buffer_f,getbuf(&(*cfg),"\n "),LENSTR2);
if(feof(cfg->fp)==0)lev->udata= ATOFG(buffer_f);
pstrcpy(buffer_f,getbuf(&(*cfg),"\n "),LENSTR2);
if(feof(cfg->fp)==0)lev->umax= (real)atof(buffer_f);
pstrcpy(buffer_f,getbuf(&(*cfg),"\n "),LENSTR2);
if(feof(cfg->fp)==0)lev->umin= (real)atof(buffer_f);
pstrcpy(buffer_f,getbuf(&(*cfg),"\n "),LENSTR2);
if(feof(cfg->fp)==0)coll->all= ATOFG(buffer_f);
pstrcpy(buffer_f,getbuf(&(*cfg),"\n "),LENSTR2);
if(feof(cfg->fp)==0)*ipdat= ATOFG(buffer_f);
pstrcpy(buffer_f,getbuf(&(*cfg),"\n "),LENSTR2);
if(feof(cfg->fp)==0)roc->smooth= atoi(buffer_f);
pstrcpy(buffer_f,getbuf(&(*cfg),"\n "),LENSTR2);
if(feof(cfg->fp)==0)coll->hist= (real)atof(buffer_f);
pstrcpy(buffer_f,getbuf(&(*cfg),"\n "),LENSTR2);
if(feof(cfg->fp)==0)coll->indscale= ATOFG(buffer_f);
for(i= 0;i<10;i++)
{
pstrcpy(buffer_f,getbuf(&(*cfg),"\n"),LENSTR2);
if(feof(cfg->fp)==0)pstrcpy(sunit[i],buffer_f,LENSTR/2);
}
pstrcpy(buffer_f,getbuf(&(*cfg),"\n "),LENSTR2);
if(feof(cfg->fp)==0)four->tran= atoi(buffer_f);
pstrcpy(buffer_f,getbuf(&(*cfg),"\n "),LENSTR2);
if(atoi(buffer_f)==0&&feof(cfg->fp)==0)coll->script= SCRWRITE;
else coll->script= SCRREAD;
pstrcpy(buffer_f,getbuf(&(*cfg),"\n "),LENSTR2);
if(feof(cfg->fp)==0)coll->bull= ATOFG(buffer_f);
pstrcpy(buffer_f,getbuf(&(*cfg),"\n "),LENSTR2);
if(feof(cfg->fp)==0)coll->lval= (real)atof(buffer_f);
pstrcpy(buffer_f,getbuf(&(*cfg),"\n "),LENSTR2);
if(feof(cfg->fp)==0)age->timx= ATOFG(buffer_f);
pstrcpy(buffer_f,getbuf(&(*cfg),"\n"),LENSTR2);
if(feof(cfg->fp)==0)pstrcpy(head->time,buffer_f,LENSTR);
pstrcpy(buffer_f,getbuf(&(*cfg),"\n "),LENSTR2);
if(feof(cfg->fp)==0)coll->sum2col= ATOFG(buffer_f);
pstrcpy(buffer_f,getbuf(&(*cfg),"\n "),LENSTR2);
if(feof(cfg->fp)==0)roc->model.ci= ATOFG(buffer_f);
pstrcpy(buffer_f,getbuf(&(*cfg),"\n "),LENSTR2);
if(feof(cfg->fp)==0)roc->model.n= atoi(buffer_f);
pstrcpy(buffer_f,getbuf(&(*cfg),"\n "),LENSTR2);
if(feof(cfg->fp)==0)pca->model.ci= ATOFG(buffer_f);
pstrcpy(buffer_f,getbuf(&(*cfg),"\n "),LENSTR2);
if(feof(cfg->fp)==0)pca->model.n= atoi(buffer_f);
pstrcpy(buffer_f,getbuf(&(*cfg),"\n "),LENSTR2);
if(feof(cfg->fp)==0)zoner->model.ci= ATOFG(buffer_f);
pstrcpy(buffer_f,getbuf(&(*cfg),"\n "),LENSTR2);
if(feof(cfg->fp)==0)zoner->model.n= atoi(buffer_f);
pstrcpy(buffer_f,getbuf(&(*cfg),"\n "),LENSTR2);
if(feof(cfg->fp)==0)lev->majmark= (real)atof(buffer_f);
pstrcpy(buffer_f,getbuf(&(*cfg),"\n "),LENSTR2);
if(feof(cfg->fp)==0)lev->minmark= (real)atof(buffer_f);
pstrcpy(buffer_f,getbuf(&(*cfg),"\n "),LENSTR2);
if(feof(cfg->fp)==0)coll->skip= atoi(buffer_f);
pstrcpy(buffer_f,getbuf(&(*cfg),"\n "),LENSTR2);
if(feof(cfg->fp)==0)gl.tufte= ATOFG(buffer_f);
pstrcpy(buffer_f,getbuf(&(*cfg),"\n "),LENSTR2);
if(feof(cfg->fp)==0)age->adbc= ATOFG(buffer_f);
pstrcpy(buffer_f,getbuf(&(*cfg),"\n "),LENSTR2);
if(feof(cfg->fp)==0)coll->c14scale= ATOFG(buffer_f);
pstrcpy(buffer_f,getbuf(&(*cfg),"\n "),LENSTR2);
if(feof(cfg->fp)==0)pstrcpy(dat->fname,buffer_f,LENFNAME);
pstrcpy(buffer_f,getbuf(&(*cfg),"\n "),LENSTR2);
if(feof(cfg->fp)==0)*ipform= atoi(buffer_f);
pstrcpy(buffer_f,getbuf(&(*cfg),"\n "),LENSTR2);
if(feof(cfg->fp)==0)coll->penwid= (real)atof(buffer_f);
pstrcpy(buffer_f,getbuf(&(*cfg),"\n "),LENSTR2);
if(feof(cfg->fp)==0)coll->interp= ATOFG(buffer_f);
pstrcpy(buffer_f,getbuf(&(*cfg),"\n "),LENSTR2);
if(feof(cfg->fp)==0)lev->interp= (real)atof(buffer_f);
pstrcpy(buffer_f,getbuf(&(*cfg),"\n "),LENSTR2);
if(feof(cfg->fp)==0)lev->intstart= (real)atof(buffer_f);
pstrcpy(buffer_f,getbuf(&(*cfg),"\n "),LENSTR2);
if(feof(cfg->fp)==0)lev->intstop= (real)atof(buffer_f);
pstrcpy(buffer_f,getbuf(&(*cfg),"\n "),LENSTR2);
if(feof(cfg->fp)==0)pstrcpy(adplot->fname,buffer_f,LENFNAME);
pstrcpy(buffer_f,getbuf(&(*cfg),"\n "),LENSTR2);
if(feof(cfg->fp)==0)gl.adpage.minpl= (real)atof(buffer_f);
pstrcpy(buffer_f,getbuf(&(*cfg),"\n"),LENSTR2);
if(feof(cfg->fp)==0)pstrcpy(head->adxaxis,buffer_f,LENSTR);
pstrcpy(buffer_f,getbuf(&(*cfg),"\n"),LENSTR2);
if(feof(cfg->fp)==0)pstrcpy(head->adyaxis,buffer_f,LENSTR);
pstrcpy(buffer_f,getbuf(&(*cfg),"\n "),LENSTR2);
if(feof(cfg->fp)==0)gl.palette.back= atol(buffer_f);
pstrcpy(buffer_f,getbuf(&(*cfg),"\n "),LENSTR2);
if(feof(cfg->fp)==0)gl.palette.fore= atol(buffer_f);
pstrcpy(buffer_f,getbuf(&(*cfg),"\n "),LENSTR2);
if(feof(cfg->fp)==0)coll->colpl= atol(buffer_f);
pstrcpy(buffer_f,getbuf(&(*cfg),"\n "),LENSTR2);
if(feof(cfg->fp)==0)coll->coltit= atol(buffer_f);
pstrcpy(buffer_f,getbuf(&(*cfg),"\n "),LENSTR2);
if(feof(cfg->fp)==0)coll->coldep= atol(buffer_f);
pstrcpy(buffer_f,getbuf(&(*cfg),"\n "),LENSTR2);
if(feof(cfg->fp)==0)coll->col14c= atol(buffer_f);
pstrcpy(buffer_f,getbuf(&(*cfg),"\n "),LENSTR2);
if(feof(cfg->fp)==0)coll->colts= atol(buffer_f);
pstrcpy(buffer_f,getbuf(&(*cfg),"\n "),LENSTR2);
if(feof(cfg->fp)==0)coll->colzone= atol(buffer_f);
pstrcpy(buffer_f,getbuf(&(*cfg),"\n "),LENSTR2);
if(feof(cfg->fp)==0)coll->colxax= atol(buffer_f);
pstrcpy(buffer_f,getbuf(&(*cfg),"\n "),LENSTR2);
if(feof(cfg->fp)==0)gl.colts= ATOFG(buffer_f);
pstrcpy(buffer_f,getbuf(&(*cfg),"\n "),LENSTR2);
if(feof(cfg->fp)==0)gl.colzone= ATOFG(buffer_f);
pstrcpy(buffer_f,getbuf(&(*cfg),"\n "),LENSTR2);
if(feof(cfg->fp)==0)gl.neglev= (real)atof(buffer_f);
pstrcpy(buffer_f,getbuf(&(*cfg),"\n "),LENSTR2);
if(feof(cfg->fp)==0)agerange->colpl= atol(buffer_f);
pstrcpy(buffer_f,getbuf(&(*cfg),"\n "),LENSTR2);
if(feof(cfg->fp)==0)agerange->colsdpl= atol(buffer_f);
pstrcpy(buffer_f,getbuf(&(*cfg),"\n "),LENSTR2);
if(feof(cfg->fp)==0)agerange->col14c= atol(buffer_f);
pstrcpy(buffer_f,getbuf(&(*cfg),"\n "),LENSTR2);
if(feof(cfg->fp)==0)agerange->coldep= atol(buffer_f);
pstrcpy(buffer_f,getbuf(&(*cfg),"\n "),LENSTR2);
if(feof(cfg->fp)==0)agerange->colxax= atol(buffer_f);
pstrcpy(buffer_f,getbuf(&(*cfg),"\n "),LENSTR2);
if(atoi(buffer_f)==0&&feof(cfg->fp)==0)lev->inttype= PAIR;
else lev->inttype= LINEFIT;
pstrcpy(buffer_f,getbuf(&(*cfg),"\n "),LENSTR2);
if(feof(cfg->fp)==0)gl.papwid= (real)atof(buffer_f);
pstrcpy(buffer_f,getbuf(&(*cfg),"\n "),LENSTR2);
if(feof(cfg->fp)==0)gl.papht= (real)atof(buffer_f);
pstrcpy(buffer_f,getbuf(&(*cfg),"\n "),LENSTR2);
if(feof(cfg->fp)==0)ca->flag= ATOFG(buffer_f);
pstrcpy(buffer_f,getbuf(&(*cfg),"\n "),LENSTR2);
if(feof(cfg->fp)==0)ca->tran= atoi(buffer_f);
pstrcpy(buffer_f,getbuf(&(*cfg),"\n "),LENSTR2);
if(feof(cfg->fp)==0)ca->iweigh= ATOFG(buffer_f);
pstrcpy(buffer_f,getbuf(&(*cfg),"\n "),LENSTR2);
if(feof(cfg->fp)==0)ca->irescfg= ATOFG(buffer_f);
pstrcpy(buffer_f,getbuf(&(*cfg),"\n "),LENSTR2);
if(feof(cfg->fp)==0)ca->iresc= atoi(buffer_f);
pstrcpy(buffer_f,getbuf(&(*cfg),"\n "),LENSTR2);
if(feof(cfg->fp)==0)ca->dca= ATOFG(buffer_f);
pstrcpy(buffer_f,getbuf(&(*cfg),"\n "),LENSTR2);
if(feof(cfg->fp)==0)ca->mk= atoi(buffer_f);
pstrcpy(buffer_f,getbuf(&(*cfg),"\n "),LENSTR2);
if(feof(cfg->fp)==0)ca->resth= (real)atof(buffer_f);
pstrcpy(buffer_f,getbuf(&(*cfg),"\n "),LENSTR2);
if(feof(cfg->fp)==0)ca->model.ci= ATOFG(buffer_f);
pstrcpy(buffer_f,getbuf(&(*cfg),"\n "),LENSTR2);
if(feof(cfg->fp)==0)ca->model.n= atoi(buffer_f);

closef(&(*cfg),__FILE__,__LINE__);

return;
}

/*:37*//*39:*/
#line 1777 "ppmainx1.w"

void getc14_x
(
age_t*const age,
file_t inage,
const file_t ints,
rc14_t*const c14
)

{
loop_t m= 0;

real*c14mem= NULL;

if(gl.flag[C14])
{
openf(&inage,__FILE__,__LINE__,OFF);
if(inage.st==CLOSED)gl.flag[C14]= OFF;
}


if(gl.flag[C14]==ON)
{
rtn= printf("Reading age data ... ");
assert(rtn>0);
c14->num= atoi(getbuf(&inage,"\n"));


c14->age= amatchar(c14->num,LENSTR/2);
c14->sd= amatchar(c14->num,LENSTR/4);
c14mem= avecreal(2*c14->num);
c14->dp1= c14mem;
c14->dp2= c14mem+c14->num;



c14->nuse= 0;
if(age->up>=-2000)(c14->nuse)++;
if(age->base>0)(c14->nuse)++;


for(m= 0;m<c14->num;m++)
{
c14->dp1[m]= (real)atof(getbuf(&inage,"\n"));

c14->dp2[m]= (real)atof(getbuf(&inage,"\n"));

pstrcpy(c14->age[m],getbuf(&inage,"\n"),LENSTR/2);


if(isdigit(c14->age[m][0])!=0||c14->age[m][0]=='-')(c14->nuse)++;

pstrcpy(c14->sd[m],getbuf(&inage,"\n"),LENSTR/4);

}

rtn= puts("done");
assert(rtn!=EOF);
closef(&inage,__FILE__,__LINE__);

}

else
{
if(age->flag==ON)
{

rtn= puts("No C14 file. Conversion to ages is not possible.\n"
"Samples assumed to be depths (cm)");
assert(rtn!=EOF);
gl.code.yax= 'D';
}

age->flag= OFF;
age->timx= OFF;
if(pstrlen(ints.fname)==0)gl.flag[TS]= ON;

if(gl.code.dat=='B')
{

rtn= puts("No C14 file. Calculation of accumulation rates is not "
"possible.\nData will remain as concentrations");
assert(rtn!=EOF);
gl.code.dat= 'C';
}

}

return;
}


/*:39*//*41:*/
#line 1874 "ppmainx1.w"

void getts_x
(
file_t ints,
ts_t*const ts
)

{
char buffer[LENSTR]= "";

flag_t ierr= 0;
int k= 0;
int m= 0;
loop_t j= 0;






if(gl.flag[TS])
{
openf(&ints,__FILE__,__LINE__,OFF);
if(ints.st==CLOSED)gl.flag[TS]= OFF;
}
if(gl.flag[TS])
{

rtn= printf("Reading sediment description ... ");
assert(rtn>0);
ts->num= atoi(getbuf(&ints,"\n"));

ts->val= avecint(ts->num*TSVALN);
ts->dep= avecreal(ts->num);
ts->lab= avecchar(ts->num*TSVALN*TSLABLEN);
gl.palette.tsid= aveclong(ts->num);


for(j= 0;j<ts->num;j++)
{
k= 0;


while(k<TSVALN)
{
pstrcpy(buffer,getbuf(&ints,"\n "),LENSTR);
if(strstr(
"Ld,Lso,Th,Tbs,Sh,Tb,Hc,Hs,Ag,As,Ga,Gs,Dh,Tl,Lc,ptm,Dg,Gg,Dl,Tep,"
"los, lcs, Tuf",buffer)==NULL)
{
if(!ierr)derror(6);
rtn= printf(" '%s' in sediment unit %d\n",buffer,j+1);
assert(rtn>0);
pstrcpy(buffer,"Tuf",LENSTR);
ierr= ON;
}

pstrcpy(ts->lab+m*TSVALN,buffer,TSLABLEN);

ts->val[m]= atoi(getbuf(&ints,"\n"));

k+= ts->val[m];
m++;

}


ts->dep[j]= (real)atof(getbuf(&ints,"\n"));

}


for(j= 0;j<ts->num;j++)
{
pstrcpy(buffer_f,getbuf(&ints,"\n"),LENSTR2);
if(feof(ints.fp)==0)
{
gl.palette.tsid[j]= findcolourid(buffer_f);
}
else
{
gl.colts= OFF;
break;
}
}



gl.page.ts= 0.04F;
rtn= puts("done");
assert(rtn!=EOF);
closef(&ints,__FILE__,__LINE__);

}

return;
}


/*:41*//*43:*/
#line 1978 "ppmainx1.w"

void getzone_x
(
file_t zone,
zone_t*const zon
)

{
real leng= 0;
real leng2= 0;

loop_t l= 0;


if(gl.flag[ZONE])
{
zone.mode[0]= 'r';
openf(&zone,__FILE__,__LINE__,OFF);
if(zone.st==CLOSED)gl.flag[ZONE]= OFF;
}


if(gl.flag[ZONE])
{
rtn= printf("Reading zone data ... ");
assert(rtn>0);
zon->num= atoi(getbuf(&zone,"\n"));
zon->lab= amatchar(zon->num,LENSTR/2);
zon->dep= avecreal(zon->num+1);
gl.palette.zoneid= aveclong(zon->num);


for(l= 0;l<zon->num;l++)
{
if((sprintf(zon->lab[l]," %s ",getbuf(&zone,"\n"))>
LENSTR/2-1))
{
PPERROR(24);
}


leng2= strwid(zon->lab[l]);
leng= MAX(leng,leng2);

}

for(l= 0;l<zon->num-1;l++)
{

zon->dep[l+1]= (real)atof(getbuf(&zone,"\n"));
}


for(l= 0;l<zon->num;l++)
{
pstrcpy(buffer_f,getbuf(&zone,"\n"),LENSTR2);
if(feof(zone.fp)==0)
{
gl.palette.zoneid[l]= findcolourid(buffer_f);
}
else
{
gl.colzone= OFF;
break;
}
}





gl.page.zon= gl.page.sep+leng;
gl.page.ad= -2*gl.page.sep;
rtn= puts("done");
assert(rtn!=EOF);
closef(&zone,__FILE__,__LINE__);

}

return;
}


/*:43*//*45:*/
#line 2066 "ppmainx1.w"

long getsecs_x
(
void
)

{
long diff= 0L;

struct tm starttime;

time_t time1970= 0;
time_t timenow= 0;

starttime.tm_year= 70;
starttime.tm_mon= 0;
starttime.tm_mday= 1;
starttime.tm_hour= 0;
starttime.tm_min= 0;
starttime.tm_sec= 0;

time1970= mktime(&starttime);
timenow= time((time_t*)NULL);


diff= (long)((double)timenow-(double)time1970);

return(diff);
}


/*:45*//*47:*/
#line 2104 "ppmainx1.w"

void getfnames_x
(
file_t*outmain,
file_t*cfg,
file_t*script,
file_t*zone,
file_t*inage,
file_t*ints,
file_t*stat,
file_t*dat,
file_t*agedep,
file_t*adplot,
letter_t*drive
)

{
char rfn[LENFNAME]= "";
loop_t l= 0;
size_t sz= 0;


rtn= fprintf(gl.logf.fp,"Input file name given: %s\n",inmain_f.fname);
assert(rtn>0);


l= 0;
for(sz= 0;sz<(size_t)pstrlen(inmain_f.fname);sz++)
{
if(inmain_f.fname[sz]=='\\'||inmain_f.fname[sz]==':')l= sz+1;
}




sz= strcspn(inmain_f.fname,".");

makefname_x(&(*outmain),".ps","Output",sz);
makefname_x(&(*cfg),".CFG","Configuration",sz);
makefname_x(&(*script),".SCR","Script",sz);


(void)strncat(rfn,inmain_f.fname,
MIN(l+4,pstrlen(inmain_f.fname)));

if((sz= strcspn(rfn,"."))!=0)rfn[sz]= '\0';





if(inmain_f.fname[1]==':')*drive= inmain_f.fname[0];


vstrcat(LENFNAME,zone->fname,rfn,"ZONE",(char*)NULL);


vstrcat(LENFNAME,inage->fname,rfn,"C14",(char*)NULL);


vstrcat(LENFNAME,ints->fname,rfn,"TS",(char*)NULL);


vstrcat(LENFNAME,stat->fname,rfn,"STAT",(char*)NULL);


vstrcat(LENFNAME,dat->fname,rfn,"DAT",(char*)NULL);


vstrcat(LENFNAME,agedep->fname,rfn,"AD",(char*)NULL);


vstrcat(LENFNAME,adplot->fname,rfn,"AD.ps",(char*)NULL);

return;

}

/*:47*//*49:*/
#line 2188 "ppmainx1.w"

void makefname_x
(
file_t*f,
const char*suff,
const char*label,
size_t sz
)

{
(void)strncat(f->fname,inmain_f.fname,sz);
vstrcat(LENFNAME,f->fname,suff,(char*)NULL);
rtn= fprintf(gl.logf.fp,"%s file name: %s\n",label,f->fname);
assert(rtn>0);

return;
}


/*:49*//*51:*/
#line 2213 "ppmainx1.w"

void findtax_x
(
int*nntax,
data_t data,
flag_t*bigtax,
real thresh,
int numtax
)

{
const char*text= 
"Available taxa with values greater than the threshold will be listed "
"below\nIndicate 'Y' or 'N' <Enter> for inclusion of each, 'A' for "
"all, or 'M' for\nall taxa preceding a sum taxon";

flag_t sumflag= OFF;

letter_t s= 0;

loop_t j= 0;
loop_t k= 0;
loop_t kk= 0;

if(thresh>=0)
{
rtn= puts(text);
assert(rtn!=EOF);
}

for(k= 0,kk= 0;k<numtax;k++)
{
if(data.taxname[k][0]=='*')sumflag= ON;
if(sumflag==ON&&s=='M')continue;
for(j= 0;j<data.nsam;j++)
{
if(data.dat[k][j]<(float)fabse(thresh)||data.levfg[j]==OFF)
{
continue;
}

if(thresh<0)s= 'Y';
else if(s!='A'&&s!='M')
{
rtn= printf("%s? ",data.taxname[k]);
assert(rtn>0);
s= ucase(getkey("YNAM"));
}

if(s=='Y'||s=='A'||s=='M')
{
bigtax[k]= ON;
kk++;
}

break;

}

}

*nntax= kk;

rtn= printf("%d taxa selected\n",*nntax);
assert(rtn>0);

return;
}

/*:51*//*53:*/
#line 2287 "ppmainx1.w"

void interp_x
(
data_t*data,
samp_t*lev,
file_t*stat
)

{
flag_t jflag= OFF;

float*inalev= NULL;
flag_t*inlevfg= NULL;
float**indat= NULL;

int firstj= 0;
int innsam= 0;
int i= 0;
int istart= 0;
int j= 0;
int k= 0;
int n1= 0;
int n2= 0;
int ndata= 0;
int maxabove= 0;
int maxbelow= 0;

real a= 0.0;
real b= 0.0;
real ilevint= 0.0;

if(stat->st==OPEN)
{
rtn= fputs("\n\n",stat->fp);
assert(rtn!=EOF);
}


if(lev->intstop<=lev->intstart)
{
lev->intstart= lev->min;
lev->intstop= lev->max;
}


i= 0;
while(i*lev->interp<=lev->intstop)
{
if(i*lev->interp>=lev->intstart)innsam++;
i++;
}

dprint(&(*stat),"Interpolation method is '%s'\n%d interpolated values\n",
lev->inttype==PAIR?"nearest pair":"line fitting",innsam);


inalev= avecfloat(innsam);
inlevfg= avecflag_t(innsam);
indat= amatfloat(data->ntax+EXTRATAXN,innsam);





i= 0;
while((ilevint= i*lev->interp)<=lev->intstop)
{
if(ilevint>=lev->intstart)
{
switch(lev->inttype)
{
case PAIR:
for(j= 0,maxabove= INT_MAX,maxbelow= -INT_MAX,n1= 0,n2= 0;j<data->nsam;j++)
{
if(data->alev[j]-(float)ilevint>=(float)0)
{
if((float)maxabove>data->alev[j]-(float)ilevint)
{
maxabove= (int)(data->alev[j]-ilevint);
n1= j;
}
}
if(data->alev[j]-ilevint<=0)
{
if((float)maxbelow<data->alev[j]-(float)ilevint)
{
maxbelow= (int)(data->alev[j]-ilevint);
n2= j;
}
}
}
inalev[istart]= (float)ilevint;
inlevfg[istart]= ON;
for(k= 0;k<data->ntax+EXTRATAXN;k++)
{
real temp= 0.0;
if(n1==n2)
{
indat[k][istart]= data->dat[k][n1];
}
else
{
temp= (ilevint-data->alev[n2])/
(data->alev[n1]-data->alev[n2]);
indat[k][istart]= data->dat[k][n2]+
(temp*(data->dat[k][n1]-data->dat[k][n2]));
}
}

break;

case LINEFIT:
for(ndata= 0,jflag= OFF,j= 0;j<data->nsam;j++)
{
if(data->alev[j]>=(ilevint-(0.5*lev->interp))
&&data->alev[j]<=(ilevint+(0.5*lev->interp)))
{
ndata++;
if(jflag==OFF)
{
jflag= ON;
firstj= j;
}

}

}
inalev[istart]= (float)ilevint;
inlevfg[istart]= ON;
for(k= 0;k<data->ntax+EXTRATAXN;k++)
{
if(ndata<=1)indat[k][istart]= 1.01*gl.neglev;
else
{
fit(&(data->alev[firstj]),&(data->dat[k][firstj]),ndata,&a,&b);
indat[k][istart]= a+(b*inalev[istart]);
}

}

break;

default:PPERROR(9);

}

istart++;
}
i++;
}


fmatfloat(data->dat,data->ntax+EXTRATAXN);
fvec(data->levfg);
fvec(data->alev);


data->alev= avecfloat(innsam);
data->levfg= avecflag_t(innsam);
data->dat= amatfloat(data->ntax+EXTRATAXN,innsam);


for(j= 0;j<innsam;j++)
{
data->levfg[j]= ON;
data->alev[j]= inalev[j];
for(k= 0;k<data->ntax+EXTRATAXN;k++)
{
data->dat[k][j]= indat[k][j];
}
}


data->nsam= innsam;


fmatfloat(indat,data->ntax+EXTRATAXN);
fvec(inlevfg);
fvec(inalev);

return;
}

/*:53*//*55:*/
#line 2477 "ppmainx1.w"

static int mod_s
(
int i,
int j
)

{
if(j>0)return(i%j);
if(i%abs(j)>0)return(0);
else return(1);
}/*:55*/
