/*2:*/
#line 15 "ppmath.w"

#include "psimpoll.h" 
#include "ppglobal.h" 

/*:2*//*4:*/
#line 24 "ppmath.w"

real atan2e
(
real y,
real x
)

{
double a= 0.0;
errno= 0;
a= (real)atan2((double)y,(double)x);
if(errno)PPERROR(14);
return((real)a);
}

/*:4*//*6:*/
#line 44 "ppmath.w"

real expe
(
real x
)

{
double a= 0.0;
errno= 0;
if(x<-HUGE_EXP)return(0.0);
a= exp((double)x);
if(errno)
{
(void)fprintf(gl.logf.fp,"Attempt to obtain exp of %f\n",x);
PPERROR(21);
}
return((real)a);
}

/*:6*//*8:*/
#line 68 "ppmath.w"

real asine
(
real x
)

{
double a= 0.0;
errno= 0;
a= asin((double)x);
if(errno)PPERROR(18);
return((real)a);
}

/*:8*//*10:*/
#line 87 "ppmath.w"

real atane
(
real x
)

{
double a= 0.0;
errno= 0;
a= atan((double)x);
if(errno)PPERROR(19);
return((real)a);
}

/*:10*//*12:*/
#line 106 "ppmath.w"

real fabse
(
real x
)

{
double a= 0;
a= fabs((double)x);
return((real)a);
}

/*:12*//*14:*/
#line 123 "ppmath.w"

real powe
(
real x,
real y
)

{
double a= 0.0;
errno= 0;
a= pow((double)x,(double)y);
if(errno)PPERROR(20);
return((real)a);
}

/*:14*//*16:*/
#line 143 "ppmath.w"

real tane
(
real x
)

{
double a= 0;
a= tan((double)x);
return((real)a);
}


/*:16*//*18:*/
#line 173 "ppmath.w"

int int1
(
real x
)

{
int n= 0;
if(x>INT_MAX||x<INT_MIN)PPERROR(0);
else if(x>0)n= (int)x;
else if(x<0)n= (int)(x-1);
return(n);
}

int int2
(
real x
)

{
int n= 0;
if(x>INT_MAX||x<INT_MIN)PPERROR(0);
else if(x>0)n= (int)(x+0.5);
else if(x<0)n= (int)(x-0.5);
return(n);
}

long long2
(
real x
)

{
long n= 0;
if(x>LONG_MAX||x<LONG_MIN)PPERROR(0);
else if(x>0)n= (long)(x+0.5);
else if(x<0)n= (long)(x-0.5);
return(n);
}

int int3
(
real x
)

{
int n= 0;
if(x>INT_MAX||x<INT_MIN)PPERROR(0);
else if(x>0)n= (int)x;
else if(x<0)n= (int)(x-0.5);
return(n);
}

int int4
(
real x
)

{
int n= 0;
if(x>INT_MAX||x<INT_MIN)PPERROR(0);
n= (int)(x+0.5);
return(n);
}

/*:18*//*20:*/
#line 243 "ppmath.w"

real loge
(
real x
)

{
double a= 0.0;
errno= 0;
a= log((double)x);
if(errno)
{
(void)fprintf(gl.logf.fp,"Attempt to obtain log of %f\n",x);
PPERROR(11);
}
return((real)a);
}

/*:20*//*22:*/
#line 266 "ppmath.w"

real log10e
(
real x
)

{
double a= 0.0;
errno= 0;
a= log10((double)x);
if(errno)
{
(void)fprintf(gl.logf.fp,"Attempt to obtain log of %f\n",x);
PPERROR(12);
}
return((real)a);
}

/*:22*//*24:*/
#line 289 "ppmath.w"

real sqrte
(
real x
)

{
double a= 0.0;
errno= 0;
assert(x>=0);
a= sqrt((double)x);
if(errno)
{
(void)fprintf(gl.logf.fp,"Attempt to obtain square root of %f\n",x);
PPERROR(10);
}
return((real)a);
}/*:24*/
