/*3:*/
#line 11 "ppmenu.w"

#include "psimpoll.h" 
#include "ppglobal.h" 
#include "ppmenu.h" 
#include "ppscreen.h" 

/*:3*//*4:*/
#line 18 "ppmenu.w"

static char buffer_f[LENSTR2];

/*:4*//*5:*/
#line 22 "ppmenu.w"

const char*entnumline_f= "Enter number <Enter>";
const char*quitline_f= "9 Leave this menu";
const char*switchline_f= "Enter '0' for on, or '1' for off";

const char*sfmt_f= "%-50s[%s]";
const char*dfmt_f= "%-50s[%d]";
const char*gfmt_f= "%-50s[%g]";

/*:5*//*6:*/
#line 32 "ppmenu.w"

const char*rtnline_f= "Q Return to main menu";
const char*const rantext_f[]= 
{
"1 Minimal standard generator",
"2 Combination of three congruential generators",
"3 Single congruential generator",
"4 Subtractive generator",
"5 Pseudo-DES generator",
"6 FSU ULTRA generator",
"7 Quick and dirty generator",
"8 Long-period generator"
};

const int nrantext_f= 8;

const char*const seedtext_f= "Enter new seed (<= 2147483647) or 'TIMER' "
"<Enter> ";

/*:6*//*28:*/
#line 508 "ppmenu.w"

void menu
(
file_t cfg,
frame_t*coll,
file_t*agedep,
file_t*adplot,
file_t*outmain,
caption_t*head,
flag_t*intfg,
age_t*age,
file_t*zone,
file_t*inage,
file_t*ints,
ci_t*ci,
rare_t*rarer,
zoner_t*zoner,
four_t*four,
num_t*num,
roc_t*roc,
file_t*stat,
frame_t*agerange,
file_t*dat,
pca_t*pca,
ca_t*ca,
samp_t*lev,
flag_t*ipdat,
format_t*ipform,
char sunit[12][LENSTR/2],
int nsam,
int ntax,
int argc
)

{
char buffer[5]= "";
/*8:*/
#line 53 "ppmenu.w"

const char*const menustr[18]= 
{
"A Dimensions and scale factors for PostScript plots",
"B Scaling of taxa and samples",
"C Changing colours",
"D Diagram style",
"E Change or enable files",
"F Font family (Helvetica)",
"G Size of selected font ",
"H Depth or age range for plot (off)",
"I Add/change titles",
"J Print dataset to file",
"K Interactive plotting (off)",
"L Conversion of depths to ages",
"M Data analyses",
"N Plot confidence intervals (off)",
"O Save configuration to ",
"P Read from script file (off)",
"U Utilities",
"X Run program"
};

/*:8*/
#line 544 "ppmenu.w"


letter_t s= 0;



pstrcpy(scline_f[MENULINE],menustr[0],SCRWID);
pstrcpy(scline_f[MENULINE+1],menustr[1],SCRWID);
pstrcpy(scline_f[MENULINE+2],
gl.palette.n==0?"  No palette found: colours not available":menustr[2],
SCRWID);
pstrcpy(scline_f[MENULINE+3],menustr[3],SCRWID);
pstrcpy(scline_f[MENULINE+4],menustr[4],SCRWID);
pstrcpy(scline_f[MENULINE+8],menustr[8],SCRWID);
pstrcpy(scline_f[MENULINE+11],menustr[11],SCRWID);
pstrcpy(scline_f[MENULINE+12],menustr[12],SCRWID);
pstrcpy(scline_f[MENULINE+16],menustr[16],SCRWID);
pstrcpy(scline_f[MENULINE+17],menustr[17],SCRWID);

do
{
if((sprintf(buffer,"%g",gl.font.ufac))>5)PPERROR(24);

getfont();

rtn= sprintf(scline_f[MENULINE+5],sfmt_f,menustr[5],gl.font.rom);
assert(rtn>0&&rtn<SCRWID);
rtn= sprintf(scline_f[MENULINE+6],"%s(%.1f)%21s[%s]",menustr[6],
gl.font.fac,"",gl.font.ufac>0?buffer:"");
assert(rtn>0&&rtn<SCRWID);
rtn= sprintf(scline_f[MENULINE+7],sfmt_f,menustr[7],
prnfg(lev->udata));
assert(rtn>0&&rtn<SCRWID);
rtn= sprintf(scline_f[MENULINE+9],"%s",menustr[9]);
assert(rtn>0&&rtn<SCRWID);
rtn= sprintf(scline_f[MENULINE+10],sfmt_f,menustr[10],
prnfg(*intfg));
assert(rtn>0&&rtn<SCRWID);
rtn= sprintf(scline_f[MENULINE+13],sfmt_f,menustr[13],
prnfg(ci->flag));
assert(rtn>0&&rtn<SCRWID);
rtn= sprintf(scline_f[MENULINE+14],"%s%s",menustr[14],cfg.fname);
assert(rtn>0&&rtn<SCRWID);
rtn= sprintf(scline_f[MENULINE+15],sfmt_f,menustr[15],
coll->script==SCRWRITE?"off":"on");
assert(rtn>0&&rtn<SCRWID);

psc(scline_f);

switch(s= (argc==1?ucase(getkey("ABCDEFGHIJKLMNOPUX")):'X'))
{
case'A':
menua_s(menustr[0]);
break;
case'B':
menub_s(menustr[1],&(*coll),&(*lev));
break;
case'C':
if(gl.palette.n!=0)menuc_s(menustr[2],&(*coll),&(*agerange));
break;
case'D':
menud_s(menustr[3],&(*coll),&(*ci));
break;
case'E':
menue_s(menustr[4],&(*outmain),&(*agedep),&(*adplot),&(*stat),
&(*dat),&(*zone),&(*inage),&(*ints));
break;
case'F':
menuf(menustr[5]);
break;
case'G':
menug(menustr[6]);
break;
case'H':
menuh_s(menustr[7],&(*lev));
break;
case'I':
menui_s(menustr[8],&(*head),sunit);
break;
case'J':
menuj_s(menustr[9],&(*ipdat),&(*ipform));
break;
case'K':
if(ntax<=237)toggle(&*intfg);
break;
case'L':
menul_s(menustr[11],&(*head),&(*age));
break;
case'M':
menum_s(menustr[12],&(*num),nsam,ntax,&(*coll),&(*roc),&(*rarer),
&(*zoner),&(*four),&(*zone),&(*pca),&(*ca));
break;
case'N':
menun_s(menustr[13],&(*ci));
break;
case'O':
writecfg_s(cfg,*coll,*agedep,*adplot,*outmain,*head,*agerange,
*intfg,*age,*zone,*inage,*ints,*ci,*rarer,*zoner,*four,
*num,*roc,*stat,*dat,*pca,*ca,*lev,*ipdat,*ipform,sunit);
break;
case'P':
coll->script= (coll->script==SCRWRITE?SCRREAD:SCRWRITE);
break;
case'U':
menuu(menustr[16]);
break;
case'X':
break;

}

}while(s!='X');

return;
}

/*:28*//*30:*/
#line 664 "ppmenu.w"

static void menua_s
(
const char*const menustr
)

{
/*9:*/
#line 77 "ppmenu.w"

const char*aline[]= 
{
"Enter new factor <Enter>",
"Enter new factor <Enter>",
"Enter new length (mm) <Enter>",
"Enter new height (mm) <Enter>"
};

const char*aline1[]= 
{
"a Scale factor for main output file (1.0)",
"b Scale factor for age-depth output file (1.0)",
"c Length of print area (mm) (240)",
"d Height of diagram (mm) (127)",
"e Paper size (A4)"
};

/*:9*/
#line 671 "ppmenu.w"


int n= 0;
int ival[2]= {0,0};
loop_t i= 0;
real aval[2]= {0.0,0.0};
const char*paper[4]= {"A4","A3","Letter","Legal"};

cls(sclineb_f,MENULINE,SCRHT-2);

do
{
aval[0]= gl.page.minpl/0.002;
aval[1]= gl.adpage.minpl/0.002;
ival[0]= int4(gl.page.wide/100);
ival[1]= int4(gl.page.prop*gl.page.high/100);

pstrcpy(sclineb_f[MENULINE],menustr,SCRWID);
for(i= 0;i<2;i++)
{
rtn= sprintf(sclineb_f[MENULINE+1+i],gfmt_f,aline1[i],aval[i],
SCRWID);
assert(rtn>0&&rtn<SCRWID);
}
for(i= 0;i<2;i++)
{
pstrcpy(sclineb_f[MENULINE+3+i],mkstr(dfmt_f,aline1[2+i],ival[i]),
SCRWID);
}

rtn= sprintf(sclineb_f[MENULINE+5],sfmt_f,aline1[4],
paper[(int)gl.paper]);
assert(rtn>0&&rtn<SCRWID);

pstrcpy(sclineb_f[MENULINE+6],quitline_f,SCRWID);
*sclineb_f[MENULINE+8]= '\0';
psc(sclineb_f);

if((n= lcase(getkey("abcde9")))=='9')break;

if(strchr("abcd",n)!=NULL)
{
pstrcpy(sclineb_f[MENULINE+8],aline[n-'a'],SCRWID);
psc(sclineb_f);
}

switch(n)
{
case'a':
gl.page.minpl= getsing(0.1,10)*0.002;
break;
case'b':
gl.adpage.minpl= getsing(0.1,1.0)*0.002;
break;
case'c':
gl.page.wide= getsing(10,420)*100;
gl.page.high= gl.page.wide/(gl.papht/gl.papwid);
break;
case'd':
gl.page.prop= getsing(10,297)*100/gl.page.high;
break;
case'e':
gl.paper++;
if(gl.paper==4)gl.paper= 0;
switch(gl.paper)
{
case A4:
gl.papwid= A4WID;
gl.papht= A4HT;
break;
case A3:
gl.papwid= A3WID;
gl.papht= A3HT;
break;
case LETTER:
gl.papwid= LETTWID;
gl.papht= LETTHT;
break;
case LEGAL:
gl.papwid= LEGWID;
gl.papht= LEGHT;
break;
}
gl.page.wide= 0.8081*gl.papht;
gl.page.high= 0.8081*gl.papwid;
gl.page.prop= 0.75;

}

}while(1);

return;
}


/*:30*//*32:*/
#line 770 "ppmenu.w"

static void menub_s
(
const char*const menustr,
frame_t*coll,
samp_t*lev
)

{
/*10:*/
#line 96 "ppmenu.w"

const char*bline[]= 
{
"a Independent scaling for each taxon (off)",
"b Scaling covers excluded samples (off)",
"c Use defaults for marks on age/depth scale (on)",
"d Use two columns for sum values (off)",
"e Skip every nth sample (0)",
"f Interpolate to constant sample intervals (off)",
"g Threshold for missing data values (-0.99)"
};

const char*b6line[]= 
{
"A Interpolation interval in age-depth units (1)",
"B Start level for interpolation (0)",
"C Stop level for interpolation (0)",
"D Interpolation method (nearest pair)"
};

/*:10*/
#line 779 "ppmenu.w"


int m= 0;
int n= 0;

cls(sclineb_f,MENULINE,SCRHT-2);
cls(sclinec_f,MENULINE,SCRHT-2);

pstrcpy(sclineb_f[MENULINE],menustr,SCRWID);
pstrcpy(sclineb_f[MENULINE+8],quitline_f,SCRWID);

do
{
rtn= sprintf(sclineb_f[MENULINE+1],sfmt_f,bline[0],
prnfg(coll->indscale));
assert(rtn>0&&rtn<SCRWID);
rtn= sprintf(sclineb_f[MENULINE+2],sfmt_f,bline[1],
prnfg(coll->all));
assert(rtn>0&&rtn<SCRWID);
rtn= sprintf(sclineb_f[MENULINE+3],sfmt_f,bline[2],
prnfg(lev->adsc));
rtn= sprintf(sclineb_f[MENULINE+4],sfmt_f,bline[3],
prnfg(coll->sum2col));
assert(rtn>0&&rtn<SCRWID);
rtn= sprintf(sclineb_f[MENULINE+5],dfmt_f,bline[4],coll->skip);
assert(rtn>0&&rtn<SCRWID);
rtn= sprintf(sclineb_f[MENULINE+6],sfmt_f,bline[5],
prnfg(coll->interp));
assert(rtn>0&&rtn<SCRWID);
rtn= sprintf(sclineb_f[MENULINE+7],gfmt_f,bline[6],gl.neglev);
assert(rtn>0&&rtn<SCRWID);

psc(sclineb_f);
if((n= lcase(getkey("abcdefg9")))=='9')break;
switch(n)
{
case'a':
toggle(&coll->indscale);
break;
case'b':
toggle(&coll->all);
break;
case'c':
toggle(&lev->adsc);
if(lev->adsc==OFF)
{
rtn= sprintf(sclineb_f[MENULINE+10],
"Major marks now at intervals of %.3f age-depth units",
lev->majmark);
rtn= sprintf(sclineb_f[MENULINE+11],
"Minor marks now at intervals of %.3f age-depth units",
lev->minmark);

pstrcpy(sclineb_f[MENULINE+12],
"Enter interval between major marks on age-depth axis <Enter>",
SCRWID);
psc(sclineb_f);
lev->majmark= getsing(0,10e7);
pstrcpy(sclineb_f[MENULINE+12],
"Enter interval between minor marks <Enter>",SCRWID);
psc(sclineb_f);
lev->minmark= getsing(0,10e7);
}
break;
case'd':
toggle(&coll->sum2col);
break;
case'e':
do
{
pstrcpy(sclineb_f[MENULINE+11],
"Enter interval between omitted samples (-100 - 100"
" [not -1 or 1]) <Enter>",SCRWID);
psc(sclineb_f);
coll->skip= (int)getsing(-100,100);
if(abs(coll->skip)!=1)break;
}while(1);
break;
case'f':
cls(sclinec_f,MENULINE+2,MENULINE+14);

rtn= sprintf(sclinec_f[MENULINE],sfmt_f,bline[5],
prnfg(coll->interp));
assert(rtn>0&&rtn<SCRWID);
pstrcpy(sclinec_f[MENULINE+2],switchline_f,SCRWID);
psc(sclinec_f);
if((coll->interp= GETFG)==ON)
{
rtn= sprintf(sclinec_f[MENULINE],sfmt_f,bline[5],
prnfg(coll->interp));
assert(rtn>0&&rtn<SCRWID);
pstrcpy(sclinec_f[MENULINE+6],quitline_f,SCRWID);
pstrcpy(sclinec_f[MENULINE+7],rtnline_f,SCRWID);
m= 0;
do
{
rtn= sprintf(sclinec_f[MENULINE+2],gfmt_f,b6line[0],
lev->interp);
assert(rtn>0&&rtn<SCRWID);
rtn= sprintf(sclinec_f[MENULINE+3],gfmt_f,b6line[1],
lev->intstart);
assert(rtn>0&&rtn<SCRWID);
rtn= sprintf(sclinec_f[MENULINE+4],gfmt_f,b6line[2],
lev->intstop);
assert(rtn>0&&rtn<SCRWID);
rtn= sprintf(sclinec_f[MENULINE+5],sfmt_f,b6line[3],
lev->inttype==PAIR?"nearest pair":"fitted line");
assert(rtn>0&&rtn<SCRWID);
psc(sclinec_f);

m= lcase(getkey("ABCD9q"));
if(m=='q')return;
if(m=='9')break;
switch(m)
{
case'a':
pstrcpy(sclinec_f[MENULINE+12],
"Enter interpolation interval in age-depth units <Enter>",
SCRWID);
psc(sclinec_f);
lev->interp= getsing(1,10e7);
break;
case'b':
pstrcpy(sclinec_f[MENULINE+12],
"Enter start (highest) level for interpolation <Enter>",
SCRWID);
psc(sclinec_f);
lev->intstart= getsing(-2000,1e7);
break;
case'c':
pstrcpy(sclinec_f[MENULINE+12],
"Enter stop (lowest) level for interpolation <Enter>",
SCRWID);
psc(sclinec_f);
lev->intstop= getsing(-2000,1e7);
break;
case'd':

lev->inttype= (lev->inttype==PAIR?LINEFIT:PAIR);
break;
}

cls(sclinec_f,MENULINE+10,MENULINE+13);

}while(1);

}

break;

case'g':
pstrcpy(sclineb_f[MENULINE+10],
"Enter new threshold <Enter>",SCRWID);
psc(sclineb_f);
gl.neglev= getsing(-FLT_MAX,0);
break;

}

cls(sclineb_f,MENULINE+10,MENULINE+12);

}while(1);

return;
}


/*:32*//*34:*/
#line 951 "ppmenu.w"

static void menuc_s
(
const char*const menustr,
frame_t*coll,
frame_t*agerange
)

{
/*11:*/
#line 117 "ppmenu.w"

const char*clinemain[]= 
{
"a Output file (main)",
"b Background colour (white)",
"c Foreground colour (black)",
"d Colour of plots (black)",
"e Colour of title (black)",
"f Colour of age-depth axis (black)",
"g Colour of 14C column (black)",
"h Colour of sediment column foreground (black)",
"i Colour of zone column foreground (black)",
"j Colour of x-axes (black)",
"k Use colours for sediment units (on)",
"l Use colours for zones (on)"
};

const char*clinead[]= 
{
"a Output file (main)",
"b Background colour (white)",
"c Colour of main curve (black)",
"d Colour of confidence interval curves (black)",
"e Colour of points (black)",
"f Colour of depth axis (black)",
"g Colour of x-axis (black)"
};

/*:11*/
#line 960 "ppmenu.w"


enum plot_t plottype= MAINP;

int n= 0;
int nlines= 0;

cls(sclineb_f,MENULINE,SCRHT-2);

do
{
if(plottype==MAINP)nlines= 12;
else nlines= 7;
pstrcpy(sclineb_f[MENULINE],menustr,SCRWID);
pstrcpy(sclineb_f[MENULINE+nlines],quitline_f,SCRWID);
rtn= sprintf(sclineb_f[MENULINE],sfmt_f,clinemain[0],
plottype==MAINP?"MAIN":"AGE-DEPTH");
rtn= sprintf(sclineb_f[MENULINE+1],sfmt_f,clinemain[1],
findcolour(gl.palette.back));
assert(rtn>0&&rtn<SCRWID);

if(plottype==MAINP)
{
rtn= sprintf(sclineb_f[MENULINE+2],sfmt_f,clinemain[2],
findcolour(gl.palette.fore));
assert(rtn>0&&rtn<SCRWID);
rtn= sprintf(sclineb_f[MENULINE+3],sfmt_f,clinemain[3],
findcolour(coll->colpl));
assert(rtn>0&&rtn<SCRWID);
rtn= sprintf(sclineb_f[MENULINE+4],sfmt_f,clinemain[4],
findcolour(coll->coltit));
assert(rtn>0&&rtn<SCRWID);
rtn= sprintf(sclineb_f[MENULINE+5],sfmt_f,clinemain[5],
findcolour(coll->coldep));
assert(rtn>0&&rtn<SCRWID);
rtn= sprintf(sclineb_f[MENULINE+6],sfmt_f,clinemain[6],
findcolour(coll->col14c));
assert(rtn>0&&rtn<SCRWID);
rtn= sprintf(sclineb_f[MENULINE+7],sfmt_f,clinemain[7],
findcolour(coll->colts));
assert(rtn>0&&rtn<SCRWID);
rtn= sprintf(sclineb_f[MENULINE+8],sfmt_f,clinemain[8],
findcolour(coll->colzone));
assert(rtn>0&&rtn<SCRWID);
rtn= sprintf(sclineb_f[MENULINE+9],sfmt_f,clinemain[9],
findcolour(coll->colxax));
assert(rtn>0&&rtn<SCRWID);
rtn= sprintf(sclineb_f[MENULINE+10],sfmt_f,clinemain[10],
prnfg(gl.colts));
assert(rtn>0&&rtn<SCRWID);
rtn= sprintf(sclineb_f[MENULINE+11],sfmt_f,clinemain[11],
prnfg(gl.colzone));
assert(rtn>0&&rtn<SCRWID);
}
else if(plottype==ADP)
{
rtn= sprintf(sclineb_f[MENULINE+2],sfmt_f,clinead[2],
findcolour(agerange->colpl));
assert(rtn>0&&rtn<SCRWID);
rtn= sprintf(sclineb_f[MENULINE+3],sfmt_f,clinead[3],
findcolour(agerange->colsdpl));
assert(rtn>0&&rtn<SCRWID);
rtn= sprintf(sclineb_f[MENULINE+4],sfmt_f,clinead[4],
findcolour(agerange->col14c));
assert(rtn>0&&rtn<SCRWID);
rtn= sprintf(sclineb_f[MENULINE+5],sfmt_f,clinead[5],
findcolour(agerange->coldep));
assert(rtn>0&&rtn<SCRWID);
rtn= sprintf(sclineb_f[MENULINE+6],sfmt_f,clinead[6],
findcolour(agerange->colxax));
assert(rtn>0&&rtn<SCRWID);
}

psc(sclineb_f);
if((n= lcase(getkey(plottype==MAINP?"abcdefghijkl9":"abcdefg9")))=='9')break;
if(n!='k'&&n!='l')
{
pstrcpy(sclineb_f[MENULINE+nlines+2],
"Enter colour name <Enter>",SCRWID);
}
psc(sclineb_f);
switch(n)
{
case'a':
if(plottype==MAINP)plottype= ADP;
else plottype= MAINP;
break;
case'b':
gl.palette.back= findcolourid(getstr(LENTAXN));
break;
case'c':
if(plottype==MAINP)gl.palette.fore= findcolourid(getstr(LENTAXN));
else agerange->colpl= findcolourid(getstr(LENTAXN));
break;
case'd':
if(plottype==MAINP)coll->colpl= findcolourid(getstr(LENTAXN));
else agerange->colsdpl= findcolourid(getstr(LENTAXN));
break;
case'e':
if(plottype==MAINP)coll->coltit= findcolourid(getstr(LENTAXN));
else agerange->col14c= findcolourid(getstr(LENTAXN));
break;
case'f':
if(plottype==MAINP)coll->coldep= findcolourid(getstr(LENTAXN));
else agerange->coldep= findcolourid(getstr(LENTAXN));
break;
case'g':
if(plottype==MAINP)coll->col14c= findcolourid(getstr(LENTAXN));
else agerange->colxax= findcolourid(getstr(LENTAXN));
break;
case'h':
if(plottype==MAINP)coll->colts= findcolourid(getstr(LENTAXN));
break;
case'i':
if(plottype==MAINP)coll->colzone= findcolourid(getstr(LENTAXN));
break;
case'j':
if(plottype==MAINP)coll->colxax= findcolourid(getstr(LENTAXN));
break;
case'k':
toggle(&gl.colts);
break;
case'l':
toggle(&gl.colzone);
break;
}

cls(sclineb_f,MENULINE,MENULINE+nlines+4);

}while(1);

return;
}


/*:34*//*36:*/
#line 1100 "ppmenu.w"

static void menud_s
(
const char*const menustr,
frame_t*coll,
ci_t*ci
)

{
/*12:*/
#line 146 "ppmenu.w"

const char*dline[]= 
{
"a <Experimental> Tufte style (off)",
"b Diagram type (outline)",
"c x10 exaggeration (off)",
"d Shade of grey for filling plots (0)",
"e Angle of rotation for taxa names (45)",
"f Join-up across missing levels (off)",
"g Width of bars for histograms (0)",
"h Place a dot next to low values (off)",
"i Upper value for placing dot (0.5)",
"j Include radiocarbon age locations (on)",
"k Factor to adjust width of lines (1)"
};

const char*dline3[]= 
{
"Enter a value for the grey shade",
"0 = black -> 1 = white"
};

const char*dline4= "Enter new angle <Enter>";
const char*dline6= 
"Enter a value for width of histogram bars (same units as the age/depth axis)";
const char*dline10= "Enter new factor <Enter>";

/*:12*/
#line 1109 "ppmenu.w"

letter_t n= 0;
loop_t i= 0;

cls(sclineb_f,MENULINE,SCRHT-2);

pstrcpy(sclineb_f[MENULINE],menustr,SCRWID);
pstrcpy(sclineb_f[MENULINE+12],quitline_f,SCRWID);

do
{
rtn= sprintf(sclineb_f[MENULINE+1],sfmt_f,dline[0],
prnfg(gl.tufte));
assert(rtn>0&&rtn<SCRWID);
rtn= sprintf(sclineb_f[MENULINE+2],sfmt_f,dline[1],
coll->style==OUTL?"outline":"filled");
assert(rtn>0&&rtn<SCRWID);
rtn= sprintf(sclineb_f[MENULINE+3],sfmt_f,dline[2],
prnfg(coll->ix10));
assert(rtn>0&&rtn<SCRWID);
rtn= sprintf(sclineb_f[MENULINE+4],gfmt_f,dline[3],coll->shade);
assert(rtn>0&&rtn<SCRWID);
rtn= sprintf(sclineb_f[MENULINE+5],dfmt_f,dline[4],coll->rot);
assert(rtn>0&&rtn<SCRWID);
rtn= sprintf(sclineb_f[MENULINE+6],sfmt_f,dline[5],
prnfg(coll->join));
assert(rtn>0&&rtn<SCRWID);
rtn= sprintf(sclineb_f[MENULINE+7],gfmt_f,dline[6],coll->hist);
assert(rtn>0&&rtn<SCRWID);
rtn= sprintf(sclineb_f[MENULINE+8],sfmt_f,dline[7],
prnfg(coll->bull));
assert(rtn>0&&rtn<SCRWID);
rtn= sprintf(sclineb_f[MENULINE+9],gfmt_f,dline[8],coll->lval);
assert(rtn>0&&rtn<SCRWID);
rtn= sprintf(sclineb_f[MENULINE+10],sfmt_f,dline[9],
prnfg(coll->c14scale));
rtn= sprintf(sclineb_f[MENULINE+11],gfmt_f,dline[10],coll->penwid);

psc(sclineb_f);

if((n= lcase(getkey("abcdefghijk9")))=='9')break;
switch(n)
{
case'a':
toggle(&gl.tufte);
if(gl.tufte==ON)ci->flag= ON;
else ci->flag= OFF;
break;
case'b':

coll->style= (coll->style==OUTL?FILL:OUTL);
break;
case'c':
toggle(&coll->ix10);
break;
case'd':
for(i= 0;i<2;i++)
{
pstrcpy(sclineb_f[MENULINE+13+i],dline3[i],SCRWID);
}
psc(sclineb_f);
coll->shade= getsing(0,1);
coll->style= FILL;
break;
case'e':
pstrcpy(sclineb_f[MENULINE+13],dline4,SCRWID);
psc(sclineb_f);
coll->rot= (int)(getsing(0,90)+0.5);
break;
case'f':
toggle(&coll->join);
break;
case'g':
pstrcpy(sclineb_f[MENULINE+13],dline6,SCRWID);
psc(sclineb_f);
coll->hist= getsing(0,1000);
if(coll->hist>0)coll->curve= HIST;
break;
case'h':
toggle(&coll->bull);
break;
case'i':
rtn= sprintf(sclineb_f[MENULINE+13],
"Enter upper value for plotting a dot (%s)",
gl.code.dat=='%'?"percentage units":"same units as dataset");
assert(rtn>0&&rtn<SCRWID);
psc(sclineb_f);
coll->lval= getsing(0,1e6);
coll->bull= ON;
break;
case'j':
toggle(&coll->c14scale);
break;
case'k':
rtn= sprintf(sclineb_f[MENULINE+13],dline10,SCRWID);
assert(rtn>0&&rtn<SCRWID);
psc(sclineb_f);
coll->penwid= getsing(0,100);
break;

}

cls(sclineb_f,MENULINE+13,MENULINE+14);

}while(1);

return;
}


/*:36*//*38:*/
#line 1226 "ppmenu.w"

static void menue_s
(
const char*const menustr,
file_t*outmain,
file_t*agedep,
file_t*adplot,
file_t*stat,
file_t*dat,
file_t*zone,
file_t*inage,
file_t*ints
)

{
/*13:*/
#line 174 "ppmenu.w"

const char*const fnametext[]= 
{
"a Main PostScript output file",
"b Output file for age-depth conversion",
"c Output file for data analyses",
"d Input file with zone details",
"e Input file with 14C ages",
"f Input file with sediment description",
"g Output file for data",
"h PostScript output file for age-depth plot"
};
const char*const s= "Enter new filename (including drive and path) <Enter> ";

/*:13*/
#line 1241 "ppmenu.w"


char*pstr[9]= 
{
NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL
};

int i= 0;
int nfile= 8;
letter_t n= 0;

buffer_f[0]= '\0';

pstr[0]= outmain->fname;
pstr[1]= agedep->fname;
pstr[2]= stat->fname;
pstr[3]= zone->fname;
pstr[4]= inage->fname;
pstr[5]= ints->fname;
pstr[6]= dat->fname;
pstr[7]= adplot->fname;

cls(sclineb_f,MENULINE,SCRHT-2);

pstrcpy(sclineb_f[MENULINE],menustr,SCRWID);
pstrcpy(sclineb_f[MENULINE+nfile+1],quitline_f,SCRWID);

do
{
for(i= 0;i<nfile;i++)
{

pstrcpy(buffer_f,pstr[i],25);
rtn= sprintf(sclineb_f[MENULINE+1+i],sfmt_f,fnametext[i],
buffer_f);
assert(rtn>0&&rtn<SCRWID);
}
*sclineb_f[MENULINE+nfile+3]= '\0';

psc(sclineb_f);

if((n= lcase(getkey("abcdefgh9")))=='9')break;
pstrcpy(sclineb_f[MENULINE+nfile+3],s,SCRWID);

psc(sclineb_f);
pstrcpy(pstr[n-'a'],getstr(LENFNAME),LENFNAME);

if(n=='d')gl.flag[ZONE]= ON;
if(n=='e')gl.flag[C14]= ON;
if(n=='f')gl.flag[TS]= ON;

}while(1);

return;
}


/*:38*//*40:*/
#line 1302 "ppmenu.w"

void menuf
(
const char*const menustr
)

{
/*14:*/
#line 189 "ppmenu.w"

const char*fline[]= 
{
"Serif fonts:",
"Sans serif fonts:",
"B ITC Bookman",
"A ITC AvantGarde",
"C Courier",
"H Helvetica",
"N New Century Schoolbook",
"E Helvetica Narrow",
"P Palatino",
"",
"T Times",
""
};

/*:14*/
#line 1309 "ppmenu.w"

loop_t i= 0;

cls(sclineb_f,MENULINE,SCRHT-2);

rtn= sprintf(sclineb_f[MENULINE],sfmt_f,menustr,gl.font.rom);
assert(rtn>0&&rtn<SCRWID);

for(i= 0;i<11;i+= 2)
{
rtn= sprintf(sclineb_f[MENULINE+2+i/2],"%-50s%s",fline[i],
fline[i+1]);
assert(rtn>0&&rtn<SCRWID);
}
pstrcpy(sclineb_f[MENULINE+9],"Enter letter indicating new font name",
SCRWID);
assert(rtn>0&&rtn<SCRWID);
psc(sclineb_f);

gl.font.code= ucase(getkey("ABCEHNPT"));

return;
}


/*:40*//*42:*/
#line 1338 "ppmenu.w"

void menug
(
const char*const menustr
)

{
/*16:*/
#line 233 "ppmenu.w"

const char*gline[]= 
{
"May cause text and diagram to overlap",
"Enter new font size (units of 1/72 inches) <Enter>"
};

/*:16*/
#line 1345 "ppmenu.w"

char buffer[5]= "";

loop_t i= 0;

sprintf(buffer,"%g",gl.font.ufac);

cls(sclineb_f,MENULINE,SCRHT-2);

rtn= sprintf(sclineb_f[MENULINE],
"%s(%.1f)%21s[%s]",menustr,gl.font.fac,"",
gl.font.ufac>0?buffer:"");
assert(rtn>0&&rtn<SCRWID);

for(i= 0;i<2;i++)
{
pstrcpy(sclineb_f[MENULINE+1+i],gline[i],SCRWID);
}
psc(sclineb_f);
gl.font.ufac= getsing(0,36);

return;
}


/*:42*//*44:*/
#line 1375 "ppmenu.w"

static void menuh_s
(
const char*const menustr,
samp_t*lev
)

{
/*17:*/
#line 241 "ppmenu.w"

const char*hline[]= 
{
"Minimum value for depth or age on plots",
"Maximum value for depth or age on plots"
};

/*:17*/
#line 1383 "ppmenu.w"

int i= 0;

for(;;)
{
cls(sclineb_f,MENULINE,SCRHT-2);
rtn= sprintf(sclineb_f[MENULINE],sfmt_f,menustr,prnfg(lev->udata));
assert(rtn>0&&rtn<SCRWID);
pstrcpy(sclineb_f[MENULINE+2],switchline_f,SCRWID);
psc(sclineb_f);

if(GETINT("01")-1==0)lev->udata= OFF;
else lev->udata= ON;

if(lev->udata==OFF)break;
else
{
pstrcpy(sclineb_f[MENULINE+6],entnumline_f,SCRWID);
i= 0;
do
{
rtn= sprintf(sclineb_f[MENULINE+2],gfmt_f,hline[0],lev->umin);
assert(rtn>0&&rtn<SCRWID);
if(i==0)
{
psc(sclineb_f);
lev->umin= getsing(-2000,1e7);
}
else
{
rtn= sprintf(sclineb_f[MENULINE+3],gfmt_f,hline[1],
lev->umax);
assert(rtn>0&&rtn<SCRWID);
psc(sclineb_f);
lev->umax= getsing(-2000,1e7);
}

i++;

}while(i<2);

}

if(lev->umax>lev->umin)break;
else
{
rtn= fprintf(stderr,"Maximum value is less than minimum value!\n");
assert(rtn>0);
lev->udata= OFF;
dlay();
}

}

return;
}


/*:44*//*46:*/
#line 1447 "ppmenu.w"

static void menui_s
(
const char*const menustr,
caption_t*head,
char sunit[12][LENSTR/2]
)

{
/*18:*/
#line 249 "ppmenu.w"

const char*iline= "k Modify graph unit labels";
const char*iline8[]= 
{
"A Concentration (volume) units",
"B Concentration (weight) units",
"C Accumulation rate units",
"D Charcoal concentration units (volume)",
"E Charcoal accumulation rate units",
"F Charcoal concentration units (weight)",
"G Charcoal:pollen units",
"H Rate of change units",
"I Ratio label",
"J Fourier output values",
"9 Leave this menu"
};

char text[10][40]= 
{
"a Label for base of diagram ",
"b Subtitle ",
"c Zonation heading ",
"d Sediment column heading ",
"e Age location column heading ",
"f Age-depth column heading (line 1) ",
"g Age-depth column heading (line 2) ",
"h Timescale column heading ",
"i Age depth plot x-axis",
"j Age depth plot y-axis"
};

/*:18*/
#line 1456 "ppmenu.w"

char*pstr[10];

int n= 0;
int nlab= 10;
int s= 0;

loop_t i= 0;
loop_t k= 0;

buffer_f[0]= '\0';

pstr[0]= head->base;
pstr[1]= head->subtitle;
pstr[2]= head->zone;
pstr[3]= head->sed;
pstr[4]= head->c14;
pstr[5]= head->ps1;
pstr[6]= head->ps2;
pstr[7]= head->time;
pstr[8]= head->adxaxis;
pstr[9]= head->adyaxis;

cls(sclineb_f,MENULINE,SCRHT-2);

pstrcpy(sclineb_f[MENULINE],menustr,SCRWID);
pstrcpy(sclineb_f[MENULINE+nlab+1],iline,SCRWID);
pstrcpy(sclineb_f[MENULINE+nlab+2],quitline_f,SCRWID);

do
{
for(k= 0;k<nlab;k++)
{

pstrcpy(buffer_f,pstr[k],25);
rtn= sprintf(sclineb_f[MENULINE+k+1],sfmt_f,text[k],buffer_f);
assert(rtn>0&&rtn<SCRWID);
}

psc(sclineb_f);

if((n= lcase(getkey("abcdefghijk9")))=='9')break;
n-= 'a';
if(n!=10)
{
*text[n]= (char)lcase(text[n][0]);
rtn= sprintf(sclineb_f[MENULINE+nlab+4],"Enter '%s' <Enter>",
text[n]+2);
assert(rtn>0&&rtn<SCRWID);
if(pstrlen(pstr[n])>25)
{
pstrcpy(sclineb_f[MENULINE+nlab+5],pstr[n],SCRWID);
}
psc(sclineb_f);
pstrcpy(pstr[n],getstr(n==0?LENSTR2:LENSTR),
n==0?LENSTR2:LENSTR);
cls(sclineb_f,MENULINE+nlab+4,MENULINE+nlab+5);
}

else if(n==10)
{
cls(sclinec_f,MENULINE,SCRHT-2);
s= 0;
for(;;)
{
for(i= 0;i<10;i++)
{
rtn= sprintf(sclinec_f[MENULINE+i],sfmt_f,iline8[i],sunit[i]);
assert(rtn>0&&rtn<SCRWID);
}
pstrcpy(sclinec_f[MENULINE+10],iline8[10],SCRWID);

psc(sclinec_f);
if((s= lcase(getkey("abcdefghij9")))=='9')break;
rtn= sprintf(sclinec_f[MENULINE+12],"%c: enter new units",ucase(s));
assert(rtn>0&&rtn<SCRWID);
psc(sclinec_f);
pstrcpy(sunit[s-'a'],getstr(LENSTR/2),LENSTR/2);
*sclinec_f[MENULINE+12]= '\0';

}

}

}while(1);

return;
}


/*:46*//*48:*/
#line 1550 "ppmenu.w"

static void menuj_s
(
const char*const menustr,
flag_t*ipdat,
format_t*ipform
)

{
/*19:*/
#line 281 "ppmenu.w"

const char*jline[]= 
{
"a Print dataset to file (off)",
"b Specify format of output"
};

const char*j2line[]= 
{
"1 psimpoll",
"2 wacalib",
"Select format"
};
const int nj2line= 3;

const char*pformat[]= 
{
"psimpoll",
"wacalib"
};


/*:19*/
#line 1559 "ppmenu.w"


int n= 0;

loop_t i= 0;

cls(sclineb_f,MENULINE,23);

pstrcpy(sclineb_f[MENULINE],menustr,SCRWID);
pstrcpy(sclineb_f[MENULINE+3],quitline_f,SCRWID);

do
{
rtn= sprintf(sclineb_f[MENULINE+1],sfmt_f,jline[0],
prnfg(*ipdat));
assert(rtn>0&&rtn<SCRWID);
rtn= sprintf(sclineb_f[MENULINE+2],sfmt_f,jline[1],
pformat[*ipform]);
assert(rtn>0&&rtn<SCRWID);
psc(sclineb_f);
if((n= lcase(getkey("ab9")))=='9')break;
switch(n)
{
case'a':
toggle(&(*ipdat));
break;
case'b':
for(i= 0;i<nj2line;i++)
{
pstrcpy(sclineb_f[MENULINE+6+i],j2line[i],SCRWID);
}
psc(sclineb_f);
switch(GETINT("12"))
{
case 1:
*ipform= PSIMPOLL;
break;
case 2:
*ipform= CORNELL;
break;
}
break;

}

cls(sclineb_f,MENULINE+6,MENULINE+10);

}while(1);

return;

}


/*:48*//*50:*/
#line 1617 "ppmenu.w"

static void menul_s
(
const char*const menustr,
caption_t*head,
age_t*age
)

{
/*20:*/
#line 304 "ppmenu.w"

const char*lline[]= 
{
"a Plot diagram against depth or age (depth)",
"b Specify an age for the top sample",
"c Specify an age for the basal sample",
"d Select an age model",
"e Select number of terms for age model",
"f Change laboratory error multiplier (1.00)",
"g Include timescale with depth axis (off)",
"h Convert all ages to AD-BC scale (off)",
};

const char*l1line= 
"Data are surface samples: conversion to ages is not possible";
const char*l2a3line[]= 
{
"Enter age <Enter>",
"Enter error estimate <Enter>"
};
const char*l4line[]= 
{
"1 Linear interpolation between dates",
"2 Cubic spline interpolation",
"3 General linear line-fitting by weighted least-squares",
"4 General linear line-fitting by singular value decomposition",
"5 Line-fitting by Bernshtein polynomial",
"Enter age model"
};
const int nl4line= 6;

const char*l5line= "Enter number of terms (0, >= 2) <Enter>";
const char*l6line= "Enter new error multiplier";

/*:20*/
#line 1626 "ppmenu.w"

const char*pmfmt= "%g+/-%g";

flag_t ageflag= OFF;

int n= 0;

loop_t i= 0;

cls(sclineb_f,MENULINE,23);

pstrcpy(sclineb_f[MENULINE],menustr,SCRWID);
pstrcpy(sclineb_f[MENULINE+9],quitline_f,SCRWID);

do
{
rtn= sprintf(sclineb_f[MENULINE+1],sfmt_f,lline[0],
age->flag==OFF?"depth":"age");
assert(rtn>0&&rtn<SCRWID);
rtn= sprintf(sclineb_f[MENULINE+2],sfmt_f,lline[1],
mkstr(pmfmt,age->up,age->upsd));
assert(rtn>0&&rtn<SCRWID);
rtn= sprintf(sclineb_f[MENULINE+3],sfmt_f,lline[2],
age->base==0?"":mkstr(pmfmt,age->base,age->basesd));
assert(rtn>0&&rtn<SCRWID);
rtn= sprintf(sclineb_f[MENULINE+4],dfmt_f,lline[3],age->model);
assert(rtn>0&&rtn<SCRWID);
rtn= sprintf(sclineb_f[MENULINE+5],dfmt_f,lline[4],age->nterm);
assert(rtn>0&&rtn<SCRWID);
rtn= sprintf(sclineb_f[MENULINE+6],gfmt_f,lline[5],
age->c14k);
assert(rtn>0&&rtn<SCRWID);
rtn= sprintf(sclineb_f[MENULINE+7],sfmt_f,lline[6],
prnfg(age->timx));
rtn= sprintf(sclineb_f[MENULINE+8],sfmt_f,lline[7],
prnfg(age->adbc));
assert(rtn>0&&rtn<SCRWID);

psc(sclineb_f);
if((n= lcase(getkey("abcdefgh9")))=='9')break;
switch(n)
{
case'a':
if(age->flag==ON&&(gl.code.yax=='S'||gl.code.yax=='T'))
{

rtn= puts(l1line);
assert(rtn!=EOF);
}
else toggle(&age->flag);

if(age->flag==OFF)ageflag= ON;
else
{
age->timx= OFF;
gl.code.yax= 'A';
gl.flag[TS]= OFF;
pstrcpy(head->ps1,"Age",LENSTR);
if(age->adbc==OFF)pstrcpy(head->ps2,"yr BP",LENSTR);
else pstrcpy(head->ps2,"yr AD/BC",LENSTR);
}
break;
case'b':
pstrcpy(sclineb_f[MENULINE+11],l2a3line[0],SCRWID);
psc(sclineb_f);
age->up= getsing(-10000,1e5);
pstrcpy(sclineb_f[MENULINE+12],l2a3line[1],SCRWID);
psc(sclineb_f);
age->upsd= getsing(0,2000);
break;
case'c':
pstrcpy(sclineb_f[MENULINE+11],l2a3line[0],SCRWID);
psc(sclineb_f);
age->base= getsing(0,1e7);
pstrcpy(sclineb_f[MENULINE+12],l2a3line[1],SCRWID);
psc(sclineb_f);
age->basesd= getsing(0,20000);
break;
case'd':
for(i= 0;i<nl4line;i++)
{
pstrcpy(sclineb_f[MENULINE+11+i],l4line[i],SCRWID);
}
psc(sclineb_f);
age->model= GETINT("12345");
break;
case'e':
pstrcpy(sclineb_f[MENULINE+11],l5line,SCRWID);
for(;;)
{
psc(sclineb_f);
age->nterm= (int)(getsing(0,12)+0.5);
if(age->nterm!=1)break;
}
break;
case'f':
pstrcpy(sclineb_f[MENULINE+11],l6line,SCRWID);
psc(sclineb_f);
age->c14k= getsing(0,5);
break;
case'g':
toggle(&age->timx);
age->flag= OFF;
ageflag= ON;
break;
case'h':
toggle(&age->adbc);
pstrcpy(head->ps2,"yr AD/BC",LENSTR);
break;

}

cls(sclineb_f,MENULINE+11,MENULINE+16);


if(ageflag==ON)
{
gl.code.yax= 'D';
gl.flag[TS]= ON;
pstrcpy(head->ps1,"Depth",LENSTR);
pstrcpy(head->ps2,"cm",LENSTR);
}

}while(1);

return;
}


/*:50*//*52:*/
#line 1762 "ppmenu.w"

static void menum_s
(
const char*const menustr,
num_t*num,
int nsam,
int ntax,
frame_t*coll,
roc_t*roc,
rare_t*rarer,
zoner_t*zoner,
four_t*four,
file_t*zone,
pca_t*pca,
ca_t*ca
)

{
/*21:*/
#line 339 "ppmenu.w"

const char*mline[]= 
{
"a Rate-of-change analysis (off)",
"b Rarefaction analysis (off)",
"c Zonation (off)",
"d Principal components analysis (off)",
"e Correspondence analysis (off)",
"f Fourier analysis (off)",
"g Statistical description of data (off)",
"h Independent splitting of taxa (off)",
"i Minimum value for inclusion of a taxon",
"j Recalculation of dataset proportions (on)"
};

const char*m02line[]= 
{
"Enter number of points for smoothing",
"(a small, odd, number e.g., 3 or 5, or 0 to disable)"
};

const char*m1line[]= 
{
"1 Dissimilarity measure (1)",
"2 Smoothing parameter (0)",
"3 Modelling of rate of change (off)"
};
const char*m2line[]= 
{
"1 Number of zones wanted",
"2 Method for obtaining zones",
"3 Name for output file with zone details",
"4 Prefix for zone labels",
"5 Data transformation",
"6 Use a randomized dataset (off)",
"7 Modelling of zonation (off)"
};
const char*m21line= "Enter number of zones <Enter>";

const char*m22line[]= 
{
"1 Binary splitting by sums-of-squares",
"2 Binary splitting by information content",
"3 Optimal splitting by sums-of-squares",
"4 Optimal splitting by information content",
"5 Constrained cluster analysis (CONISS)",
"Enter method"
};
const int nm22line= 6;

const char*m23line= "Enter new filename <Enter>";
const char*m24line= "Enter new label prefix <Enter>";
const char*m3line[]= 
{
"1 Specify the matrix to use",
"2 Specify the number of axes for output",
"3 Data transformation",
"4 Modelling of pca (off)"
};

const char*m31line[]= 
{
"1 Linear correlation",
"2 Rank correlation",
"3 Covariance"
};

const char*m4line[]= 
{
"a Detrended correspondence analysis (off)",
"b Downweighting of rare types (off)",
"c Rescaling of axes (off)",
"d Number of times to rescale axes",
"e Rescaling threshold",
"f Number of segments",
"g Data transformation",
"h Modelling of ca (off)"
};

/*:21*/
#line 1780 "ppmenu.w"

int m= 0;
int n= 0;
loop_t i= 0;

cls(sclineb_f,MENULINE,SCRHT-2);
cls(sclinec_f,MENULINE,SCRHT-2);

pstrcpy(sclineb_f[MENULINE],menustr,SCRWID);
pstrcpy(sclineb_f[MENULINE+11],quitline_f,SCRWID);

do
{
rtn= sprintf(sclineb_f[MENULINE+1],sfmt_f,mline[0],
prnfg(roc->flag));
assert(rtn>0&&rtn<SCRWID);
rtn= sprintf(sclineb_f[MENULINE+2],sfmt_f,mline[1],
prnfg(rarer->flag));
assert(rtn>0&&rtn<SCRWID);
rtn= sprintf(sclineb_f[MENULINE+3],sfmt_f,mline[2],
prnfg(zoner->flag));
assert(rtn>0&&rtn<SCRWID);
rtn= sprintf(sclineb_f[MENULINE+4],sfmt_f,mline[3],
prnfg(pca->flag));
assert(rtn>0&&rtn<SCRWID);
rtn= sprintf(sclineb_f[MENULINE+5],sfmt_f,mline[4],
prnfg(ca->flag));
assert(rtn>0&&rtn<SCRWID);
rtn= sprintf(sclineb_f[MENULINE+6],sfmt_f,mline[5],
prnfg(four->flag));
assert(rtn>0&&rtn<SCRWID);
rtn= sprintf(sclineb_f[MENULINE+7],sfmt_f,mline[6],
prnfg(num->stat));
assert(rtn>0&&rtn<SCRWID);
rtn= sprintf(sclineb_f[MENULINE+8],sfmt_f,mline[7],
prnfg(coll->indspl));
assert(rtn>0&&rtn<SCRWID);
rtn= sprintf(sclineb_f[MENULINE+9],gfmt_f,mline[8],
num->thresh);
assert(rtn>0&&rtn<SCRWID);
rtn= sprintf(sclineb_f[MENULINE+10],sfmt_f,mline[9],
prnfg(gl.recalc));
assert(rtn>0&&rtn<SCRWID);

psc(sclineb_f);

if((n= lcase(getkey("abcdefghij9")))=='9')break;
cls(sclinec_f,MENULINE,SCRHT-2);
pstrcpy(sclinec_f[MENULINE+2],switchline_f,SCRWID);
switch(n)
{
case'a':
rtn= sprintf(sclinec_f[MENULINE],sfmt_f,mline[0],
prnfg(roc->flag));
assert(rtn>0&&rtn<SCRWID);
psc(sclinec_f);

if((roc->flag= GETFG)==ON)
{
rtn= sprintf(sclinec_f[MENULINE],sfmt_f,mline[0],
prnfg(roc->flag));
assert(rtn>0&&rtn<SCRWID);
m= 0;
cls(sclinec_f,MENULINE+2,SCRHT-2);

for(;;)
{
rtn= sprintf(sclinec_f[MENULINE+2],dfmt_f,m1line[0],
roc->diss);
assert(rtn>0&&rtn<SCRWID);
rtn= sprintf(sclinec_f[MENULINE+3],dfmt_f,m1line[1],
roc->smooth);
assert(rtn>0&&rtn<SCRWID);
rtn= sprintf(sclinec_f[MENULINE+4],sfmt_f,m1line[2],
prnfg(roc->model.ci));
assert(rtn>0&&rtn<SCRWID);

pstrcpy(sclinec_f[MENULINE+5],quitline_f,SCRWID);
pstrcpy(sclinec_f[MENULINE+6],rtnline_f,SCRWID);
psc(sclinec_f);
m= lcase(getkey("1239q"));
if(m=='q')return;
if((m-= '0')==9)break;
switch(m)
{
case 1:
for(i= 0;i<8;i++)
{
rtn= sprintf(sclinec_f[MENULINE+8+i],"%d %s",i+1,
roc->text[i+1]);
assert(rtn>0&&rtn<SCRWID);
}
pstrcpy(sclinec_f[MENULINE+16],entnumline_f,SCRWID);
psc(sclinec_f);
roc->diss= GETINT("12345678");
break;
case 2:
for(i= 0;i<2;i++)
{
pstrcpy(sclinec_f[MENULINE+8+i],m02line[i],SCRWID);
}
psc(sclinec_f);
roc->smooth= GETINT("03579");
break;
case 3:
if(modelmenu_s(&roc->model)!=0)return;
break;

}

cls(sclinec_f,MENULINE+8,MENULINE+16);

}

}

break;

case'b':
rtn= sprintf(sclinec_f[MENULINE],sfmt_f,mline[1],
prnfg(rarer->flag));
assert(rtn>0&&rtn<SCRWID);
psc(sclinec_f);
if((rarer->flag= GETFG)==ON)
{
rtn= sprintf(sclinec_f[MENULINE],sfmt_f,mline[1],
prnfg(rarer->flag));
assert(rtn>0&&rtn<SCRWID);
rtn= sprintf(sclinec_f[MENULINE+2],dfmt_f,
"Specify the count size for standardization",rarer->n);
assert(rtn>0&&rtn<SCRWID);
pstrcpy(sclinec_f[MENULINE+3],entnumline_f,SCRWID);
psc(sclinec_f);
rarer->n= (int)getsing(0,1000);
}

break;

case'c':
rtn= sprintf(sclinec_f[MENULINE],sfmt_f,mline[2],
prnfg(zoner->flag));
assert(rtn>0&&rtn<SCRWID);
psc(sclinec_f);
if((zoner->flag= GETFG)==ON)
{

rtn= sprintf(sclinec_f[MENULINE],sfmt_f,mline[2],
prnfg(zoner->flag));
assert(rtn>0&&rtn<SCRWID);
pstrcpy(sclinec_f[MENULINE+9],quitline_f,SCRWID);
pstrcpy(sclinec_f[MENULINE+10],rtnline_f,SCRWID);
m= 0;
do
{
rtn= sprintf(sclinec_f[MENULINE+2],dfmt_f,m2line[0],
zoner->n);
assert(rtn>0&&rtn<SCRWID);
rtn= sprintf(sclinec_f[MENULINE+3],dfmt_f,m2line[1],
zoner->meth);
assert(rtn>0&&rtn<SCRWID);
pstrcpy(buffer_f,zone->fname,25);
rtn= sprintf(sclinec_f[MENULINE+4],sfmt_f,m2line[2],
buffer_f);
assert(rtn>0&&rtn<SCRWID);
rtn= sprintf(sclinec_f[MENULINE+5],sfmt_f,m2line[3],
zoner->pre);
assert(rtn>0&&rtn<SCRWID);
rtn= sprintf(sclinec_f[MENULINE+6],dfmt_f,m2line[4],
zoner->tran);
assert(rtn>0&&rtn<SCRWID);
rtn= sprintf(sclinec_f[MENULINE+7],sfmt_f,m2line[5],
prnfg(zoner->ransam));
assert(rtn>0&&rtn<SCRWID);
rtn= sprintf(sclinec_f[MENULINE+8],sfmt_f,m2line[6],
prnfg(zoner->model.ci));
assert(rtn>0&&rtn<SCRWID);

psc(sclinec_f);
m= lcase(getkey("12345679q"));
if(m=='q')return;
if((m-= '0')==9)break;
switch(m)
{
case 1:
pstrcpy(sclinec_f[MENULINE+12],m21line,SCRWID);
psc(sclinec_f);
zoner->n= (int)getsing(0,(real)nsam-2);
break;
case 2:
for(i= 0;i<nm22line;i++)
{
pstrcpy(sclinec_f[MENULINE+12+i],m22line[i],SCRWID);
}
psc(sclinec_f);
zoner->meth= GETINT("12345");
break;
case 3:
pstrcpy(sclinec_f[MENULINE+12],m23line,SCRWID);
psc(sclinec_f);
pstrcpy(zone->fname,getstr(LENFNAME),LENFNAME);
gl.flag[ZONE]= ON;
break;
case 4:
pstrcpy(sclinec_f[MENULINE+12],m24line,SCRWID);
psc(sclinec_f);
pstrcpy(zoner->pre,getstr(LENSTR/4),LENSTR/4);
break;
case 5:
tranmenu_s(&zoner->tran);
break;
case 6:
toggle(&zoner->ransam);
break;
case 7:
if(modelmenu_s(&zoner->model)!=0)return;
break;

}

cls(sclinec_f,MENULINE+11,MENULINE+17);

}while(1);

}

break;

case'd':
rtn= sprintf(sclinec_f[MENULINE],sfmt_f,mline[3],
prnfg(pca->flag));
assert(rtn>0&&rtn<SCRWID);
psc(sclinec_f);
if((pca->flag= GETFG)==ON)
{
rtn= sprintf(sclinec_f[MENULINE],sfmt_f,mline[3],
prnfg(pca->flag));
assert(rtn>0&&rtn<SCRWID);
pstrcpy(sclinec_f[MENULINE+6],quitline_f,SCRWID);
pstrcpy(sclinec_f[MENULINE+7],rtnline_f,SCRWID);
m= 0;
do
{
rtn= sprintf(sclinec_f[MENULINE+2],dfmt_f,m3line[0],
pca->matrix);
assert(rtn>0&&rtn<SCRWID);
rtn= sprintf(sclinec_f[MENULINE+3],dfmt_f,m3line[1],
pca->naxes);
assert(rtn>0&&rtn<SCRWID);
rtn= sprintf(sclinec_f[MENULINE+4],dfmt_f,m3line[2],
pca->tran);
assert(rtn>0&&rtn<SCRWID);
rtn= sprintf(sclinec_f[MENULINE+5],sfmt_f,m3line[3],
prnfg(pca->model.ci));
assert(rtn>0&&rtn<SCRWID);

psc(sclinec_f);

m= lcase(getkey("12349q"));
if(m=='q')return;
if((m-= '0')==9)break;
switch(m)
{
case 1:
for(i= 0;i<3;i++)
{
pstrcpy(sclinec_f[MENULINE+9+i],m31line[i],SCRWID);
}
pstrcpy(sclinec_f[MENULINE+12],entnumline_f,SCRWID);
psc(sclinec_f);
pca->matrix= GETINT("123");
break;
case 2:
rtn= sprintf(sclinec_f[MENULINE+9],dfmt_f,
"Specify the number of axes for output",pca->naxes);
assert(rtn>0&&rtn<SCRWID);
pstrcpy(sclinec_f[MENULINE+10],entnumline_f,SCRWID);
assert(rtn>0&&rtn<SCRWID);
psc(sclinec_f);
pca->naxes= (int)getsing(1.0,(real)ntax);
break;
case 3:

tranmenu_s(&pca->tran);
break;
case 4:
if(modelmenu_s(&pca->model)!=0)return;
break;

}

cls(sclinec_f,MENULINE+9,MENULINE+12);

}while(1);

}

break;

case'e':
rtn= sprintf(sclinec_f[MENULINE],sfmt_f,mline[4],
prnfg(ca->flag));
assert(rtn>0&&rtn<SCRWID);
psc(sclinec_f);
if((ca->flag= GETFG)==ON)
{
rtn= sprintf(sclinec_f[MENULINE],sfmt_f,mline[4],
prnfg(ca->flag));
assert(rtn>0&&rtn<SCRWID);
pstrcpy(sclinec_f[MENULINE+10],quitline_f,SCRWID);
pstrcpy(sclinec_f[MENULINE+11],rtnline_f,SCRWID);
m= 0;
do
{
rtn= sprintf(sclinec_f[MENULINE+2],sfmt_f,m4line[0],
prnfg(ca->dca));
assert(rtn>0&&rtn<SCRWID);
rtn= sprintf(sclinec_f[MENULINE+3],sfmt_f,m4line[1],
prnfg(ca->iweigh));
assert(rtn>0&&rtn<SCRWID);
rtn= sprintf(sclinec_f[MENULINE+4],sfmt_f,m4line[2],
prnfg(ca->irescfg));
assert(rtn>0&&rtn<SCRWID);
rtn= sprintf(sclinec_f[MENULINE+5],dfmt_f,m4line[3],
ca->iresc);
assert(rtn>0&&rtn<SCRWID);
rtn= sprintf(sclinec_f[MENULINE+6],gfmt_f,m4line[4],
ca->resth);
assert(rtn>0&&rtn<SCRWID);
rtn= sprintf(sclinec_f[MENULINE+7],dfmt_f,m4line[5],
ca->mk);
assert(rtn>0&&rtn<SCRWID);
rtn= sprintf(sclinec_f[MENULINE+8],dfmt_f,m4line[6],
ca->tran);
assert(rtn>0&&rtn<SCRWID);
rtn= sprintf(sclinec_f[MENULINE+9],sfmt_f,m4line[7],
prnfg(ca->model.ci));
assert(rtn>0&&rtn<SCRWID);

psc(sclinec_f);

m= lcase(getkey("abcdefgh9q"));
if(m=='q')return;
if(m=='9')break;
switch(m)
{
case'a':
toggle(&ca->dca);
if(ca->dca==OFF)ca->irescfg= OFF;
break;
case'b':
toggle(&ca->iweigh);
break;
case'c':
if(ca->dca==ON)toggle(&ca->irescfg);
break;
case'd':
rtn= sprintf(sclinec_f[MENULINE+13],dfmt_f,
"Specify the number of times to rescale",ca->iresc);
assert(rtn>0&&rtn<SCRWID);
pstrcpy(sclinec_f[MENULINE+14],entnumline_f,SCRWID);
assert(rtn>0&&rtn<SCRWID);
psc(sclinec_f);
ca->iresc= (int)getsing(0.0,20.0);
break;
case'e':
rtn= sprintf(sclinec_f[MENULINE+13],gfmt_f,
"Specify the rescaling threshold",ca->resth);
assert(rtn>0&&rtn<SCRWID);
pstrcpy(sclinec_f[MENULINE+14],entnumline_f,SCRWID);
assert(rtn>0&&rtn<SCRWID);
psc(sclinec_f);
ca->resth= getsing(0.0,100.0);
break;
case'f':
rtn= sprintf(sclinec_f[MENULINE+13],dfmt_f,
"Specify the number of segments",ca->mk);
assert(rtn>0&&rtn<SCRWID);
pstrcpy(sclinec_f[MENULINE+14],entnumline_f,SCRWID);
assert(rtn>0&&rtn<SCRWID);
psc(sclinec_f);
ca->mk= (int)getsing(10.0,46.0);
break;
case'g':

tranmenu_s(&ca->tran);
break;
case'h':
if(modelmenu_s(&ca->model)!=0)return;
break;

}

cls(sclinec_f,MENULINE+13,MENULINE+16);

}while(1);

}

break;

case'f':
rtn= sprintf(sclinec_f[MENULINE],sfmt_f,mline[5],
prnfg(four->flag));
assert(rtn>0&&rtn<SCRWID);
psc(sclinec_f);
if((four->flag= GETFG)==ON)
{
rtn= sprintf(sclinec_f[MENULINE],sfmt_f,mline[5],
prnfg(four->flag));
assert(rtn>0&&rtn<SCRWID);
m= 0;
do
{
rtn= sprintf(sclinec_f[MENULINE+2],dfmt_f,
"1 Data transformation",four->tran);
assert(rtn>0&&rtn<SCRWID);
pstrcpy(sclinec_f[MENULINE+3],quitline_f,SCRWID);
pstrcpy(sclinec_f[MENULINE+4],rtnline_f,SCRWID);
psc(sclinec_f);
m= lcase(getkey("19q"));
if(m=='q')return;
if((m-= '0')==9)break;
else tranmenu_s(&four->tran);

}while(1);

}

break;

case'g':
toggle(&num->stat);
break;

case'h':
toggle(&coll->indspl);
break;

case'i':
rtn= sprintf(sclinec_f[MENULINE],gfmt_f,
"7 Minimum value for inclusion of a taxon",num->thresh);
assert(rtn>0&&rtn<SCRWID);
*sclinec_f[MENULINE+1]= '\0';
pstrcpy(sclinec_f[MENULINE+2],"Enter minimum value",SCRWID);
psc(sclinec_f);
if(gl.code.dat=='%')num->thresh= getsing(-1,1);
else num->thresh= getsing(-1e7,1e7);
break;

case'j':
toggle(&gl.recalc);
break;

}

}while(1);

return;
}


/*:52*//*54:*/
#line 2246 "ppmenu.w"

static void menun_s
(
const char*const menustr,
ci_t*ci
)

{
/*22:*/
#line 419 "ppmenu.w"

const char*nline[]= 
{
"1 Fine-scale variation in sediment accumulation",
"  Default = 0.3 per 5 years",
"2 Method for calculating confidence intervals",
"3 Method for generating random numbers",
"4 Seed for random number generator",
"5 Number of simulations"
};

const char*n1line= "Enter new allowance (0 to disable) <Enter>";
const char*n2line[]= 
{
"1 Modification of Maher's lognormal distributions",
"2 Propagation of errors"
};
const char*n5line= "Enter number of simulations (default 100) <Enter>";

/*:22*/
#line 2254 "ppmenu.w"

int n= 0;
loop_t i= 0;

cls(sclineb_f,MENULINE,SCRHT-2);

rtn= sprintf(sclineb_f[MENULINE],sfmt_f,menustr,prnfg(ci->flag));
assert(rtn>0&&rtn<SCRWID);
pstrcpy(sclineb_f[MENULINE+2],switchline_f,SCRWID);
psc(sclineb_f);

ci->flag= GETINT("01")-1;

rtn= sprintf(sclineb_f[MENULINE],sfmt_f,menustr,prnfg(ci->flag));
assert(rtn>0&&rtn<SCRWID);

pstrcpy(sclineb_f[MENULINE+8],quitline_f,SCRWID);

do
{
if(gl.code.dat=='B')
{
rtn= sprintf(sclineb_f[MENULINE+2],gfmt_f,nline[0],
ci->cvsed);
assert(rtn>0&&rtn<SCRWID);
pstrcpy(sclineb_f[MENULINE+3],nline[1],SCRWID);
}
rtn= sprintf(sclineb_f[MENULINE+4],dfmt_f,nline[2],ci->meth);
assert(rtn>0&&rtn<SCRWID);
rtn= sprintf(sclineb_f[MENULINE+5],dfmt_f,nline[3],gl.mran);
assert(rtn>0&&rtn<SCRWID);
rtn= sprintf(sclineb_f[MENULINE+6],sfmt_f,nline[4],gl.seed);
assert(rtn>0&&rtn<SCRWID);
rtn= sprintf(sclineb_f[MENULINE+7],dfmt_f,nline[5],ci->nran);
assert(rtn>0&&rtn<SCRWID);

psc(sclineb_f);
if((n= GETINT(gl.code.dat=='B'?"123459":"23459"))==9)break;
switch(n)
{
case 1:
pstrcpy(sclineb_f[MENULINE+10],n1line,SCRWID);
psc(sclineb_f);
ci->cvsed= getsing(0,1);
break;
case 2:
for(i= 0;i<2;i++)
{
pstrcpy(sclineb_f[MENULINE+10+i],n2line[i],SCRWID);
}
psc(sclineb_f);
ci->meth= GETINT("12");
break;
case 3:
for(i= 0;i<nrantext_f;i++)
{

pstrcpy(sclineb_f[MENULINE+10+i],rantext_f[i],SCRWID);
}
psc(sclineb_f);
gl.mran= GETINT("12345678");
break;
case 4:
rtn= sprintf(sclineb_f[MENULINE+10],seedtext_f);
assert(rtn>0&&rtn<SCRWID);
psc(sclineb_f);
pstrcpy(gl.seed,getstr(11),11);
break;
case 5:
pstrcpy(sclineb_f[MENULINE+10],n5line,SCRWID);
psc(sclineb_f);
ci->nran= (int)(getsing(10,1000)+0.5F);
break;

}

cls(sclineb_f,MENULINE+10,MENULINE+17);

}while(1);

return;
}


/*:54*//*56:*/
#line 2343 "ppmenu.w"

void menuu
(
const char*const menustr
)

{
/*25:*/
#line 441 "ppmenu.w"

char uline[][55]= 
{
"a Leave program without writing output file",
"                                                      ",
"c Make coffee",
"d Display references for this program"
};

const char*const u5text[]= 
{
"Aitchison, J. 1986. The statistical analysis of compositional data. "
"Chapman\n\tand Hall, London.",
"Bennett, K.D. 1994. Confidence intervals for age estimates and "
"deposition\n\ttimes in late Quaternary sediment sequences. "
"The Holocene, 4, 337-348.",
"Bennett, K.D. 1996. Determination of the number of zones in a "
"\n\tbiostratigraphical sequence. "
"New Phytologist 132, 155-170.",
"Birks, H.J.B., & Gordon, A.D. 1985. Numerical methods in Quaternary "
"pollen\n\tanalysis. Academic Press, London.",
"Birks, H.J.B. & Line, J.M. 1992. The use of rarefaction analysis "
"for\n\testimating palynological richness from Quaternary "
"pollen-analytical\n\tdata. The Holocene 2, 1-10.",
"Grimm, E.C. 1987. CONISS: a FORTRAN 77 program for stratigraphically"
"\n\tconstrained cluster analysis by the method of incremental sum "
"of\n\tsquares. Computers & Geosciences 13, 13-35.",
"Hill, M.O. 1979. DECORANA -- a FORTRAN program for detrended "
"correspondence\n\tanalysis and reciprocal averaging. Ecology and "
"Systematics,\n\tCornell University.",
"Jackson, D.A. 1993. Stopping rules in principal components analysis: "
"a\n\tcomparison of heuristical and statistical approaches. Ecology "
"74,\n\t2204-2214.",
"Maher, L.J. Jr 1972. Nomograms for computing 0.95 confidence limits "
"of\n\tpollen data. Review of Palaeobotany and Palynology 13, 85-93.",
"Maher, L.J. Jr 1981. Statistics for microfossil concentration "
"measurements\n\temploying samples spiked with marker grains. Review"
" of Palaeobotany and\n\tPalynology 32, 153-191.",
"Marsaglia, G. & Zaman, A. 1994. Some portable very-long-period random"
"\n\tnumber generators. Computers in Physics 8, 117-121.",
"Parratt, L.G. 1961. Probability and experimental errors in science: "
"an \n\telementary survey. Wiley, New York.",
"Prentice, I.C. 1980. Multidimensional scaling as a research tool in\n"
"\tQuaternary palynology: a review of theory and methods. Review of\n"
"\tPalaeobotany and Palynology 31, 71-104.",
"Press, W.H., Teukolsky, S.A., Vetterling, W.T. & Flannery, B.P. 1992."
"\n\tNumerical recipes in C: the art of scientific computing. 2nd ed. "
"CUP,\n\tCambridge.",
"Sokal, R.R. & Rohlf, F.J. 1969. Biometry: the principles and practice"
"\n\tof statistics in biological research. W.H. Freeman, San "
"Francisco.",
"Zaman, A. & Marsaglia, G. 1991. A new class of random number generators."
"\n\tAnnals of Applied Probability 1, 462-480."
};
const int nu5text= 16;

/*:25*/
#line 2350 "ppmenu.w"

char keybuff[10]= "";

flag_t psim= ON;
int nuline= 4;
int n= 0;
loop_t i= 0;

rtn= sprintf(uline[1],"b Display %s version and compilation date/time",
gl.prog);
assert(rtn>0&&rtn<55);

if(strstr(gl.prog,"psimpoll")==NULL)
{
psim= OFF;
nuline= 3;
}
pstrcpy(keybuff,psim==ON?"abcd9":"abc9",10);
cls(sclineb_f,MENULINE,SCRHT-2);

do
{
pstrcpy(sclineb_f[MENULINE],menustr,SCRWID);
for(i= 0;i<nuline;i++)
{
pstrcpy(sclineb_f[MENULINE+1+i],uline[i],SCRWID);
}
pstrcpy(sclineb_f[MENULINE+1+nuline],quitline_f,SCRWID);

psc(sclineb_f);

if((n= lcase(getkey(keybuff)))=='9')break;
switch(n)
{
case'a':
EXIT(EXIT_SUCCESS);
case'b':
rtn= sprintf(sclineb_f[MENULINE+3+nuline],"%s version %.2f",
gl.prog,gl.ver);
assert(rtn>0&&rtn<SCRWID);
rtn= sprintf(sclineb_f[MENULINE+4+nuline],
"compiled by %sANSI C compiler %s %s",STDC==1?"":"non-",
gl.time,gl.date);
assert(rtn>0&&rtn<SCRWID);
psc(sclineb_f);
dlay();
break;
case'c':
pstrcpy(sclineb_f[MENULINE+7-psim],
"Device appears to be off line: check hose connections",SCRWID);
psc(sclineb_f);
dlay();
break;
case'd':

rtn= printf("%s uses algorithms and functions from:\n",gl.prog);
assert(rtn>0);
for(i= 0;i<nu5text;i++)
{
rtn= puts(u5text[i]);
assert(rtn!=EOF);
if(i>0&&i%7==0&&i!=nu5text-1)dlay();
}
dlay();
break;

}

cls(sclineb_f,MENULINE+3+nuline,MENULINE+4+nuline);

}while(1);

return;
}


/*:56*//*58:*/
#line 2432 "ppmenu.w"

static int modelmenu_s
(
model_t*model
)

{
const char*modline[]= 
{
"Options to control modelling:",
"0 Switch on/off (off)",
"1 Number of models to generate (10)",
"2 Random number generator to use (1)",
"3 Seed for random number generator"
};
const char*mod1line= "Enter number of models <Enter>";

char**sclinee= NULL;

int n= 0;
loop_t i= 0;

sclinee= amatchar(SCRHT,SCRWID);
for(i= 0;i<4;i++)pstrcpy(sclinee[i],scline_f[i],SCRWID);
pstrcpy(sclinee[SCRHT-1],scline_f[SCRHT-1],SCRWID);

pstrcpy(sclinee[MENULINE],modline[0],SCRWID);
pstrcpy(sclinee[MENULINE+6],quitline_f,SCRWID);
pstrcpy(sclinee[MENULINE+7],rtnline_f,SCRWID);
pstrcpy(sclinee[MENULINE+9],entnumline_f,SCRWID);

do
{
rtn= sprintf(sclinee[MENULINE+2],sfmt_f,modline[1],
prnfg(model->ci));
assert(rtn>0&&rtn<SCRWID);
rtn= sprintf(sclinee[MENULINE+3],dfmt_f,modline[2],model->n);
assert(rtn>0&&rtn<SCRWID);
rtn= sprintf(sclinee[MENULINE+4],dfmt_f,modline[3],gl.mran);
assert(rtn>0&&rtn<SCRWID);
rtn= sprintf(sclinee[MENULINE+5],sfmt_f,modline[4],gl.seed);
assert(rtn>0&&rtn<SCRWID);
psc(sclinee);
n= lcase(getkey("01239q"));
if(n=='q')break;
if((n-= '0')==9)break;
switch(n)
{
case 0:
toggle(&model->ci);
break;
case 1:
pstrcpy(sclinee[MENULINE+11],mod1line,SCRWID);
psc(sclinee);
model->n= (int)getsing(1,1000);
break;
case 2:
for(i= 0;i<nrantext_f;i++)
{

pstrcpy(sclinee[MENULINE+11+i],rantext_f[i],SCRWID);
}
psc(sclinee);
gl.mran= GETINT("12345678");
break;
case 3:
rtn= sprintf(sclinee[MENULINE+11],seedtext_f);
assert(rtn>0&&rtn<SCRWID);
psc(sclinee);
pstrcpy(gl.seed,getstr(11),11);
break;

}

cls(sclinee,MENULINE+11,MENULINE+18);

}while(1);

fmatchar(sclinee,SCRHT);

if(n==9)return(0);
else return(-1);
}


/*:58*//*60:*/
#line 2522 "ppmenu.w"

static void tranmenu_s
(
int*tran
)

{
char**sclined= NULL;

const char*trantext[]= 
{
"Transformations available:",
"",
"0 None",
"1 Square-root",
"2 Standardization to zero mean and unit variance       (not CA)",
"3 Normalization of variables to unit length",
"4 Centred log ratio / logarithm                        (not CA)",
"",
"Enter number <Enter>"
};
const int ntrantext= 9;

loop_t i= 0;

sclined= amatchar(SCRHT,SCRWID);
for(i= 0;i<4;i++)pstrcpy(sclined[i],scline_f[i],SCRWID);
for(i= 5;i<5+ntrantext;i++)
{
pstrcpy(sclined[i],trantext[i-5],SCRWID);
}

pstrcpy(sclined[SCRHT-1],scline_f[SCRHT-1],SCRWID);

psc(sclined);
fmatchar(sclined,SCRHT);

*tran= GETINT("01234");

}


/*:60*//*62:*/
#line 2575 "ppmenu.w"

static void writecfg_s
(
file_t cfg,
frame_t coll,
file_t agedep,
file_t adplot,
file_t outmain,
caption_t head,
frame_t agerange,
flag_t intfg,
age_t age,
file_t zone,
file_t inage,
file_t ints,
ci_t ci,
rare_t rarer,
zoner_t zoner,
four_t four,
num_t num,
roc_t roc,
file_t stat,
file_t dat,
pca_t pca,
ca_t ca,
samp_t lev,
flag_t ipdat,
format_t ipform,
char sunit[12][LENSTR/2]
)

{
loop_t i= 0;






cfg.mode[0]= 'w';
openf(&cfg,__FILE__,__LINE__,ON);
rtn= fprintf(cfg.fp,"%f\n%f\n%f\n",gl.page.minpl,gl.page.wide,
gl.page.prop);
assert(rtn>0);
rtn= fprintf(cfg.fp,"%c\n%d\n",coll.style==OUTL?'O':'F',coll.ix10);
assert(rtn>0);
rtn= fprintf(cfg.fp,"%s\n%s\n",agedep.fname,outmain.fname);
assert(rtn>0);
rtn= fprintf(cfg.fp,"%c\n%f\n",gl.font.code,gl.font.ufac);
assert(rtn>0);
rtn= fprintf(cfg.fp,"%d\n",coll.rot);
assert(rtn>0);
rtn= fprintf(cfg.fp,"%s\n%s\n%s\n%s\n",head.base,head.subtitle,
head.zone,head.sed);
assert(rtn>0);
rtn= fprintf(cfg.fp,"%d %d\n",(int)coll.join,(int)intfg);
assert(rtn>0);
rtn= fprintf(cfg.fp,"%d %f %f %f %f %d %d %f\n",
(int)age.flag,age.up,age.upsd,age.base,age.basesd,age.model,
age.nterm,age.c14k);
assert(rtn>0);
rtn= fprintf(cfg.fp,"%s\n%s\n%s\n",zone.fname,inage.fname,ints.fname);
assert(rtn>0);
rtn= fprintf(cfg.fp,"%d %f %d\n",(int)ci.flag,ci.cvsed,ci.meth);
assert(rtn>0);
rtn= fprintf(cfg.fp,"%d\n%s\n%d\n",gl.mran,gl.seed,ci.nran);
assert(rtn>0);
rtn= fprintf(cfg.fp,"%d %d\n",(int)rarer.flag,rarer.n);
assert(rtn>0);
rtn= fprintf(cfg.fp,"%d %f %d %d %s\n",(int)zoner.flag,num.thresh,
zoner.n,zoner.meth,zoner.pre);
assert(rtn>0);
rtn= fprintf(cfg.fp,"%d %d\n",(int)roc.flag,roc.diss);
assert(rtn>0);
rtn= fprintf(cfg.fp,"%s\n%s\n%s\n",head.c14,head.ps1,head.ps2);
assert(rtn>0);
rtn= fprintf(cfg.fp,"%d\n",num.stat);
assert(rtn>0);
rtn= fprintf(cfg.fp,"%s\n",stat.fname);
assert(rtn>0);
rtn= fprintf(cfg.fp,"%d\n%d\n%d\n",(int)pca.flag,pca.matrix,pca.naxes);
assert(rtn>0);
rtn= fprintf(cfg.fp,"%d\n",(int)four.flag);
assert(rtn>0);
rtn= fprintf(cfg.fp,"%d\n",(int)lev.adsc);
assert(rtn>0);
rtn= fprintf(cfg.fp,"%d\n",pca.tran);
assert(rtn>0);
rtn= fprintf(cfg.fp,"%d\n",zoner.tran);
assert(rtn>0);
rtn= fprintf(cfg.fp,"%d\n",(int)coll.indspl);
assert(rtn>0);
rtn= fprintf(cfg.fp,"%d\n",(int)zoner.ransam);
assert(rtn>0);
rtn= fprintf(cfg.fp,"%d\n",(int)gl.recalc);
assert(rtn>0);
rtn= fprintf(cfg.fp,"%f\n",coll.shade);
assert(rtn>0);
rtn= fprintf(cfg.fp,"%d %f %f\n",(int)lev.udata,lev.umax,lev.umin);
assert(rtn>0);
rtn= fprintf(cfg.fp,"%d\n",(int)coll.all);
assert(rtn>0);
rtn= fprintf(cfg.fp,"%d\n",(int)ipdat);
assert(rtn>0);
rtn= fprintf(cfg.fp,"%d\n",roc.smooth);
assert(rtn>0);
rtn= fprintf(cfg.fp,"%f %d\n",coll.hist,(int)coll.indscale);
assert(rtn>0);
for(i= 0;i<10;i++)
{
rtn= fprintf(cfg.fp,"%s\n",sunit[i]);
assert(rtn>0);
}
rtn= fprintf(cfg.fp,"%d\n",four.tran);
assert(rtn>0);
rtn= fprintf(cfg.fp,"%d\n%d\n%f\n",coll.script==SCRREAD?-1:0,
(int)coll.bull,coll.lval);
assert(rtn>0);
rtn= fprintf(cfg.fp,"%d\n",(int)age.timx);
assert(rtn>0);
rtn= fprintf(cfg.fp,"%s\n",head.time);
assert(rtn>0);
rtn= fprintf(cfg.fp,"%d\n",(int)coll.sum2col);
assert(rtn>0);
rtn= fprintf(cfg.fp,"%d %d\n",(int)roc.model.ci,roc.model.n);
assert(rtn>0);
rtn= fprintf(cfg.fp,"%d %d\n",(int)pca.model.ci,pca.model.n);
assert(rtn>0);
rtn= fprintf(cfg.fp,"%d %d\n",(int)zoner.model.ci,zoner.model.n);
assert(rtn>0);
rtn= fprintf(cfg.fp,"%f %f\n",lev.majmark,lev.minmark);
assert(rtn>0);
rtn= fprintf(cfg.fp,"%d\n",coll.skip);
assert(rtn>0);
rtn= fprintf(cfg.fp,"%d\n",(int)gl.tufte);
assert(rtn>0);
rtn= fprintf(cfg.fp,"%d\n",(int)age.adbc);
assert(rtn>0);
rtn= fprintf(cfg.fp,"%d\n",(int)coll.c14scale);
assert(rtn>0);
rtn= fprintf(cfg.fp,"%s\n",dat.fname);
assert(rtn>0);
rtn= fprintf(cfg.fp,"%d\n",(int)ipform);
assert(rtn>0);
rtn= fprintf(cfg.fp,"%f\n",coll.penwid);
assert(rtn>0);
rtn= fprintf(cfg.fp,"%d\n",(int)coll.interp);
assert(rtn>0);
rtn= fprintf(cfg.fp,"%f\n",lev.interp);
assert(rtn>0);
rtn= fprintf(cfg.fp,"%f\n",lev.intstart);
assert(rtn>0);
rtn= fprintf(cfg.fp,"%f\n",lev.intstop);
assert(rtn>0);
rtn= fprintf(cfg.fp,"%s\n",adplot.fname);
assert(rtn>0);
rtn= fprintf(cfg.fp,"%f\n",gl.adpage.minpl);
assert(rtn>0);
rtn= fprintf(cfg.fp,"%s\n%s\n",head.adxaxis,head.adyaxis);
assert(rtn>0);
rtn= fprintf(cfg.fp,"%ld\n%ld\n",gl.palette.back,gl.palette.fore);
assert(rtn>0);
rtn= fprintf(cfg.fp,"%ld\n%ld\n%ld\n%ld\n%ld\n%ld\n%ld\n",coll.colpl,
coll.coltit,coll.coldep,coll.col14c,coll.colts,coll.colzone,
coll.colxax);
assert(rtn>0);
rtn= fprintf(cfg.fp,"%d\n%d\n",gl.colts,gl.colzone);
assert(rtn>0);
rtn= fprintf(cfg.fp,"%f\n",gl.neglev);
assert(rtn>0);
rtn= fprintf(cfg.fp,"%ld\n%ld\n%ld\n%ld\n%ld\n",agerange.colpl,
agerange.colsdpl,agerange.col14c,agerange.coldep,agerange.colxax);
assert(rtn>0);
rtn= fprintf(cfg.fp,"%d\n",lev.inttype==PAIR?0:1);
assert(rtn>0);
rtn= fprintf(cfg.fp,"%f\n",gl.papwid);
assert(rtn>0);
rtn= fprintf(cfg.fp,"%f\n",gl.papht);
assert(rtn>0);
rtn= fprintf(cfg.fp,"%d\n%d\n%d\n%d\n%d\n%d\n%d\n%f\n",(int)ca.flag,
ca.tran,(int)ca.iweigh,(int)ca.irescfg,ca.iresc,(int)ca.dca,ca.mk,
ca.resth);
assert(rtn>0);
rtn= fprintf(cfg.fp,"%d %d\n",(int)ca.model.ci,ca.model.n);
assert(rtn>0);

closef(&cfg,__FILE__,__LINE__);

return;
}


/*:62*//*64:*/
#line 2772 "ppmenu.w"

void getfont
(
void
)

{
/*15:*/
#line 207 "ppmenu.w"

const char*const fontrom[]= 
{
"Helvetica",
"Times-Roman",
"Courier",
"AvantGarde-Book",
"Bookman-Light",
"NewCenturySchlbk-Roman",
"Palatino-Roman",
"Helvetica-Narrow"
};

const char*const fontita[]= 
{
"Helvetica-Oblique",
"Times-Italic",
"Courier-Oblique",
"AvantGarde-BookOblique",
"Bookman-LightItalic",
"NewCenturySchlbk-Italic",
"Palatino-Italic",
"Helvetica-Narrow-Oblique"
};

/*:15*/
#line 2779 "ppmenu.w"


const real fontfac[]= 
{
7.1,7.2,5.9,6.7,6.5,6.4,6.6,8.7
};

switch(gl.font.code)
{
case'H':gl.font.num= 0;break;
case'T':gl.font.num= 1;break;
case'C':gl.font.num= 2;break;
case'A':gl.font.num= 3;break;
case'B':gl.font.num= 4;break;
case'N':gl.font.num= 5;break;
case'P':gl.font.num= 6;break;
case'E':gl.font.num= 7;break;
default:PPERROR(9);
}

pstrcpy(gl.font.rom,fontrom[gl.font.num],25);
pstrcpy(gl.font.ital,fontita[gl.font.num],25);
gl.font.fac= fontfac[gl.font.num];

return;
}


/*:64*//*66:*/
#line 2814 "ppmenu.w"

char getkey
(
const char*const list
)

{
char s[10]= "";

for(;;)
{
if(fgets(s,10,stdin)==NULL)PPERROR(6);
if(strchr(list,ucase(s[0]))==NULL&&strchr(list,lcase(s[0]))==NULL)
{
rtn= printf("'%c' is not an option: try one of '%s'\n> ",s[0],list);
assert(rtn>0);
}
else break;

}

return(s[0]);
}


/*:66*//*68:*/
#line 2844 "ppmenu.w"

real getsing
(
real xmi,
real xma
)

{
char s[10]= "";
flag_t x= OFF;
real y= 0;

while(x==OFF)
{
if(fgets(s,10,stdin)==NULL)PPERROR(6);
if(isdigit(s[0])==0&&s[0]!='.'&&s[0]!='-')
{
rtn= printf("'%c' is not a number\n>",s[0]);
assert(rtn>0);
}
else
{
y= (real)atof(s);
if(y>xma||y<xmi)
{
rtn= printf("Out of range (%.3f-%.3f)\n> ",xmi,xma);
assert(rtn>0);
}
else x= ON;

}

}

return(y);
}

/*:68*//*70:*/
#line 2886 "ppmenu.w"

char*prnfg
(
const flag_t f
)

{
return(f==OFF?"off":"on");
}

/*:70*//*72:*/
#line 2901 "ppmenu.w"

void toggle
(
flag_t*f
)

{
*f= (*f==OFF?ON:OFF);
return;
}
/*:72*/
