/*2:*/
#line 13 "ppnuman.w"

#include "psimpoll.h" 
#include "ppglobal.h" 


/*:2*//*3:*/
#line 19 "ppnuman.w"

/*14:*/
#line 231 "ppnuman.w"

static real getval_s(real*logfact,real sumi,real fdatajk,int mincount);
/*:14*//*16:*/
#line 270 "ppnuman.w"

static void moment1_s(real*data,int n,real*adev,real*ave,real*curt,
real*sscurt,real*sdev,real*skew,real*sskew,real*var);
/*:16*//*20:*/
#line 386 "ppnuman.w"

static void period_s(real*x,real*y,int n,real*px,real*py);
/*:20*//*30:*/
#line 923 "ppnuman.w"

static void udruns_s(real*x,int n,real*u,real*q);
/*:30*/
#line 20 "ppnuman.w"


/*:3*//*5:*/
#line 31 "ppnuman.w"

void bstick
(
real*array,
int p
)

{
loop_t i= 0;

array[p-1]= 1.0/p;
for(i= p-1;i>0;i--)array[i-1]= array[i]+(1.0/i);
for(i= 0;i<p;i++)array[i]/= p;

return;
}

/*:5*//*7:*/
#line 56 "ppnuman.w"

real errprop2
(
real x,
real xs,
real y,
real ys
)

{
real a= 0;
real b= 0;
real c= 0;

a= xs/x;
b= ys/y;

c= x*y*pythag(a,b);

return(c);
}

/*:7*//*9:*/
#line 86 "ppnuman.w"

real errprop3
(
real x,
real xs,
real y,
real ys
)

{
real a= 0;
real b= 0;
real c= 0;

a= xs/x;
b= ys/y;

c= (x/y)*pythag(a,b);

return(c);
}

/*:9*//*11:*/
#line 121 "ppnuman.w"

void evalpoly
(
eval_t parms,
real x,
real*p,
real*dp
)

{
*p= parms.y2a[parms.nterm-1];
*dp= 0.0;
parms.nterm--;
while(parms.nterm>0)
{
*dp= (*dp)*x+*p;
*p= (*p)*x+parms.y2a[--(parms.nterm)];
}

return;
}

/*:11*//*13:*/
#line 149 "ppnuman.w"

void fourer
(
four_t four,
int nnsam,
int nntax,
real**smdat,
real*rsum,
char**taxname,
char*stitle,
file_t*stat
)

{
char buffer[LENSTR]= "";

real prob= 0;
int m= 0;
int nout= 5;

loop_t j= 0;
loop_t kk= 0;


real**trandat= NULL;

real*px= NULL;
real**py= NULL;

dprint(&(*stat),"Calculation of Lomb periodogram\n");
px= avecreal(nnsam*nout);
py= amatreal(nntax,nnsam*nout);
trandat= amatreal(nntax,nnsam);


datatran(four.tran,nnsam,nntax,smdat,rsum,trandat,stat);

for(kk= 0;kk<nntax;kk++)
{
rtn= printf("%d ",kk);
assert(rtn>0);
period_s(smdat[nntax],trandat[kk],nnsam,px,py[kk]);
}

rtn= putchar('\n');
assert(rtn!=EOF);
prob= -loge(0.05/(2.0*nnsam*nout/5));

rtn= fprintf(stat->fp,"\n\nFourier analysis\n0.05 probability = %f\n\n",
prob);
assert(rtn>0);

rtn= fprintf(stat->fp,"%s\n%d\n%d\nlf\n",stitle,nntax,nnsam*nout);
assert(rtn>0);
for(j= 0;j<nnsam*nout;j++)
{
rtn= fprintf(stat->fp,"%-8.4f\n",1000.0*px[j]);
assert(rtn>0);
}

for(kk= 0;kk<nntax;kk++)
{
m= (int)smdat[kk][nnsam];
pstrcpy(buffer,taxname[m],7);
rtn= fprintf(stat->fp,"%s\n",buffer);
assert(rtn>0);

prnrealarray(stat->fp,"%-8.4f\n",py[kk],nnsam*nout);

}

fmatreal(trandat,nntax);
fmatreal(py,nntax);
fvec(px);

return;
}

/*:13*//*15:*/
#line 234 "ppnuman.w"

static real getval_s
(
real*logfact,
real sumi,
real fdatajk,
int mincount
)

{
real tempval= 0.0;

int datajk= 0;

datajk= int4(fdatajk*sumi);
if(sumi-datajk-mincount<=0)tempval= 0.0;
else
{
tempval= logfact[int4(sumi)-datajk];
tempval+= logfact[int4(sumi)-mincount];
tempval-= logfact[int4(sumi)-datajk-mincount];
tempval-= logfact[int4(sumi)];
tempval= expe(tempval);
}

return(tempval);
}

/*:15*//*17:*/
#line 274 "ppnuman.w"

static void moment1_s
(
real*data,
int n,
real*adev,
real*ave,
real*curt,
real*scurt,
real*sdev,
real*skew,
real*sskew,
real*var
)

{
real ep= 0.0;
real dn= 0.0;
real p= 0;
real s= 0;

loop_t j= 0;

*adev= 0;
*curt= 0;
*skew= 0;
*var= 0;

*ave= sumrealarray(data,n)/n;

for(j= 0;j<n;j++)
{
*adev+= fabs(s= data[j]-*ave);
ep+= s;
*var+= (p= s*s);
*skew+= (p*= s);
*curt+= (p*= s);
}

*adev/= n;
*var= ((*var)-ep*ep/(real)n)/((real)n-1.0);
*sdev= sqrte(*var);
if(*var)
{
*skew/= (n*(*var)*(*sdev));
*curt= *curt/(n*(*var)*(*var))-3;
}

dn= (real)n;
*scurt= sqrte(24.0*dn*(dn-1)*(dn-1)/((dn-3.0)*(dn-2)*
(dn+3)*(dn+5)));
*sskew= sqrte(6.0*dn*(dn-1.0)/((dn-2.0)*(dn+1.0)*
(dn+3.0)));

return;
}

/*:17*//*19:*/
#line 341 "ppnuman.w"

void moment2
(
real*sdev,
real*ave,
real*data,
int n
)

{
real ep= 0.0;
real s= 0.0;
real var= 0.0;

loop_t j= 0;

*ave= sumrealarray(data,n)/n;

for(j= 0;j<n;j++)
{
s= data[j]-*ave;
ep+= s;
var+= (s*s);
}

var= (var-ep*ep/(real)n)/((real)n-1.0);
*sdev= sqrte(var);

return;
}

/*:19*//*21:*/
#line 389 "ppnuman.w"

static void period_s
(
real*x,
real*y,
int n,
real*px,
real*py
)

{
real arg= 0.0;
real ave= 0.0;
real c= 0.0;
real cc= 0.0;
real cwtau= 0.0;
real hifac= 2.0;


real ofac= 5.0;
real pnow= 0.0;
real s= 0.0;
real ss= 0.0;
real sumc= 0.0;
real sumcy= 0.0;
real sums= 0.0;
real sumsh= 0.0;
real sumsy= 0.0;
real sv= 0.0;
real swtau= 0.0;
real var= 0.0;
real wtau= 0.0;
real wtemp= 0.0;
real xave= 0.0;
real xdif= 0.0;
real xmax= 0.0;
real xmin= 0.0;
real yy= 0.0;

int np= 0;

loop_t i= 0;
loop_t j= 0;


real*realmem= NULL;
real*wi= NULL;
real*wpi= NULL;
real*wpr= NULL;
real*wr= NULL;

realmem= avecreal(n+n+n+n);
wi= realmem;
wpi= wi+n;
wpr= wpi+n;
wr= wpr+n;

moment2(&sv,&ave,y,n);

var= SQUARE(sv);

xmax= maxrealarray(x,n);
xmin= minrealarray(x,n);

xdif= xmax-xmin;
xave= 0.5*(xmax+xmin);
assert(xdif>0&&ofac>0);
pnow= 1.0/(xdif*ofac);
for(j= 0;j<n;j++)
{
arg= 2*PI*((x[j]-xave)*pnow);
wpr[j]= -2.0*SQUARE(sin(0.5*arg));
wpi[j]= sin(arg);
wr[j]= cos(arg);
wi[j]= wpi[j];
}

np= (int)(ofac*0.5*hifac*n);
for(i= 0;i<np;i++)
{
px[i]= (real)pnow;
sumsh= sumc= 0.0;
for(j= 0;j<n;j++)
{
c= wr[j];
s= wi[j];
sumsh+= s*c;
sumc+= (c-s)*(c+s);
}

wtau= 0.5*atan2e(2.0*sumsh,sumc);
swtau= sin(wtau);
cwtau= cos(wtau);
sums= sumc= sumsy= sumcy= 0.0;
for(j= 0;j<n;j++)
{
s= wi[j];
c= wr[j];
ss= s*cwtau-c*swtau;
cc= c*cwtau+s*swtau;
sums+= ss*ss;
sumc+= cc*cc;
yy= y[j]-ave;
sumsy+= yy*ss;
sumcy+= yy*cc;
wr[j]= ((wtemp= wr[j])*wpr[j]-wi[j]*wpi[j])+wr[j];
wi[j]= (wi[j]*wpr[j]+wtemp*wpi[j])+wi[j];
}

assert(sums>0);
assert(sumc>0);
py[i]= (0.5*(sumcy*sumcy/sumc+sumsy*sumsy/sums)/var);
assert(xdif>0);
pnow+= 1.0/(ofac*xdif);
}

fvec(realmem);

return;
}

/*:21*//*23:*/
#line 515 "ppnuman.w"

void quart
(
real*lq,
real*med,
real*uq,
real*data,
int n
)

{
real medianpos= 0;
real lquartpos= 0;
real uquartpos= 0;
real fdummy= 0;

medianpos= 0.5*(n+1);
lquartpos= 0.25*(n+3);
uquartpos= 0.25*(3*n+1);

*med= data[(int)medianpos-1];
fdummy= medianpos-(int)medianpos;
*med+= (fdummy*(data[(int)medianpos]-data[(int)medianpos-1]));

*lq= data[(int)lquartpos-1];
fdummy= lquartpos-(int)lquartpos;
*lq+= (fdummy*(data[(int)lquartpos]-data[(int)lquartpos-1]));

*uq= data[(int)uquartpos-1];
fdummy= uquartpos-(int)uquartpos;
*uq+= (fdummy*(data[(int)uquartpos]-data[(int)uquartpos-1]));

return;
}

/*:23*//*25:*/
#line 561 "ppnuman.w"

void raref
(
rare_t*rarer,
data_t*data,
int sumpos,
flag_t iroc
)

{
char buffer[LENSTR]= "";

real lolim= 0;
real std= 0;
real tempval1= 0;
real tempval2= 0;
real tempval3= 0;
real uplim= 0;

int idummy1= 0;
int maxcount= 0;
int mincount= 0;
int minp= 0;

loop_t j= 0;
loop_t k= 0;
loop_t kk= 0;
loop_t n= 0;


real*exptax= NULL;
real*logfact= NULL;
real*var= NULL;

int*obstax= NULL;


if(sumpos==0)
{
dprint(&gl.logf,"\nRarefaction analysis requested, but no sum data is "
"available\n");

setfloatarray(data->dat[data->ntax+iroc-1],data->nsam,0);
setfloatarray(data->dat[data->ntax+1],data->nsam,0);
setfloatarray(data->dat[data->ntax+2],data->nsam,0);

rarer->n= 0;
return;
}


obstax= avecint(data->nsam);
exptax= avecreal(data->nsam);
var= avecreal(data->nsam);




minp= 10000;
maxcount= 0;
for(j= 0;j<data->nsam;j++)
{
if(data->levfg[j]==ON)
{
minp= MIN(minp,(int)data->dat[sumpos][j]);
maxcount= MAX(maxcount,(int)data->dat[sumpos][j]);
}

}

if(rarer->n>0)mincount= rarer->n;
else mincount= rarer->n= minp;

dprint(&gl.logf,"Rarefaction: data standardized to a count of %d\n",
mincount);


logfact= avecreal(maxcount+1);

logfact[0]= logfact[1]= 0.0;
for(n= 2;n<=maxcount;n++)
{
logfact[n]= logfact[n-1]+loge(n);
}


rtn= fputs("Calculated level: ",stdout);
assert(rtn!=EOF);
for(j= 0;j<data->nsam;j++)
{
if(data->levfg[j]==OFF)continue;
rtn= printf("%d ",j);
assert(rtn>0);
for(k= 0;k<sumpos;k++)
{
if(data->dat[k][j]>(float)0)

{
obstax[j]++;
if(int4(data->dat[sumpos][j])>=mincount)
{


tempval1= getval_s(logfact,(real)data->dat[sumpos][j],
(real)data->dat[k][j],mincount);
if(tempval1>0.0)
{
exptax[j]+= tempval1;
var[j]+= (tempval1*(1.0-tempval1));
}

for(kk= k+1;kk<sumpos;kk++)
{


if(data->dat[kk][j]>(float)0)
{
tempval2= getval_s(logfact,(real)data->dat[sumpos][j],
(real)data->dat[kk][j],mincount);
tempval3= getval_s(logfact,(real)data->dat[sumpos][j],
(real)data->dat[k][j]+data->dat[kk][j],mincount);

var[j]+= (2.0*(tempval3-(tempval1*tempval2)));
}

}

}

}

}

}

rtn= putchar('\n');
assert(rtn!=EOF);

for(j= 0;j<data->nsam;j++)
{
if(data->levfg[j]==ON)
{
if(int4(data->dat[sumpos][j])<mincount)
{
exptax[j]= lolim= uplim= 0.0;
}
else
{

exptax[j]= obstax[j]-exptax[j];

std= 1.96*(sqrte(fabs(var[j])));
lolim= exptax[j]-std;
uplim= exptax[j]+std;
}


data->dat[data->ntax+iroc-1][j]= (float)exptax[j];
data->dat[data->ntax+1][j]= (float)lolim;
data->dat[data->ntax+2][j]= (float)uplim;

}

else
{
data->dat[data->ntax+iroc-1][j]= (float)-1;
data->dat[data->ntax+1][j]= (float)-1;
data->dat[data->ntax+2][j]= (float)-1;
}

}


if(sprintf(buffer,"%cPalynol. richness",rarer->n>0?'!':'-')>
LENSTR-1)
{
PPERROR(24);
}
idummy1= data->ntax+(int)iroc-1;
if(pstrlen(buffer)+1>LENTAXN)
{
data->taxname[idummy1]= rvecchar(data->taxname[idummy1],
pstrlen(buffer)+1);
}
pstrcpy(data->taxname[idummy1],buffer,MAX(LENTAXN,pstrlen(buffer)+1));

fvec(logfact);
fvec(var);
fvec(exptax);
fvec(obstax);

return;
}

/*:25*//*27:*/
#line 760 "ppnuman.w"

void smooth
(
real*xin,
real*yin,
int n,
int npoint
)

{
real dummy= 0.0;

real fdummy= 0;

int m= 0;

loop_t j= 0;

eval_t parms= 
{
NULL,NULL,0,NULL,0,0
};


real*xout= NULL;
real**zcovar= NULL;
real*dumsd= NULL;
int*lista= NULL;

m= npoint/2;
parms.nterm= (npoint==3?2:4);

dumsd= avecreal(npoint);
setrealarray(dumsd,npoint,1);

xout= avecreal(n);

lista= avecint(parms.nterm);
setintarray(lista,parms.nterm,1);

parms.y2a= avecreal(npoint);
zcovar= amatreal(npoint,npoint);

for(j= m;j<(n-m);j++)
{
lfit(yin+j-m,xin+j-m,dumsd,npoint,parms.y2a,zcovar,
parms.nterm,lista,parms.nterm,&fdummy,0,dpoly);
evalpoly(parms,yin[j],xout+j,&dummy);
}



for(j= 0;j<n;j++)
{
if(j>=m&&j<(n-m))xin[j]= MAX(0.0,xout[j]);
else xin[j]= -1;
}

fmatreal(zcovar,npoint);
fvec(parms.y2a);
fvec(lista);
fvec(xout);
fvec(dumsd);

return;
}

/*:27*//*29:*/
#line 832 "ppnuman.w"

void stater
(
real**smdat,
int nnsam,
int nntax,
char**taxname,
file_t*stat
)

{
char buffer[LENSTR]= "";

real adev= 0;
real ave= 0;
real curt= 0;
real scurt= 0;
real sdev= 0;
real skew= 0;
real sskew= 0;
real udr= 0.0;
real var= 0;

real maxx= 0;

real maxy= 0;
real q= 0;
real t= 0;

real u= 0;

int m= 0;

loop_t kk= 0;

dprint(&gl.logf,"Calculating basic statistics\n");

rtn= fprintf(stat->fp,"\nDistribution of values for each taxon\n\n"
"%17s%10s%14s%12s\n","mean","sd","skewness","kurtosis");
assert(rtn>0);
for(kk= 0;kk<nntax;kk++)
{
moment1_s(smdat[kk],nnsam,&adev,&ave,&curt,&scurt,&sdev,&skew,
&sskew,&var);
m= (int)smdat[kk][nnsam];

pstrcpy(buffer,taxname[m],7);
rtn= fprintf(stat->fp,"%-8s% 10.4f % 10.4f ",buffer,ave,sdev);
assert(rtn>0);
rtn= fprintf(stat->fp,"% 10.4f%s % 10.4f%s \n",skew,
(fabs(skew)/sskew>1.96)?"*":" ",curt,
(fabs(curt)/scurt>1.96)?"*":" ");
assert(rtn>0);
}

rtn= fprintf(stat->fp,"\nWeighted average estimates for each taxon\n\n"
"%16s%12s%11s%11s\n","optimum","tolerance","loc of max",
"val of max");
assert(rtn>0);
for(kk= 0;kk<nntax;kk++)
{
wtave(smdat[nntax],smdat[kk],nnsam,&maxx,&maxy,&u,&t);
m= (int)smdat[kk][nnsam];
pstrcpy(buffer,taxname[m],7);
rtn= fprintf(stat->fp,"%-8s%8.1f %8.1f %8.1f %10.4f\n",buffer,u,t,
maxx,maxy);
assert(rtn>0);
}

rtn= fprintf(stat->fp,"\nRuns test for each taxon\n\n%16s%8s\n","udr",
"q");
assert(rtn>0);
for(kk= 0;kk<nntax;kk++)
{
udruns_s(smdat[kk],nnsam,&udr,&q);
m= (int)smdat[kk][nnsam];
pstrcpy(buffer,taxname[m],7);
rtn= fprintf(stat->fp,"%-8s%10.4f %8.4e\n",buffer,udr,q);
assert(rtn>0);
}

rtn= fputs("\n\n",stat->fp);
assert(rtn>0);

return;
}

/*:29*//*31:*/
#line 926 "ppnuman.w"

static void udruns_s
(
real*x,
int n,
real*u,
real*q
)

{
static real b[6]= {0.0,0.0,0.0,0.0,0.0,0.0};
static const real a[6][6]= 
{{4529.4,9044.9,13568.0,18091.0,22615.0,27892.0},
{9044.9,18097.0,27139.0,36187.0,45234.0,55789.0},
{13568.0,27139.0,40721.0,54281.0,67852.0,83685.0},
{18091.0,36187.0,54281.0,72414.0,90470.0,111580.0},
{22615.0,45234.0,67852.0,90470.0,113262.0,139476.0},
{27892.0,55789.0,83685.0,111580.0,139476.0,172860.0}
};

static flag_t irun= OFF;

real x1= 0;
real x2= 0;

int ru= 0;

int ucount[6]= {0,0,0,0,0,0};

loop_t i= 0;
loop_t j= 0;
loop_t k= 0;

if(!irun)
{
irun= ON;
b[0]= 1.0/6.0;
b[1]= 5.0/24.0;
b[2]= 11.0/120.0;
b[3]= 19.0/720.0;
b[4]= 29.0/5040.0;
b[5]= 1.0/840.0;
}

for(i= 0;i<n;i++)
{
x1= x[i];
if(x1>x2&&ru<5)ru++;
else if(x2>=x1)
{
ucount[ru]++;
ru= 0;
}

x2= x1;

}

ucount[ru]++;
*u= 0.0;

for(j= 0;j<6;j++)
{
for(k= 0;k<6;k++)
{
*u+= ((ucount[j]-(n*b[j]))*(ucount[k]-(n*b[k]))*a[j][k]);
}

}

*u/= n;
*q= gammq(0.5*6.0,0.5*(*u));

return;
}

/*:31*//*33:*/
#line 1016 "ppnuman.w"

void wtave
(
real*x,
real*y,
int n,
real*maxx,
real*maxy,
real*u,
real*t
)


{
real sumy= 0.0;
real sumyx= 0.0;
real sumyxu= 0.0;

loop_t i= 0;

*maxx= x[0];
*maxy= y[0];


i= n;
while(--i>0)
{
if(y[i]>*maxy)
{
*maxy= y[i];
*maxx= x[i];
}
}

sumy= sumrealarray(y,n);

for(i= 0;i<n;i++)sumyx+= (y[i]*x[i]);

*u= sumyx/sumy;

for(i= 0;i<n;i++)sumyxu+= (y[i]*(x[i]-*u)*(x[i]-*u));

*t= sqrte(sumyxu/sumy);

return;
}
/*:33*/
