/*3:*/
#line 15 "pppca.w"

#include "psimpoll.h" 
#include "ppglobal.h" 

/*:3*//*4:*/
#line 20 "pppca.w"

/*9:*/
#line 119 "pppca.w"

static void jacobi_s(real**matrixin,int n,real*eignval,real**eignvec,
int*nrot);
/*:9*//*15:*/
#line 593 "pppca.w"

static void rotate_s(real**a,real*g,real*h,real s,real tau,int i,
int j,int k,int l);
/*:15*/
#line 21 "pppca.w"


/*:4*//*6:*/
#line 28 "pppca.w"

void covar
(
real*data1,
real*data2,
int n,
real*c
)

{
real sum1= 0;
real sum2= 0;
real sump= 0;
real val1= 0;
real val2= 0;

loop_t j= 0;

for(j= 0;j<n;j++)
{
sum1+= (val1= data1[j]);
sum2+= (val2= data2[j]);
sump+= (val1*val2);
}

*c= (sump-(sum1*sum2/(real)n))/((real)n-1.0);

return;
}

/*:6*//*8:*/
#line 66 "pppca.w"

void crank
(
int n,
real*w,
real*s
)

{
real rank= 0;
real t= 0;

int jt= 0;

loop_t j= 1;
loop_t ji= 0;

*s= 0.0;
while(j<n)
{
if(w[j]!=w[j-1])
{
w[j-1]= j;
j++;
}

else
{
for(jt= j+1;jt<=n&&w[jt-1]==w[j-1];jt++);
rank= 0.5*((real)j+(real)jt-1.0);
for(ji= j;ji<=jt-1;ji++)w[ji-1]= (real)rank;
t= (real)jt-(real)j;
*s+= t*t*t-t;
j= jt;
}

}

if(j==n)w[n-1]= n;

return;
}

/*:8*//*10:*/
#line 123 "pppca.w"

static void jacobi_s
(
real**matrixin,
int n,
real*eignval,
real**eignvec,
int*nrot
)

{
real c= 0.0;
real g= 0.0;
real h= 0.0;
real p= 0.0;
real s= 0.0;
real sm= 0.0;
real t= 0.0;
real tau= 0.0;
real theta= 0.0;
real tresh= 0.0;

loop_t i= 0;
loop_t ip= 0;
loop_t iq= 0;
loop_t j= 0;
loop_t k= 0;


real*b= NULL;
real*z= NULL;

*nrot= 0;

b= avecreal(n);
z= avecreal(n);

for(ip= 0;ip<n;ip++)
{
setrealarray(eignvec[ip],n,0.0);
eignvec[ip][ip]= 1.0;
}

for(ip= 0;ip<n;ip++)
{
b[ip]= eignval[ip]= matrixin[ip][ip];
z[ip]= 0.0;
}

for(i= 0;i<50;i++)
{
rtn= printf("%d ",i);
assert(rtn>0);
sm= 0.0;
for(ip= 0;ip<n-1;ip++)
{
for(iq= ip+1;iq<n;iq++)sm+= fabs(matrixin[ip][iq]);
}

if(sm==0.0)
{
rtn= putchar('\n');
assert(rtn!=EOF);
break;
}

if(i<3)tresh= 0.2*sm/(real)SQUARE(n);
else tresh= 0.0;

for(ip= 0;ip<n-1;ip++)
{
for(iq= ip+1;iq<n;iq++)
{
g= 100.0*fabs(matrixin[ip][iq]);
if(i>3&&fabs(eignval[ip])+g==fabs(eignval[ip])
&&fabs(eignval[iq])+g==fabs(eignval[iq]))
{
matrixin[ip][iq]= 0.0;
}
else if(fabs(matrixin[ip][iq])>tresh)
{
h= eignval[iq]-eignval[ip];
if(fabs(h)+g==fabs(h))t= matrixin[ip][iq]/h;
else
{
theta= 0.5*h/matrixin[ip][iq];
t= 1.0/(fabs(theta)+sqrte(1.0+theta*theta));
if(theta<0.0)t= -t;
}

c= 1.0/sqrte(1+t*t);
s= t*c;
tau= s/(1.0+c);
h= t*matrixin[ip][iq];
z[ip]-= h;
z[iq]+= h;
eignval[ip]-= h;
eignval[iq]+= h;
matrixin[ip][iq]= 0.0;

for(j= 0;j<=ip-1;j++)
{
rotate_s(matrixin,&g,&h,s,tau,j,ip,j,iq);
}

for(j= ip+1;j<=iq-1;j++)
{
rotate_s(matrixin,&g,&h,s,tau,ip,j,j,iq);
}

for(j= iq+1;j<n;j++)
{
rotate_s(matrixin,&g,&h,s,tau,ip,j,iq,j);
}

for(j= 0;j<n;j++)
{
rotate_s(eignvec,&g,&h,s,tau,j,ip,j,iq);
}

(*nrot)++;

}

}

}

for(ip= 0;ip<n;ip++)
{
b[ip]+= z[ip];
eignval[ip]= b[ip];
z[ip]= 0.0;
}

}

if(i>=49)
{
rtn= puts("Too many iterations in jacobi");
assert(rtn!=EOF);
}




for(i= 0;i<n;i++)
{
p= eignval[k= i];
for(j= i+1;j<n;j++)
{
if(eignval[j]>=p)p= eignval[k= j];
}
if(k!=i)
{
eignval[k]= eignval[i];
eignval[i]= p;
for(j= 0;j<n;j++)
{
p= eignvec[j][i];
eignvec[j][i]= eignvec[j][k];
eignvec[j][k]= p;
}

}

}

fvec(z);
fvec(b);

return;
}

/*:10*//*12:*/
#line 303 "pppca.w"

void pcaer
(
pca_t pca,
int nnsam,
int nntax,
real**smdat,
real*rsum,
char**taxname,
file_t*stat
)

{
char buffer[LENSTR]= "";
const char*matrixtext[]= 
{
"linear correlation matrix",
"rank correlation matrix",
"covariance matrix"
};

real csumev= 0.0;
real score= 0.0;
real sumev= 0.0;

int m= 0;
int naxes= 0;
int nrot= 0;
static int models= 0;

loop_t jj= 0;
loop_t k= 0;
loop_t kk= 0;

void(*tranfunc[])(real*,real*,int,real*)= 
{NULL,pearsn,spear,covar};


real*bsvals= NULL;
real*evalue= NULL;

static real**evaluesd= NULL;
real**evector= NULL;
real**pcamat= NULL;
real**trandat= NULL;

naxes= MIN(pca.naxes,nntax);

trandat= amatreal(nntax,nnsam);
pcamat= amatreal(nntax,nntax);
evector= amatreal(nntax,nntax);
evalue= avecreal(nntax);
bsvals= avecreal(nntax);

dprint(&(*stat),"Calculating %s",matrixtext[pca.matrix-1]);
if(pca.model.ci)
{
if(models==0)
{
models= pca.model.n;
evaluesd= amatreal(nntax,models);
}
dprint(&(*stat)," (model %d of %d)",1+models-pca.model.n,models);
}
dprint(&(*stat),"\n");


datatran(pca.tran,nnsam,nntax,smdat,rsum,trandat,&(*stat));


bstick(bsvals,nntax);


rtn= fputc('\n',stat->fp);
assert(rtn!=EOF);
for(k= 0;k<nntax;k++)
{
m= (int)smdat[k][nnsam];
rtn= printf("%d ",k);
assert(rtn>0);
pstrcpy(buffer,taxname[m],7);
rtn= fprintf(stat->fp,"%-8s",buffer);
assert(rtn>0);


for(kk= 0;kk<=k;kk++)
{
tranfunc[pca.matrix](trandat[k],trandat[kk],nnsam,
&pcamat[k][kk]);
pcamat[kk][k]= pcamat[k][kk];
rtn= fprintf(stat->fp,"% 7.4f ",pcamat[k][kk]);
assert(rtn>0);
}

rtn= fputc('\n',stat->fp);
assert(rtn!=EOF);

}

rtn= fputs("        ",stat->fp);
assert(rtn!=EOF);


for(kk= 0;kk<nntax;kk++)
{
m= (int)smdat[kk][nnsam];
pstrcpy(buffer,taxname[m],7);
rtn= fprintf(stat->fp,"%-8s",buffer);
assert(rtn>0);
}

rtn= fputc('\n',stat->fp);
assert(rtn!=EOF);
dprint(&(*stat),"\nPrincipal components analysis\n");
rtn= fputc('\n',stat->fp);
assert(rtn!=EOF);

jacobi_s(pcamat,nntax,evalue,evector,&nrot);
if(pca.model.ci==ON)
{
for(k= 0;k<nntax;k++)evaluesd[k][pca.model.n-1]= evalue[k];
}


if(pca.model.ci==OFF&&evaluesd!=NULL)
{
real ave= 0.0;
real sd= 0.0;

for(k= 0;k<naxes;k++)
{
moment2(&sd,&ave,evaluesd[k],models);


evaluesd[k][0]= sd;

}

}

rtn= fprintf(stat->fp,"%d jacobi rotations for convergence\n\n"
"Eigenvectors\n\n    ",nrot);
assert(rtn>0);


for(k= 0;k<naxes;k++)
{
rtn= fprintf(stat->fp,"%10d",k+1);
assert(rtn>0);
}
rtn= fputc('\n',stat->fp);
assert(rtn!=EOF);
for(k= 0;k<nntax;k++)
{
m= (int)smdat[k][nnsam];
pstrcpy(buffer,taxname[m],7);
rtn= fprintf(stat->fp,"%-8s",buffer);
assert(rtn>0);

prnrealarray(stat->fp,"% 9.6f ",evector[k],naxes);

}

rtn= fputs("\n\n",stat->fp);
assert(rtn!=EOF);


if(pca.model.ci==OFF)
{
rtn= fprintf(stat->fp,"Eigenvalues\n\n"
"     Value     SD n=%-3d  Prop.     Cum. prop.\n",models);
assert(rtn>0);

sumev= sumrealarray(evalue,nntax);

for(k= 0,csumev= 0.0;k<naxes;k++)
{
rtn= fprintf(stat->fp,"%3d % 9.6f %9.6f %9.6f%s %8.6f\n",k+1,
evalue[k],evaluesd!=NULL?evaluesd[k][0]:0.0,
evalue[k]/sumev,bsvals[k]<evalue[k]/sumev?"*":" ",
csumev+= (evalue[k]/sumev));
assert(rtn>0);
}


rtn= fputs("\n\nSample scores\n\n      ",stat->fp);
assert(rtn!=EOF);
for(k= 0;k<naxes;k++)
{
rtn= fprintf(stat->fp,"%10d",k+1);
assert(rtn>0);
}
rtn= fputc('\n',stat->fp);
assert(rtn!=EOF);
for(jj= 0;jj<nnsam;jj++)
{

rtn= fprintf(stat->fp,"%9.3f ",smdat[nntax][jj]);
assert(rtn>0);
for(kk= 0;kk<naxes;kk++)
{
for(k= 0,score= 0.0;k<nntax;k++)
{
score+= (trandat[k][jj]*evector[k][kk]);
}

rtn= fprintf(stat->fp,"% 9.6f ",score);
assert(rtn>0);

}

rtn= fputc('\n',stat->fp);
assert(rtn!=EOF);

}

rtn= fputs("\n\n",stat->fp);
assert(rtn!=EOF);

}

if(!pca.model.ci&&evaluesd!=NULL)
{
fmatreal(evaluesd,nntax);
evaluesd= NULL;
}
fvec(bsvals);
fvec(evalue);
fmatreal(evector,nntax);
fmatreal(pcamat,nntax);
fmatreal(trandat,nntax);

return;
}

/*:12*//*14:*/
#line 550 "pppca.w"

void pearsn
(
real*x,
real*y,
int n,
real*r
)

{
real ax= 0.0;
real ay= 0.0;
real xt= 0.0;
real yt= 0.0;
real sxx= 0.0;
real sxy= 0.0;
real syy= 0.0;

loop_t j= 0;

ax= sumrealarray(x,n)/n;
ay= sumrealarray(y,n)/n;

for(j= 0;j<n;j++)
{
xt= x[j]-ax;
yt= y[j]-ay;
sxx+= xt*xt;
syy+= yt*yt;
sxy+= xt*yt;
}

*r= sxy/sqrte(sxx*syy);

return;
}

/*:14*//*16:*/
#line 597 "pppca.w"

static void rotate_s
(
real**a,
real*g,
real*h,
real s,
real tau,
int i,
int j,
int k,
int l
)

{
*g= a[i][j];
*h= a[k][l];
a[i][j]= *g-s*(*h+*g*tau);
a[k][l]= *h+s*(*g-*h*tau);

return;
}

/*:16*//*18:*/
#line 628 "pppca.w"

void spear
(
real*data1,
real*data2,
int n,
real*rs
)

{
real d= 0.0;
real en= 0.0;
real en3n= 0.0;
real fac= 0.0;
real sf= 0.0;
real sg= 0.0;
real tempval= 0.0;

loop_t j= 0;


real*wksp1= NULL;
real*wksp2= NULL;

int*indx= NULL;

wksp1= avecreal(n);
wksp2= avecreal(n);
indx= avecint(n);

for(j= 0;j<n;j++)
{
wksp1[j]= data1[j];
wksp2[j]= data2[j];
}

indexx(n,wksp1,indx);
sortinx(n,wksp2,indx);
crank(n,wksp1,&sf);

indexx(n,wksp2,indx);
sortinx(n,wksp1,indx);
crank(n,wksp2,&sg);

for(j= 0;j<n;j++)
{
tempval= wksp1[j]-wksp2[j];
d+= (SQUARE(tempval));
}
en= (real)n;
en3n= en*en*en-en;
fac= (1.0-sf/en3n)*(1.0-sg/en3n);
*rs= (1.0-(6.0/en3n)*(d+(sf+sg)/12.0))/sqrte(fac);

fvec(indx);
fvec(wksp2);
fvec(wksp1);

return;
}/*:18*/
