/*3:*/
#line 15 "ppran.w"

#include "psimpoll.h" 
#include "ppglobal.h" 

/*:3*//*4:*/
#line 20 "ppran.w"

/*8:*/
#line 184 "ppran.w"

static real fsuran_s(void);
/*:8*//*12:*/
#line 284 "ppran.w"

static real mzran13_s(void);
/*:12*//*14:*/
#line 341 "ppran.w"

static void psdes_s(unsigned long*lword,unsigned long*irword);
/*:14*//*16:*/
#line 390 "ppran.w"

static real ran0_s(void);
/*:16*//*18:*/
#line 430 "ppran.w"

static real ran1_s(void);
/*:18*//*20:*/
#line 498 "ppran.w"

static real ran2_s(void);
/*:20*//*22:*/
#line 569 "ppran.w"

static real ran3_s(void);
/*:22*//*24:*/
#line 652 "ppran.w"

static real ran4_s(void);
/*:24*//*26:*/
#line 713 "ppran.w"

static real ranqd1_s(void);
/*:26*/
#line 21 "ppran.w"

/*32:*/
#line 849 "ppran.w"

static void rinit(long unsigned congy,long unsigned shrgx);
static real uni(void);

/*:32*/
#line 22 "ppran.w"


/*:4*//*5:*/
#line 25 "ppran.w"

real(*ranfunc[])(void)= 
{
NULL,ran0_s,ran1_s,ran2_s,ran3_s,ran4_s,fsuran_s,ranqd1_s,mzran13_s
};

const long IA= 16807;
const long IA1= 40014L;
const long IA2= 40692L;
const long IM= 2147483647L;
const long IM1= 2147483563L;
const long IM2= 2147483399L;
const long IQ= 127773L;
const long IQ1= 53668L;
const long IQ2= 52774L;
const long IR= 2836;
const long IR1= 12211;
const long IR2= 3791;
const long MASK= 123459876L;
const long MBIG= 1000000000L;
const long MSEED= 161803398L;

const real EPS= 1.2e-7;

/*:5*//*7:*/
#line 65 "ppran.w"

real bnldev
(
real pp,
real sum
)

{
static flag_t iprng= OFF;

static real pold= -1.0;
static real pc= 0.0;
static real plog= 0.0;
static real pclog= 0.0;
static real en= 0.0;
static real oldg= 0.0;
real am= 0.0;
real em= 0.0;
real g= 0.0;
real angle= 0.0;
real p= 0.0;
real bnl= 0.0;
real sq= 0.0;
real t= 0.0;
real y= 0.0;

int n= 0;
static int nold= -1;

loop_t j= 0;

if(pp<=FLT_MIN)
{
return(0);
}

n= int2(sum);



if(!iprng)
{
long ltest= gl.idum;
gl.idum= -1;
if(gl.mran==5)(void)ran4_s();
gl.idum= -ltest;
iprng= ON;
}

p= (pp<=0.5?pp:1.0-pp);
am= n*p;

if(n<25)
{
bnl= 0.0;
for(j= 0;j<n;j++)
{
if(ranfunc[gl.mran]()<p)bnl+= 1.0;
}

}

else if(am<1.0)
{
g= expe(-am);
t= 1.0;
for(j= 0;j<n;j++)
{
t*= ranfunc[gl.mran]();
if(t<g)break;
}
bnl= (j<n?j:n);

}

else
{
if(n!=nold)
{
en= (real)n;
oldg= gammln(en+1.0);
nold= n;
}
if(p!=pold)
{
pc= 1.0-p;
plog= loge(p);
pclog= loge(pc);
pold= p;
}
sq= sqrte(2.0*am*pc);
do
{
do
{
angle= PI*ranfunc[gl.mran]();
y= tane(angle);
em= sq*y+am;
}while(em<0.0||em>=(en+1.0));

em= (real)floor((real)em);

t= 1.2*sq*(1.0+y*y)*
expe(oldg-gammln(em+1.0)-gammln(en-em+1.0)+em*plog+
(en-em)*pclog);

}while(ranfunc[gl.mran]()>t);

bnl= em;

}

if(p!=pp)bnl= n-bnl;

return(bnl);
}

/*:7*//*9:*/
#line 187 "ppran.w"

static real fsuran_s
(
void
)

{
if(gl.idum<0)
{
long unsigned idum1= 0;
long unsigned idum2= 0;
idum1= ULONG_MAX-(-gl.idum);
idum2= (unsigned)(-gl.idum);
rinit(idum1,idum2);
gl.idum= -gl.idum;
}

return(uni());
}

/*:9*//*11:*/
#line 223 "ppran.w"

real gasdev
(
void
)

{
real q= 0;
real x= 0;
real y= 0;

real v[2]= {0,0};

const real s= 0.449871;
const real t= -0.386595;
const real a= 0.19600;
const real b= 0.25472;
const real r1= 0.27597;
const real r2= 0.27846;

static flag_t iprng= OFF;

loop_t i= 0;



if(!iprng)
{
long ltest= gl.idum;
gl.idum= -1;
if(gl.mran==5)v[0]= ran4_s();
gl.idum= -ltest;
iprng= ON;
}

do
{
do
{

for(i= 0;i<2;i++)v[i]= ranfunc[gl.mran]();

v[1]= 1.7156F*(v[1]-0.5F);
x= v[0]-s;
y= fabse(v[1])-t;
q= x*x+y*(a*y-b*x);

if(q<r1)
{
return(v[1]/v[0]);
}

}while(q>r2);

}while(v[1]*v[1]>(-4*loge(v[0])*v[0]*v[0]));

return(v[1]/v[0]);
}

/*:11*//*13:*/
#line 287 "ppran.w"

static real mzran13_s
(
void
)

{
real temp= 0;

static unsigned long x= 521288629UL;
static unsigned long y= 362436069UL;
static unsigned long z= 16163801UL;
static unsigned long c= 1UL;
static unsigned long n= 1131199209UL;
static double ulongmax= ULONG_MAX;

long int s= 0;

if(gl.idum<=0)
{
x= (unsigned long)gl.idum;
gl.idum= -gl.idum;
}

if(y>x+c)
{
s= y-(x+c);
c= 0;
}
else
{
s= y-(x+c)-18;
c= 1;
}
x= y;
y= z;
z= s;
s+= (n-69069UL*n+1013904243UL);

temp= (real)((double)s/(ulongmax+1.0));

return(temp);
}

/*:13*//*15:*/
#line 344 "ppran.w"

static void psdes_s
(
unsigned long*lword,
unsigned long*irword
)

{
loop_t i= 0;

unsigned long ia= 0;
unsigned long ib= 0;
unsigned long iswap= 0;
unsigned long itmph= 0;
unsigned long itmpl= 0;

static const unsigned long c1[4]= 
{0xbaa96887L,0x1e17d32cL,0x03bcdc3cL,0x0f33d1b2L};
static const unsigned long c2[4]= 
{0x4b0f3b58L,0xe874f0c3L,0x6955c5a6L,0x55a7ca46L};

for(i= 0;i<4;i++)
{
ia= (iswap= (*irword))^c1[i];
itmpl= ia&0xffff;
itmph= ia>>16;
ib= itmpl*itmpl+~(itmph*itmph);
*irword= (*lword)^(((ia= (ib>>16)|((ib&0xffff)<<16))
^c2[i])+itmpl*itmph);
*lword= iswap;
}

return;
}

/*:15*//*17:*/
#line 393 "ppran.w"

static real ran0_s
(
void
)

{
long k= 0L;

double ans= 0.0;
double AM= 0.0;

AM= (1.0/(double)IM);

gl.idum^= MASK;
k= gl.idum/IQ;
gl.idum= IA*(gl.idum-k*IQ)-IR*k;
if(gl.idum<0)gl.idum+= IM;
ans= AM*(double)gl.idum;
gl.idum^= MASK;

return((real)ans);
}

/*:17*//*19:*/
#line 433 "ppran.w"

static real ran1_s
(
void
)


{
loop_t j= 0;

long k= 0L;
long NDIV= 0L;
static long iy= 0L;
static long iv[32];

double AM= 0.0;
double RNMX= 0.0;

real temp= 0;

NDIV= 1+(IM-1)/32;
AM= 1.0/(double)IM;
RNMX= 1.0-EPS;

if(gl.idum<=0||!iy)
{
if(-gl.idum<1)gl.idum= 1;
else gl.idum= -gl.idum;
for(j= 32+7;j>=0;j--)
{
k= gl.idum/IQ;
gl.idum= IA*(gl.idum-k*IQ)-IR*k;
if(gl.idum<0)gl.idum+= IM;
if(j<32)iv[j]= gl.idum;
}

iy= iv[0];

}

k= gl.idum/IQ;
gl.idum= IA*(gl.idum-k*IQ)-IR*k;
if(gl.idum<0)gl.idum+= IM;
j= (int)(iy/NDIV);
iy= iv[j];
iv[j]= gl.idum;
temp= (real)MIN(AM*(double)iy,RNMX);

return(temp);
}

/*:19*//*21:*/
#line 501 "ppran.w"

static real ran2_s
(
void
)

{
loop_t j= 0;

long k= 0L;
static long idum2= 123456789L;
long NDIV= 0L;
static long iy= 0L;

real temp= 0;
double AM= 0.0;
double RNMX= 0.0;

static long iv[32];

NDIV= 1+(IM1-1)/32;
AM= 1.0/(double)IM1;
RNMX= 1.0-EPS;

if(gl.idum<=0)
{
if(-gl.idum<1)gl.idum= 1;
else gl.idum= -gl.idum;
idum2= gl.idum;
for(j= 32+7;j>=0;j--)
{
k= gl.idum/IQ1;
gl.idum= IA1*(gl.idum-k*IQ1)-k*IR1;
if(gl.idum<0)gl.idum+= IM1;
if(j<32)iv[j]= gl.idum;
}

iy= iv[0];

}

k= gl.idum/IQ1;
gl.idum= IA1*(gl.idum-k*IQ1)-k*IR1;
if(gl.idum<0)gl.idum+= IM1;
k= idum2/IQ2;
idum2= IA2*(idum2-k*IQ2)-k*IR2;
if(idum2<0)idum2+= IM2;
j= (int)(iy/NDIV);
iy= iv[j]-idum2;
iv[j]= gl.idum;
if(iy<1)iy+= (IM1-1);
temp= (real)MIN(AM*(double)iy,RNMX);

return(temp);
}

/*:21*//*23:*/
#line 572 "ppran.w"

static real ran3_s
(
void
)

{
int ii= 0;
static int iff= 0;
static int inext= 0;
static int inextp= 0;

loop_t i= 0;
loop_t k= 0;

long mj= 0L;
long mk= 0L;
long MZ= 0L;

static double FAC= 0.0;

static long ma[56];

FAC= 1.0/MBIG;

if(gl.idum<0||iff==0)
{
iff= 1;
mj= MSEED-(gl.idum<0?-gl.idum:gl.idum);
mj%= MBIG;
ma[55]= mj;
mk= 1;
for(i= 1;i<=54;i++)
{
ii= (21*i)%55;
ma[ii]= mk;
mk= mj-mk;
if(mk<MZ)mk+= MBIG;
mj= ma[ii];
}
for(k= 1;k<=4;k++)
{
for(i= 1;i<=55;i++)
{
ma[i]-= ma[1+(i+30)%55];
if(ma[i]<MZ)ma[i]+= MBIG;
}

}

inext= 0;
inextp= 31;
gl.idum= 1;

}

if(++inext==56)inext= 1;
if(++inextp==56)inextp= 1;
mj= ma[inext]-ma[inextp];
if(mj<MZ)mj+= MBIG;
ma[inext]= mj;

return((real)(mj*FAC));
}

/*:23*//*25:*/
#line 655 "ppran.w"

static real ran4_s
(
void
)

{
flag_t testflag= OFF;

unsigned long irword;
unsigned long itemp;
unsigned long lword;

static long idums= 0;


static unsigned long jflone= 0x3f800000L;
static unsigned long jflmsk= 0x007fffffL;







if(gl.idum<0)
{
if(gl.idum==-1)testflag= ON;
idums= -gl.idum;
gl.idum= 1;
}

irword= gl.idum;
lword= idums;

psdes_s(&lword,&irword);








if(testflag&&(lword!=0x604d1dceL||irword!=0x509c0c23L))derror(13);

itemp= jflone|(jflmsk&irword);
++gl.idum;

return((*(real*)&itemp)-1);
}

/*:25*//*27:*/
#line 716 "ppran.w"

static real ranqd1_s
(
void
)

{
real a= 0;
a= (real)(rand())/(RAND_MAX+1.0);
return(a);
}

/*:27*//*29:*/
#line 733 "ppran.w"

void tranran
(
real**x,
int row,
int column
)

{
int i1= 0;
int i2= 0;

loop_t iter= 0;
loop_t j= 0;
loop_t k= 0;

long seed= 0L;


real**y= NULL;
int*temp= NULL;


y= amatreal(row,column);
temp= avecint(column+1);


for(j= 0;j<column;j++)temp[j]= j;


seed= gl.idum;
gl.idum= -labs(gl.idum);


for(iter= 0;iter<100;iter++)(void)ranfunc[gl.mran]();



for(j= 0;j<10*column;j++)
{
i1= (int)(column*ranfunc[gl.mran]());
i2= (int)(column*ranfunc[gl.mran]());
temp[column]= temp[i2];
temp[i2]= temp[i1];
temp[i1]= temp[column];
}



for(k= 0;k<row;k++)
{
for(j= 0;j<column;j++)y[k][j]= x[k][temp[j]];
}


for(k= 0;k<row;k++)
{
for(j= 0;j<column;j++)x[k][j]= y[k][j];
}

gl.idum= seed;


fvec(temp);
fmatreal(y,row);

return;
}

/*:29*//*31:*/
#line 826 "ppran.w"

#if 0==1
extern double uni(void),vni(void);
extern double duni(void),dvni(void);
#endif

static long i32bit(void);
static long i31bit(void);

#if 0==1
extern short i16bit(void),i15bit(void);extern void rinit(long
unsigned congx,long unsigned shrgx);extern char i8bit(void),
i7bit(void),i1bit(void);
#endif

static void SWBfill(long*x);
static long swb32fill(void);

#if 0==1
char swbstate[];int swbsize;
#endif

/*:31*//*33:*/
#line 875 "ppran.w"

#define N 37 
#define N2 24 

long swb32[N],

swb16[N],

swb8[N],
swbseed[N]= 
{
0x0D45D69AL,
0x9DB73B1AL,0xA84604E8L,0x7C5F0CA5L,0xBC0196CEL,0xFF4CB42EL,0x7ACA6BE3L,
0xA9ED2A5AL,0x6405A8F7L,0xAC00D4F8L,0xBDD1FC77L,0x064F9DC5L,0xF10AB737L,
0x781293D3L,0x8410C2D2L,0x1C6587DBL,0x7D8F8F0FL,0xF3DCC4EAL,0xB965F99FL,
0x9A0094D1L,0x65976D1CL,0x09173DC1L,0x8E38B992L,0x84701D44L,0x14F0E1B9L,
0xE8A1EC5FL,0x1E925A12L,0xE77A0B5BL,0xCDB5926EL,0xD16260C8L,0xC917E806L,
0x519076AAL,0x7BF6C21CL,0x808C0C90L,0x3E93C7B8L,0x707D6EA0L,
0xF1DB698DL
};
char flags= 0;
long unsigned congx= 0x1C3a128FL;

long*swb32p;
short swb32n= 0;
short*swb16p;
short swb16n= 0;
char*swb8p;
short swb8n= 0;

char swb1[32];
char*swb1p;
short swb1n= 0;




















/*:33*//*34:*/
#line 929 "ppran.w"

void rinit
(
long unsigned congy,
long unsigned shrgx
)

{
short i,j;
unsigned long tidbits= 0L;

congx= congy*2+1;
for(i= 0;i<N;i++)
{
for(j= 32;j>0;j--)
{
congx= congx*69069L;
shrgx= shrgx^(shrgx>>15);
shrgx= shrgx^(shrgx<<17);
tidbits= (tidbits>>1)|(0x80000000L&(congx^shrgx));
}
swbseed[i]= tidbits;
}
swb32n= swb16n= swb8n= swb1n= 0;
flags= 0;
}

/*:34*//*35:*/
#line 974 "ppran.w"

#define SWB(c,x,y,z) \
c =  (y<0) ? (((z= x-y-c) < 0) || (x>=0)) : (((z= x-y-c) < 0) && (x>=0));

static void SWBfill
(
long*x
)

{
short i;






for(i= 0;i<N2;i++)
SWB(flags,swbseed[i+N-N2],swbseed[i],swbseed[i]);
for(i= N2;i<N;i++)
SWB(flags,swbseed[i-N2],swbseed[i],swbseed[i]);

#ifndef fast 

for(i= 0;i<N;i++)
*(x++)= swbseed[i]^(congx= congx*69069L);

#else
for(i= 0;i<N;i++)*(x++)= swbseed[i];
#endif

}

static long swb32fill
(
void
)

{
swb32p= &swb32[0];
SWBfill(&swb32[0]);
swb32n= N-1;
return*(swb32p++);
}

#if 0==1

static short swb16fill(void){swb16p= (short*)&swb16[0];SWBfill((long
*)swb16p);swb16n= 2*N-1;return*(swb16p++);}

static char swb8fill(void){swb8p= (char*)&swb8[0];SWBfill((long*)
swb8p);swb8n= 4*N-1;return*(swb8p++);}

#endif

static long i32bit
(
void
)

{
return(swb32n--)?*(swb32p++):swb32fill();
}


static long i31bit
(
void
)

{
return((swb32n--)?*(swb32p++):swb32fill())&0x7FFFFFFFL;
}

#if 0==1

short i16bit(void){return(swb16n--)?*(swb16p++):swb16fill();}
short i15bit(void){return((swb16n--)?*(swb16p++):swb16fill())&
0x7FFF;}char i8bit(void){return(swb8n--)?*(swb8p++):
swb8fill();}char i7bit(void){return((swb8n--)?*(swb8p++):
swb8fill())&0x7F;}

char swb1fill(void){unsigned long i,j;swb1p= &swb1[0];swb1n= 31;i= 
i32bit();for(j= 0;j<32;j++){swb1[j]= i&1;i= i>>1;}*Turbo C does not
like the return*(swb1p++);*swb1[j]= i&1}

char i1bit(void){return(swb1n--)?*(swb1p++):swb1fill();}

#endif

#define two2neg31  ( (2.0/0x10000L) / 0x10000L )
#define two2neg32  ( (1.0/0x10000L) / 0x10000L )

#if 0==1

float vni(void){long temp;temp= i32bit();if(temp&0xFF000000L){
return temp*two2neg31;}return(temp+i32bit()*two2neg32)*
two2neg31;}

#endif

real uni
(
void
)

{
long temp;

temp= i31bit();
if(temp&0xFF000000L)
{
return(real)(temp*two2neg31);
}
return(real)((temp+i32bit()*two2neg32)*two2neg31);
}

#if 0==1

double dvni(void){unsigned long temp;temp= i32bit();return((long)
i32bit()+temp*two2neg32)*two2neg31;}

double duni(void){unsigned long temp;temp= i32bit();return(i31bit()+
temp*two2neg32)*two2neg31;}

#endif/*:35*/
