/*3:*/
#line 15 "pproc.w"

#include "psimpoll.h" 
#include "ppglobal.h" 

/*:3*//*4:*/
#line 20 "pproc.w"

/*7:*/
#line 187 "pproc.w"

static void dcang_s(real**rocdat,int nnsam,int nntax,real*res,int m);
/*:7*//*9:*/
#line 221 "pproc.w"

static void dcchi1_s(real**rocdat,int nnsam,int nntax,real*res,int m);
/*:9*//*11:*/
#line 264 "pproc.w"

static void dcchi2_s(real**rocdat,int nnsam,int nntax,real*res,int m);
/*:11*//*13:*/
#line 304 "pproc.w"

static void dcchord_s(real**rocdat,int nnsam,int nntax,real*res,int m);
/*:13*//*15:*/
#line 337 "pproc.w"

static void dceuc_s(real**rocdat,int nnsam,int nntax,real*res,int m);
/*:15*//*17:*/
#line 370 "pproc.w"

static void dcinf_s(real**rocdat,int nnsam,int nntax,real*res,int m);
/*:17*//*19:*/
#line 416 "pproc.w"

static void dcman_s(real**rocdat,int nnsam,int nntax,real*res,int m);
/*:19*//*21:*/
#line 449 "pproc.w"

static void dcseuc_s(real**rocdat,int nnsam,int nntax,real*res,int m);
/*:21*/
#line 21 "pproc.w"


/*:4*//*6:*/
#line 29 "pproc.w"

void rocer
(
roc_t roc,
real**smdat,
real*rsum,
data_t*data,
int nnsam,
int nntax,
file_t*stat
)

{
int m= 0;
static int models= 0;

loop_t j= 0;
loop_t jj= 0;
loop_t kk= 0;

void(*dcfunc[])(real**,int,int,real*,int)= 
{NULL,dcchord_s,dcinf_s,dcchi1_s,dcchi2_s,dcman_s,dceuc_s,dcang_s,dcseuc_s};


real*res= NULL;
static real**ressd= NULL;
real**rocdat= NULL;

rtn= fputs("Rate-of-change analysis\n",gl.logf.fp);
assert(rtn!=EOF);

rocdat= amatreal(nntax+1,nnsam);


datatran(0,nnsam,nntax,smdat,rsum,rocdat,&gl.logf);

if(roc.smooth>0)
{
rtn= fputs("Smoothing data ",stdout);
assert(rtn!=EOF);


for(j= 0;j<nnsam;j++)rocdat[nntax][j]= smdat[nntax][j];

m= roc.smooth/2;
for(kk= 0;kk<nntax;kk++)
{
rtn= printf("%d ",kk);
assert(rtn>0);
smooth(rocdat[kk],rocdat[nntax],nnsam,roc.smooth);
}

rtn= putchar('\n');
assert(rtn!=EOF);

}

if(models==0)
{
rtn= puts(roc.text[roc.diss]);
assert(rtn!=EOF);
}

res= avecreal(nnsam-1);

if(roc.model.ci==ON)
{
if(models==0)
{
models= roc.model.n;
ressd= amatreal(nnsam-1,models);
rtn= fprintf(stat->fp,"Results from %d models\n",models);
assert(rtn>0);
}
dprint(&gl.logf,"model %d of %d\n",1+models-roc.model.n,models);
}


(*dcfunc[roc.diss])(rocdat,nnsam,nntax,res,m);

for(jj= 0;jj<m;jj++)data->dat[data->ntax-1][jj]= (float)-1;


for(j= m,jj= m;jj<data->nsam-(m+1);jj++)
{
if(data->levfg[jj]==ON&&j<nnsam-(m+1))
{
res[j]/= (fabs((real)smdat[nntax][j]-smdat[nntax][j+1])/100);
data->dat[data->ntax-1][jj]= (float)res[j];
j++;
}

else data->dat[data->ntax-1][jj]= (float)-1;

}

for(jj= data->nsam-(m+1);jj<data->nsam;jj++)
{
data->dat[data->ntax-1][jj]= (float)-1;
}

if(roc.model.ci==ON)
{
for(j= m;j<nnsam-(m+1);j++)ressd[j][roc.model.n-1]= res[j];
}

if(data->alevsd==NULL)
{
dprint(&(*stat),"Errors on age estimates not available\n");
}



if(roc.model.ci==OFF&&ressd!=NULL)
{
real ave= 0.0;
real sd= 0.0;

for(j= m;j<nnsam-(m+1);j++)
{

moment2(&sd,&ave,ressd[j],models);

if(data->alevsd!=NULL)
{
real tempval= 0;

tempval= pythag(smdat[nntax+1][j],smdat[nntax+1][j+1]);

tempval= errprop3(smdat[nntax][j]-smdat[nntax][j+1],tempval,
100,0);
sd= errprop3(res[j],sd,
(smdat[nntax][j]-smdat[nntax][j+1])/100,tempval);
}

rtn= fprintf(stat->fp,"sample %d mean %f sd %f\n",j,ave,sd);
assert(rtn>0);

}

rtn= fputs("\n\n",stat->fp);
assert(rtn!=EOF);

}

if(roc.model.ci==OFF&&ressd!=NULL)
{
fmatreal(ressd,nnsam-1);
ressd= NULL;
}
fmatreal(rocdat,nntax+1);
fvec(res);

return;
}

/*:6*//*8:*/
#line 190 "pproc.w"

static void dcang_s
(
real**rocdat,
int nnsam,
int nntax,
real*res,
int m
)

{
loop_t j= 0;
loop_t kk= 0;

for(j= m;j<nnsam-(m+1);j++)
{
for(kk= 0;kk<nntax;kk++)
{
res[j]+= (sqrte(rocdat[kk][j]*rocdat[kk][j+1]));
}

res[j]= acos(res[j]);
if(res[j]>PI/2.0)derror(17);

}

return;
}

/*:8*//*10:*/
#line 224 "pproc.w"

static void dcchi1_s
(
real**rocdat,
int nnsam,
int nntax,
real*res,
int m
)

{
loop_t j= 0;
loop_t kk= 0;

real tempval1= 0;
real tempval2= 0;

for(kk= 0;kk<nntax;kk++)
{
for(j= m;j<nnsam-(m+1);j++)
{
tempval1= rocdat[kk][j]+rocdat[kk][j+1];
tempval2= SQUARE(rocdat[kk][j]-rocdat[kk][j+1]);
if(tempval1>0)res[j]+= (tempval2/tempval1);
}

}

for(j= m;j<nnsam-(m+1);j++)
{
if(res[j]>2.0)derror(17);
res[j]= sqrte(res[j]);
}

return;

}

/*:10*//*12:*/
#line 267 "pproc.w"

static void dcchi2_s
(
real**rocdat,
int nnsam,
int nntax,
real*res,
int m
)

{
loop_t j= 0;
loop_t kk= 0;

real tempval1= 0;
real tempval2= 0;

for(kk= 0;kk<nntax;kk++)
{
tempval1= 0;
for(j= m;j<nnsam-m;j++)tempval1+= rocdat[kk][j];
for(j= m;j<nnsam-(m+1);j++)
{
tempval2= SQUARE(rocdat[kk][j]-rocdat[kk][j+1]);
res[j]+= (tempval2/tempval1);
}

}

for(j= m;j<nnsam-(m+1);j++)res[j]= sqrte(res[j]);

return;

}

/*:12*//*14:*/
#line 307 "pproc.w"

static void dcchord_s
(
real**rocdat,
int nnsam,
int nntax,
real*res,
int m
)

{
loop_t j= 0;
loop_t kk= 0;

for(j= m;j<nnsam-(m+1);j++)
{
for(kk= 0;kk<nntax;kk++)
{
res[j]+= (sqrte(rocdat[kk][j]*rocdat[kk][j+1]));
}
if(res[j]>1.0)derror(17);
res[j]= sqrte(2-2*res[j]);

}

return;
}

/*:14*//*16:*/
#line 340 "pproc.w"

static void dceuc_s
(
real**rocdat,
int nnsam,
int nntax,
real*res,
int m
)

{
loop_t j= 0;
loop_t kk= 0;

for(j= m;j<nnsam-(m+1);j++)
{
for(kk= 0;kk<nntax;kk++)
{
res[j]+= SQUARE(rocdat[kk][j]-rocdat[kk][j+1]);
}

res[j]= sqrte(res[j]);

}

return;
}

/*:16*//*18:*/
#line 373 "pproc.w"

static void dcinf_s
(
real**rocdat,
int nnsam,
int nntax,
real*res,
int m
)

{
loop_t j= 0;
loop_t kk= 0;

real tempval1= 0;
real tempval2= 0;
real tempval3= 0;

for(j= m;j<nnsam-(m+1);j++)
{
for(kk= 0;kk<nntax;kk++)
{
if((tempval3= rocdat[kk][j]+rocdat[kk][j+1])!=0)
{
tempval3= 2/tempval3;
}
tempval1= tempval3*rocdat[kk][j];
tempval2= tempval3*rocdat[kk][j+1];
if(tempval1!=0)tempval1= rocdat[kk][j]*loge(tempval1);
if(tempval2!=0)tempval2= rocdat[kk][j+1]*loge(tempval2);
res[j]+= tempval1+tempval2;

}

if(res[j]>2*LOG2)derror(17);

}

return;
}

/*:18*//*20:*/
#line 419 "pproc.w"

static void dcman_s
(
real**rocdat,
int nnsam,
int nntax,
real*res,
int m
)

{
loop_t j= 0;
loop_t kk= 0;

for(j= m;j<nnsam-(m+1);j++)
{
for(kk= 0;kk<nntax;kk++)
{
res[j]+= (fabs(rocdat[kk][j]-rocdat[kk][j+1]));
}

if(res[j]>2)derror(17);

}

return;
}

/*:20*//*22:*/
#line 452 "pproc.w"

static void dcseuc_s
(
real**rocdat,
int nnsam,
int nntax,
real*res,
int m
)

{
loop_t j= 0;
loop_t kk= 0;

real tempval1= 0;
real tempval2= 0;
real tempval3= 0;

for(kk= 0;kk<nntax;kk++)
{

tempval1= 0;
for(j= m;j<nnsam-(m+1);j++)tempval1+= rocdat[kk][j];
tempval1/= nnsam;

tempval2= 0;
for(j= m;j<nnsam-(m+1);j++)
{
tempval2+= SQUARE(rocdat[kk][j]-tempval1);
}
tempval2/= ((real)nnsam-1.0);
tempval2= sqrte(tempval2);

for(j= m;j<nnsam-(m+1);j++)
{
tempval3= rocdat[kk][j]-rocdat[kk][j+1];
res[j]+= SQUARE(tempval3/tempval2);
}

}

for(j= m;j<nnsam-(m+1);j++)res[j]= sqrte(res[j]);

return;
}/*:22*/
