/*28:*/
#line 277 "pphead.w"

enum curve_t{PLAIN,SUMMARY,CONFIN,NUMBER,HIST};
enum flag_e{OFF= 0,ON= -1};
enum format_e{PSIMPOLL= 0,CORNELL= 1};
enum input_e{PSIMPOL= 0,TILIA= 1};
enum script_t{SCRWRITE,SCRREAD};
enum stream_t{CLOSED,OPEN};
enum style_t{OUTL,FILL};
enum plot_t{MAINP,ADP};
enum interp_e{PAIR,LINEFIT};
enum paper_e{A4,A3,LETTER,LEGAL};

/*:28*//*29:*/
#line 290 "pphead.w"

typedef enum flag_e flag_t;
typedef enum format_e format_t;
typedef enum input_e input_t;
typedef enum interp_e interp_t;
typedef enum paper_e paper_t;

typedef int letter_t;
typedef int loop_t;

#ifdef DOUBLE 
typedef double real;
#else 
typedef float real;
#endif

typedef char*Pchar;
typedef float*Pfloat;
typedef real*Preal;
typedef int*Pint;


/*:29*//*30:*/
#line 313 "pphead.w"

typedef struct
{
flag_t ci;
int n;
}model_t;

typedef struct
{
long n;
long*id;
real**val;
char**name;
long*zoneid;
long*tsid;
long back;
long fore;
}colour_t;

typedef struct
{
flag_t flag;
flag_t timx;
real up;
real upsd;
real base;
real basesd;
int model;
int nterm;
real c14k;
flag_t adbc;
}age_t;

typedef struct
{
char*base;
char*c14;
char*ps1;
char*ps2;
char*time;
char*sed;
char*zone;
char*subtitle;
char*adxaxis;
char*adyaxis;
}caption_t;

typedef struct
{
real*lgmv;
real*lgsmv;
real*mv;
real*mvsd;
real**ex;
}conc_t;

typedef struct
{
flag_t flag;
flag_t adflag;
int meth;
int nran;
real cvsed;
}ci_t;

typedef struct
{
int dat;
int yax;
}code_t;

typedef struct
{
real*x;
real*y;
int n;
real*y2a;
real range;
int nterm;
}eval_t;

typedef struct
{
char fname[LENFNAME];
FILE*fp;
enum stream_t st;
char mode[2];
}file_t;

typedef struct
{
int code;
int num;
char rom[25];
char ital[25];
real fac;
real ufac;
}font_t;

typedef struct
{
flag_t flag;
int tran;
}four_t;

typedef struct
{
flag_t all;
flag_t bars;
flag_t bull;
real lval;
flag_t exchar;
flag_t ix10;
flag_t indscale;
flag_t indspl;
flag_t join;
flag_t label;
enum style_t style;
real shade;
enum curve_t curve;
real scale;
real finscale;
real max;
real min;
flag_t ulimit;
int rot;
real hist;
enum script_t script;
flag_t sum2col;
int skip;
real datamax;
real datamin;
real median;
real lq;
real uq;
flag_t c14scale;
flag_t interp;
long colpl;
long coltit;
long coldep;
long col14c;
long colts;
long colzone;
long colxax;
long colsdpl;
real penwid;
}frame_t;

typedef struct
{
real thresh;
flag_t stat;
}num_t;

typedef struct
{
real high;
real wide;
real prop;
real minpl;
real sep;
real xmg;
real ymg;
real yscbeg;
real time;
real ad;
real ts;
real zon;
real c14;
real ylo;
int nysum;
real*ysumhi;
real*ysumlo;
real charsc;
real lineht;
}page_t;

typedef struct
{
flag_t flag;
int n;
}rare_t;

typedef struct
{
int num;
int nuse;
char**age;
char**sd;
real*dp1;
real*dp2;
}rc14_t;

typedef struct
{
flag_t udata;
real max;
real min;
real umax;
real umin;
real origmin;
real ex;
flag_t adsc;
real majmark;
real minmark;
int maxpos;
int minpos;
real interp;
real intstart;
real intstop;
interp_t inttype;
}samp_t;

typedef struct
{
real*ar;
real*arsd;
}sed_t;

typedef struct
{
char**name;
int n;
real*grey;
long*colid;
}summary_t;

typedef struct
{
int num;
char*lab;
int*val;
real*dep;
}ts_t;

typedef struct
{
int ntick;
real*val;
char**annot;
real leng;
}xaxis_t;

typedef struct
{
int num;
char**lab;
real*dep;
}zone_t;


/*:30*//*31:*/
#line 565 "pphead.w"

typedef struct
{
flag_t flag;
int tran;
model_t model;
flag_t iweigh;
flag_t irescfg;
int iresc;
flag_t dca;
int mk;
float resth;
}ca_t;

typedef struct
{
int nsam;
int ntax;
char intitle[LENSTR];
float*alev;
float*alevold;
flag_t*levfg;
real*alevsd;
float**dat;
char**taxname;
conc_t conc;
real*histwid;
summary_t summary;
char**exlabel;
}data_t;

typedef struct
{
flag_t flag;
int matrix;
int naxes;
int tran;
model_t model;
}pca_t;

typedef struct
{
flag_t flag;
int diss;
int smooth;
const char*text[9];
model_t model;
}roc_t;

typedef struct
{
flag_t flag;
int n;
int meth;
char pre[LENSTR/4];
int tran;
flag_t ransam;
model_t model;
}zoner_t;

typedef struct
{
char prog[10];
real ver;
const char*time;
const char*date;
file_t logf;
font_t font;
code_t code;
long idum;
int mran;
char seed[11];
flag_t flag[6];
flag_t recalc;
page_t page;
page_t adpage;
int openfiles;
clock_t clockstart;
flag_t tufte;
input_t input;
colour_t palette;
flag_t colzone;
flag_t colts;
real neglev;
paper_t paper;
real papht;
real papwid;
}Global;

/*:31*/
