/*3:*/
#line 15 "ppzoner.w"

#include "psimpoll.h" 
#include "ppglobal.h" 

/*:3*//*4:*/
#line 20 "ppzoner.w"

/*5:*/
#line 25 "ppzoner.w"

static void zmodres_s(FILE*fp,int numzone,int nnsam,int**bmarker,
char**omarker,real*dat,int models,int meth);
/*:5*//*7:*/
#line 125 "ppzoner.w"

static int zonbin_s(real**table,int nnsam,flag_t*label,real prevmin,
real*val);
/*:7*//*11:*/
#line 559 "ppzoner.w"

static void zonopt_s(real**table,real**opttab,int**optmarktab,
int nnsam,int n);
/*:11*//*13:*/
#line 606 "ppzoner.w"

static real zonlstab_s(real*sqtotal,real*total,real**x,int nntax,int m,
int n);
/*:13*//*15:*/
#line 644 "ppzoner.w"

static real zoninftab_s(real*sqtotal,real*total,real**x,int nntax,int m,
int n);
/*:15*//*17:*/
#line 686 "ppzoner.w"

static void zprint_s(const zoner_t zoner,const int i,real varczon,
real varpzon,real vart,file_t*stat,real*zonlev,real bsval);
/*:17*//*31:*/
#line 1245 "ppzoner.w"

static void prnzonelen_s(FILE*fp,real*data,int nnsam,real*zonlev,
int numzone);
/*:31*/
#line 21 "ppzoner.w"


/*:4*//*6:*/
#line 29 "ppzoner.w"

static void zmodres_s
(
FILE*fp,
int numzone,
int nnsam,
int**bmarker,
char**omarker,
real*dat,
int models,
int meth
)

{
real tempval= 0;

int n= 0;

loop_t i= 0;
loop_t j= 0;

rtn= fputs("\n\nModelling summary\n",fp);
assert(rtn!=EOF);
if(bmarker!=NULL)
{
if(meth==5)rtn= fputs("CONISS\n",fp);
else rtn= fputs("Binary splitting\n",fp);
assert(rtn!=EOF);
for(i= 0;i<numzone-1;i++)
{
rtn= fprintf(fp,"Zone marker %d: ",i+1);
assert(rtn>0);
for(j= 0;j<nnsam-1;j++)
{
if(bmarker[j][i]!=0)
{
tempval= (dat[j]+dat[j+1])/2;
if(models==0)
{
rtn= fprintf(fp,"%.3f: %d ",tempval,bmarker[j][i]);
}
else
{
rtn= fprintf(fp,"%.3f: %d (%.1f%%) ",tempval,bmarker[j][i],
100*(real)bmarker[j][i]/models);
}
assert(rtn>0);
}

}

rtn= fputc('\n',fp);
assert(rtn!=EOF);

}

rtn= fputs("\n\n",fp);
assert(rtn!=EOF);

}

else if(omarker!=NULL)
{
rtn= fputs("Optimal splitting\nPatterns of markers found:\n",fp);
assert(rtn!=EOF);
for(i= 0;i<models;i++)
{
if(omarker[i][0]!='\0')
{
n= 1;
rtn= fprintf(fp,"%s ",omarker[i]);
assert(rtn>0);
for(j= i+1;j<models;j++)
{
if(strcmp(omarker[i],omarker[j])==0)
{
n++;
omarker[j][0]= '\0';
}
}

if(models==0)rtn= fprintf(fp,"%d\n",n);
else rtn= fprintf(fp,"%d (%.1f%%)\n",n,100*(real)n/models);
assert(rtn>0);

}

}

}

return;
}

/*:6*//*8:*/
#line 129 "ppzoner.w"

static int zonbin_s
(
real**table,
int nnsam,
flag_t*label,
real prevmin,
real*val
)

{
int lmark= 0;
int mark= 0;
int umark= 0;

loop_t i= 0;
loop_t j= 0;

real newval= 0;

for(j= 0,*val= FLT_MAX,lmark= 0;j<nnsam;j++)
{
if(label[j]==ON)
{
umark= j;
for(i= lmark;i<umark;i++)
{
newval= table[lmark][umark-lmark]-
(table[lmark][i-lmark]+table[i+1][umark-(i+1)]);
if(prevmin-newval<*val)
{
*val= prevmin-newval;
mark= i;
}

}
lmark= umark+1;

}

}

return(mark);
}

/*:8*//*10:*/
#line 188 "ppzoner.w"

void zonation
(
const zoner_t zoner,
int nnsam,
int nntax,
real**smdat,
real*rsum,
file_t*zone,
file_t*stat
)

{
char buffer[LENSTR]= "";
const char*const text[4]= 
{
"binary splitting ","optimal splitting ",
"by sums-of-squares","by information content"
};
real lssic= 0;
real prevlssic= 0;
real val= 0;

flag_t prnflag= ON;

int i= 0;
int mark= 0;
int numzone= 0;
static int models= 0;
int str1= 0;
int str2= 0;

loop_t j= 0;
loop_t jj= 0;
loop_t k= 0;
loop_t kk= 0;
loop_t l= 0;
loop_t m= 0;


static char**omarker= NULL;

real*bsvals= NULL;
real*sqtotal= NULL;
real*total= NULL;

real**opttab= NULL;
real**table= NULL;
real**trandat= NULL;

real*zonlev= NULL;

flag_t*label= NULL;

static int**bmarker= NULL;
int**optmarktab= NULL;

str1= (zoner.meth==1||zoner.meth==2)?0:1;
str2= (zoner.meth==1||zoner.meth==3)?2:3;

vstrcat(LENSTR,buffer,"Zonation: ",text[str1],text[str2],(char*)NULL);

if(stat->st==OPEN)
{
rtn= fputs("\n\n",stat->fp);
assert(rtn!=EOF);
}

if(zoner.n==0)
{
numzone= -1;
dprint(&(*stat),"%s\n",buffer);
}
else
{
numzone= MIN(zoner.n,nnsam-2);
dprint(&(*stat),"%s into %d zones",buffer,numzone);
if(zoner.model.ci)
{
if(bmarker==NULL&&omarker==NULL)models= zoner.model.n;
dprint(&(*stat)," (model %d of %d)",1+models-zoner.model.n,
models);
}
dprint(&(*stat),"\n");

}

if(zoner.model.ci==OFF&&zoner.ransam==OFF)
{
zone->mode[0]= 'w';
openf(&(*zone),__FILE__,__LINE__,OFF);
if(zone->st==CLOSED)
{
dprint(&gl.logf,"No ZONE file: zonation abandoned\n");
return;
}

}



table= amatreal(nnsam,-1);


trandat= amatreal(nntax,nnsam);


total= avecreal(nntax);
sqtotal= avecreal(nntax);


datatran(zoner.tran,nnsam,nntax,smdat,rsum,trandat,&(*stat));


if(zoner.ransam)
{
tranran(trandat,nntax,nnsam);
dprint(&(*stat),"Samples randomized\n");
rtn= fputs("Samples randomized\n",gl.logf.fp);
assert(rtn!=EOF);
}

rtn= fputs("Building table: ",stdout);
assert(rtn!=EOF);

for(j= 0;j<nnsam;j++)
{
rtn= printf("%d ",j);
assert(rtn>0);
for(kk= 0;kk<nntax;kk++)
{



if((total[kk]= trandat[kk][j])==0.0)sqtotal[kk]= 0.0;
else
{
if(zoner.meth==1||zoner.meth==3)
{
sqtotal[kk]= SQUARE(total[kk]);
}
else sqtotal[kk]= total[kk]*loge(total[kk])/LOG2;

}

}

table[j][0]= 0.0;

for(jj= j+1,i= 1;jj<nnsam;jj++,i++)
{
if(zoner.meth==1||zoner.meth==3)
{
table[j][i]= zonlstab_s(sqtotal,total,trandat,nntax,j,jj);
}
else if(zoner.meth==2||zoner.meth==4)
{
table[j][i]= zoninftab_s(sqtotal,total,trandat,nntax,j,jj);
}

}

}

rtn= putchar('\n');
assert(rtn!=EOF);


fvec(sqtotal);
fvec(total);
fmatreal(trandat,nntax);

if(zoner.meth==3||zoner.meth==4)
{
opttab= amatreal(nnsam,-1);
optmarktab= amatint(nnsam,-1);

for(j= 0;j<nnsam;j++)
{
opttab[0][j]= table[0][j];
optmarktab[0][j]= j;
}

}

lssic= table[0][nnsam-1];

label= avecflag_t(nnsam);

label[nnsam-1]= ON;

dprint(&(*stat),"(a) residual variance\n"
"(b) variance with n zones as %% of total\n"
"(c) variance reduction (%% of total) from n - 1 zones to n zones\n"
"(d) variance reduction (%% of n - 1 zones) from n - 1 zones to n "
"zones\n"
" n    (a)     (b)     (c)       (d)%s\n",
(zoner.ransam==OFF?"    markers":""));

rtn= sprintf(buffer,"  1 %8.4f  1.0000  -\n",lssic);
assert(rtn>0&&rtn<LENSTR);
dprint(&(*stat),buffer);

bsvals= avecreal(nnsam);
bstick(bsvals,nnsam);


zonlev= avecreal(nnsam-1);
if(zoner.model.ci==ON&&bmarker==NULL&&omarker==NULL)
{
if(zoner.meth==1||zoner.meth==2)
{
bmarker= amatint(nnsam-1,numzone-1);
for(j= 0;j<nnsam-1;j++)
{
setintarray(bmarker[j],numzone-1,0);
}

}

else
{
omarker= amatchar(models,20*(numzone-1));
for(i= 0;i<models;i++)omarker[i][0]= '\0';
}

}

i= 2;
for(m= 0;;)
{
if(zoner.meth==1||zoner.meth==2)
{
mark= zonbin_s(table,nnsam,label,lssic,&val);
zonlev[i-2]= (smdat[nntax][mark]+smdat[nntax][mark+1])/2;
if(bmarker!=NULL)bmarker[mark][i-2]+= 1;
label[mark]= ON;
prevlssic= lssic;
lssic= val;
if(prnflag==ON)
{
zprint_s(zoner,i,lssic,prevlssic,table[0][nnsam-1],
&(*stat),zonlev,bsvals[i-2]);
}

}

else
{
real rdummy1= 0;
real rdummy2= 0;

zonopt_s(table,opttab,optmarktab,nnsam,i-1);
j= i;
k= nnsam-1;
for(l= i-2;l>=0;l--)
{
mark= optmarktab[j-1][k-(j-1)];
zonlev[l]= (smdat[nntax][mark]+smdat[nntax][mark+1])/2;
if(omarker!=NULL&&i==numzone)
{
rtn= sprintf(buffer,"%.3f ",zonlev[l]);
assert(rtn>0&&rtn<LENSTR);
vstrcat(20*(numzone-1),omarker[models-zoner.model.n],
buffer,(char*)NULL);
}
k= mark;
j--;

}

rdummy1= opttab[i-1][(nnsam-1)-(i-1)];
rdummy2= opttab[i-2][(nnsam-1)-(i-2)];

if(prnflag==ON)
{
zprint_s(zoner,i,rdummy1,rdummy2,table[0][nnsam-1],&(*stat),
zonlev,bsvals[i-2]);
}

}

if(i==numzone)break;
if((i!=m+10&&i!=nnsam-2)||i<numzone)i++;
else
{
m= MIN(m+10,nnsam-2);
rtn= printf("\nSelect number of zones%s <Enter>\n",
i==nnsam-2?"":", or '0' to continue");
assert(rtn>0);
numzone= (int)(getsing(i==nnsam-2?2:0,i));

i++;
if(numzone==0)numzone= -1;
if(numzone>0)
{

for(j= 0;j<nnsam-1;j++)label[j]= OFF;
lssic= table[0][nnsam-1];
i= 2;
prnflag= OFF;
}

}

}

rtn= putchar('\n');
assert(rtn!=EOF);


if(zoner.model.ci==OFF&&zoner.ransam==OFF)
{
qsort(zonlev,numzone-1,sizeof(real),compare);

if(stat->st==OPEN)
{

prnzonelen_s(stat->fp,smdat[nntax],nnsam,zonlev,numzone);
}


rtn= fprintf(zone->fp,"%d\n",numzone);
assert(rtn>0);

for(i= numzone;i>0;i--)
{
rtn= fprintf(zone->fp,"%s%d\n",zoner.pre,i);
assert(rtn>0);
}

prnrealarray(zone->fp,"%.3f\n",zonlev,numzone-1);

closef(&(*zone),__FILE__,__LINE__);

}

if(zoner.model.ci==ON&&zoner.model.n==1)
{
if(stat->st==OPEN)
{
zmodres_s(stat->fp,numzone,nnsam,bmarker,omarker,smdat[nntax],
models,zoner.meth);
}
if(zoner.meth==1||zoner.meth==2)
{
fmatint(bmarker,nnsam-1);
bmarker= NULL;

}
else
{
fmatchar(omarker,models);
omarker= NULL;

}

}

fvec(zonlev);
fvec(bsvals);
fvec(label);
fmatint(optmarktab,nnsam);
fmatreal(opttab,nnsam);
fmatreal(table,nnsam);

return;
}

/*:10*//*12:*/
#line 563 "ppzoner.w"

static void zonopt_s
(
real**table,
real**opttab,
int**optmarktab,
int nnsam,
int n
)

{
int tempmark= 0;

loop_t i= 0;
loop_t j= 0;

real sosinfval= 0;
real tempval= 0;

for(i= n;i<nnsam;i++)
{

for(j= n-1,sosinfval= HUGE_VAL;j<i;j++)
{
tempval= opttab[n-1][j-(n-1)]+table[j+1][i-(j+1)];
if(tempval<sosinfval)
{
sosinfval= tempval;
tempmark= j;
}

}

opttab[n][i-n]= sosinfval;
optmarktab[n][i-n]= tempmark;

}

return;
}

/*:12*//*14:*/
#line 610 "ppzoner.w"

static real zonlstab_s
(
real*sqtotal,
real*total,
real**x,
int nntax,
int m,
int n
)

{
loop_t kk= 0;

real number= 0.0;
real sosinf= 0.0;
real val1= 0.0;

number= 1.0+n-m;
for(kk= 0;kk<nntax;kk++)
{
if((total[kk]+= (val1= x[kk][n]))!=0.0)
{
sqtotal[kk]+= SQUARE(val1);
sosinf+= (sqtotal[kk]-(total[kk]*total[kk]/number));
}

}

return(sosinf);
}

/*:14*//*16:*/
#line 648 "ppzoner.w"

static real zoninftab_s
(
real*sqtotal,
real*total,
real**x,
int nntax,
int m,
int n
)

{
loop_t i= 0;
loop_t kk= 0;

real number= 0.0;
real sosinf= 0.0;
real tempval= 0.0;
real val1= 0.0;

number= 1.0+n-m;
for(kk= 0;kk<nntax;kk++)
{
if((total[kk]+= (val1= x[kk][n]))!=0.0)
{
if(val1>0)sqtotal[kk]+= (val1*loge(val1)/LOG2);
sosinf+= sqtotal[kk];
for(i= m,tempval= 0.0;i<=n;i++)tempval+= x[kk][i];
sosinf-= (tempval*loge(total[kk]/number)/LOG2);
}

}

return(sosinf);
}

/*:16*//*18:*/
#line 690 "ppzoner.w"

static void zprint_s
(
const zoner_t zoner,
const int i,
real varczon,
real varpzon,
real vart,
file_t*stat,
real*zonlev,
real bsval
)

{
char buffer[LENSTR]= "";

loop_t j= 0;
real rdummy1= 0;
real rdummy2= 0;

qsort(zonlev,i-1,sizeof(real),compare);

rdummy1= (varpzon-varczon)/vart;
rdummy2= varczon/varpzon;


rtn= sprintf(buffer,"%3d %8.4f%8.4f%8.4f%s%8.4f ",i,varczon,
varczon/vart,rdummy1,bsval<rdummy1?"*":" ",rdummy2);
assert(rtn>0&&rtn<LENSTR);
dprint(&(*stat),"%s",buffer);
if(!zoner.ransam)
{
for(j= 0;j<i-1;j++)
{
rtn= sprintf(buffer," %-.3f",zonlev[j]);
assert(rtn>0&&rtn<LENSTR);
dprint(&(*stat),"%s",buffer);
}

}

rtn= fputc('\n',stat->fp);
assert(rtn!=EOF);
rtn= putchar('\n');
assert(rtn!=EOF);

return;
}

/*:18*//*20:*/
#line 765 "ppzoner.w"

/*25:*/
#line 1076 "ppzoner.w"

static void cclus_s(real**es,real*ess,int nnsam,int*namep,int*nameq);
/*:25*//*27:*/
#line 1201 "ppzoner.w"

static real update_s(int r);
/*:27*//*29:*/
#line 1224 "ppzoner.w"

static real d2_s(int i,int j);
/*:29*/
#line 766 "ppzoner.w"


/*:20*//*21:*/
#line 769 "ppzoner.w"

real dshort_f= 0.0;

int p_f= 0;
int q_f= 0;
int np_f= 0;
int nq_f= 0;

/*:21*//*22:*/
#line 778 "ppzoner.w"

real*d_f= NULL;
int*nclus_f= NULL;
int*name_f= NULL;


/*:22*//*24:*/
#line 790 "ppzoner.w"

void coniss
(
const zoner_t zoner,
int nnsam,
int nntax,
real**smdat,
real*rsum,
file_t*zone,
file_t*stat
)

{
static const char*dcname[]= 
{
"Euclidian distance",
"Edwards and Cavalli-Sforza's chord distance",
"standardized Euclidian",
"Orloci's chord distance",
"Euclidian distance on centred log ratios"
};

real diff= 0.0;
real dsqd= 0.0;
real zdummy= 0.0;

int dummy= 0;
int id= 0;
int mark= 0;
int numzone= 0;
static int models= 0;

loop_t i= 0;
loop_t j= 0;
loop_t k= 0;
loop_t n= 0;


real*bsvals= NULL;
real*ess= NULL;

real**es= NULL;
real**trandat= NULL;

real*zonlev= NULL;

int*namep= NULL;
int*nameq= NULL;

static int**marker= NULL;

dprint(&(*stat),"coniss");
rtn= fputs("coniss\n",gl.logf.fp);
assert(rtn!=EOF);
if(zoner.n==0)
{
numzone= -1;
dprint(&(*stat),"\n");
}
else
{
numzone= MIN(zoner.n,nnsam-1);
dprint(&(*stat),": splitting into %d zones",numzone);
if(zoner.model.ci)
{
if(marker==NULL)models= zoner.model.n;
dprint(&(*stat)," (model %d of %d)",1+models-zoner.model.n,
models);
}
dprint(&(*stat),"\n");
}

if(!zoner.model.ci&&!zoner.ransam)
{
zone->mode[0]= 'w';
openf(&(*zone),__FILE__,__LINE__,OFF);
if(zone->st==CLOSED)
{
dprint(&gl.logf,"No ZONE file: zonation abandoned\n");
return;
}

}

es= amatreal(nnsam,4);
trandat= amatreal(nntax,nnsam);

d_f= avecreal(nnsam*(nnsam-1)/2);
ess= avecreal(nnsam);

name_f= avecint(nnsam);
namep= avecint(nnsam);
nameq= avecint(nnsam);
nclus_f= avecint(nnsam);

for(i= 0;i<nnsam;i++)name_f[i]= i;


dprint(&(*stat),"Dissimilarity coefficient is %s\n",
dcname[zoner.tran]);
datatran(zoner.tran,nnsam,nntax,smdat,rsum,trandat,&(*stat));


if(zoner.ransam)
{
tranran(trandat,nntax,nnsam);
dprint(&(*stat),"Samples randomized\n");
rtn= fputs("Samples randomized\n",gl.logf.fp);
assert(rtn!=EOF);
}


for(i= 1,id= 0;i<nnsam;i++)
{
rtn= printf("%d ",i);
assert(rtn>0);
for(j= 0;j<i;j++)
{
dsqd= 0.0;
for(k= 0;k<nntax;k++)
{
diff= trandat[k][i]-trandat[k][j];
dsqd+= (SQUARE(diff));
}
d_f[id++]= dsqd;

}

}

rtn= putchar('\n');
assert(rtn!=EOF);


cclus_s(es,ess,nnsam,namep,nameq);


bsvals= avecreal(nnsam);
bstick(bsvals,nnsam);


if(stat->st==OPEN&&!zoner.model.ci)
{
rtn= fputs("\n"
"                                                                    Mean\n"
"                                                      Within-       within-\n"
"              Clusters    Increase in   Total         cluster       cluster\n"
"Stage         merged      dispersion    dispersion    dispersion"
"    dispersion\n",stat->fp);
assert(rtn!=EOF);

for(i= 0;i<nnsam-1;i++)
{
zdummy= es[i][0]/es[nnsam-2][1];
dummy= bsvals[nnsam-(i+2)]<zdummy?'*':' ';
rtn= fprintf(stat->fp,"%4d %9.3f %9.3f %12.6f%c ",i+1,
smdat[nntax][namep[i]],smdat[nntax][nameq[i]],es[i][0],
dummy);
assert(rtn>0);
rtn= fprintf(stat->fp,"%12.6f %12.6f %12.6f\n",es[i][1],es[i][2],
es[i][3]);
assert(rtn>0);
}

}




zonlev= avecreal(nnsam);
if(zoner.model.ci&&marker==NULL)
{
marker= amatint(nnsam-1,numzone-1);
for(j= 0;j<nnsam-1;j++)
{
setintarray(marker[j],numzone-1,0);
}

}



if(numzone==-1)
{
rtn= printf("\n(a) Prop. of dispersion %s\n",
zoner.ransam?"":"(b) Markers");
assert(rtn>0);
rtn= printf("  n   (a)          %s\n",zoner.ransam?"":"(b)");
assert(rtn>0);
for(j= nnsam-2,i= 1,n= 0;;n++,i++,j--)
{
zdummy= es[j][0]/es[nnsam-2][1];
rtn= printf("%3d %10.6f%s ",i+1,zdummy,
bsvals[nnsam-(j+2)]<zdummy?"*":" ");
assert(rtn>0);

if(!zoner.ransam)
{

mark= nameq[nnsam-2-(i-1)]-1;
zonlev[i-1]= (smdat[nntax][mark]+smdat[nntax][mark+1])/2;

qsort(zonlev,i,sizeof(real),compare);

prnrealarray(stdout," %.3f",zonlev,i);

}
else
{
rtn= putchar('\n');
assert(rtn!=EOF);
}

if(n==10||i==nnsam-2)
{
n= 0;
rtn= printf("\nSelect number of zones%s <Enter>\n",
i==nnsam-2?"":", or '0' to continue");
assert(rtn>0);
numzone= (int)(getsing(i==nnsam-2?2:0,i));

if(numzone>0)break;

}

}

}


for(i= 0;i<numzone-1;i++)
{
mark= nameq[nnsam-2-i]-1;
zonlev[i]= (smdat[nntax][mark]+smdat[nntax][mark+1])/2;
if(marker!=NULL)marker[mark][i]+= 1;
}

if(zoner.model.ci==OFF&&zoner.ransam==OFF)
{
qsort(zonlev,numzone-1,sizeof(real),compare);

if(stat->st==OPEN)
{

prnzonelen_s(stat->fp,smdat[nntax],nnsam,zonlev,numzone);
}


rtn= fprintf(zone->fp,"%d\n",numzone);
assert(rtn>0);
for(i= numzone;i>0;i--)
{
rtn= fprintf(zone->fp,"%s%d\n",zoner.pre,i);
assert(rtn>0);
}
prnrealarray(zone->fp,"%.3f\n",zonlev,numzone-1);

closef(&(*zone),__FILE__,__LINE__);

}

if(zoner.model.n==1&&stat->st==OPEN)
{
zmodres_s(stat->fp,numzone,nnsam,marker,(char**)NULL,smdat[nntax],
models,zoner.meth);
fmatint(marker,nnsam-1);
marker= NULL;
}


fvec(zonlev);
fvec(bsvals);
fvec(nclus_f);
fvec(nameq);
fvec(namep);
fvec(name_f);
fvec(ess);
fvec(d_f);
fmatreal(trandat,nntax);
fmatreal(es,nnsam);

return;
}

/*:24*//*26:*/
#line 1079 "ppzoner.w"

static void cclus_s
(
real**es,
real*ess,
int nnsam,
int*namep,
int*nameq
)

{
real de= 0;
real e= 0.0;

int id= 0;
int ij= 0;
int i1j= 0;
int ip= 0;
int iq= 0;
int ir= 0;
int msiz= 0;
int namp= 0;
int namq= 0;

loop_t i= 0;
loop_t iter= 0;
loop_t j= 0;
loop_t m= 0;
loop_t n= 0;



setintarray(nclus_f,nnsam,1);
setrealarray(ess,nnsam,0);

msiz= nnsam-1;







for(iter= 1;iter<=nnsam-1;iter++)
{

dshort_f= d_f[0];
p_f= 1;
id= 1;
for(n= 2;n<=msiz;n++)
{
id+= n;
if(d_f[id-1]<dshort_f)
{
dshort_f= d_f[id-1];
p_f= n;
}

}

q_f= p_f+1;
namp= name_f[p_f-1];
namq= name_f[q_f-1];
namep[iter-1]= namp;
nameq[iter-1]= namq;
np_f= nclus_f[namp];
nq_f= nclus_f[namq];


de= dshort_f/2.0;
e+= de;
ess[namp]+= (ess[namq]+de);
es[iter-1][0]= de;
es[iter-1][1]= e;
es[iter-1][2]= ess[namp];
es[iter-1][3]= ess[namp]/((real)np_f+(real)nq_f);


ip= (p_f-1)*(p_f-2)/2;
iq= (q_f-1)*(q_f-2)/2;
for(j= 1;j<=p_f-1;j++)
{
id= ip+j;
d_f[id-1]= update_s(j);
for(i= q_f;i<=msiz;i++)
{
ij= j+(i-1)*(i-2)/2;
i1j= ij+i-1;
d_f[ij-1]= d_f[i1j-1];
}

}

ir= (iq-q_f)+2;
for(i= q_f;i<=msiz;i++)
{
ir+= (i-2);
id= ir+p_f;
d_f[id-1]= update_s(i+1);
}
for(j= q_f;j<=(msiz-1);j++)
{
for(i= j+1;i<=msiz;i++)
{
ij= j+(i-1)*(i-2)/2;
i1j= ij+i;
d_f[ij-1]= d_f[i1j-1];
}

}

for(m= q_f;m<=msiz;m++)name_f[m-1]= name_f[m];
nclus_f[namp]= np_f+nq_f;
msiz--;

}

return;
}

/*:26*//*28:*/
#line 1204 "ppzoner.w"

static real update_s
(
int r
)

{
real x= 0.0;

int nr= 0;

nr= nclus_f[name_f[r-1]];
x= (((real)nr+np_f)*d2_s(r,p_f)+((real)nr+nq_f)*
d2_s(r,q_f)-nr*dshort_f)/((real)nr+np_f+nq_f);

return(x);
}

/*:28*//*30:*/
#line 1227 "ppzoner.w"

static real d2_s
(
int i,
int j
)

{
int id= 0;

if(i>j)id= (i-1)*(i-2)/2+j;
else id= (j-1)*(j-2)/2+i;

return(d_f[id-1]);
}

/*:30*//*32:*/
#line 1249 "ppzoner.w"

static void prnzonelen_s
(
FILE*fp,
real*data,
int nnsam,
real*zonlev,
int numzone
)

{
int count= 0;
loop_t j= 0;
loop_t jj= 0;

real*samples= NULL;
samples= avecreal(nnsam);

cpyrealarray(samples,data,nnsam);
qsort(samples,nnsam,sizeof(real),compare);

rtn= fprintf(fp,"\n%d zones selected: numbers of samples per zone are: ",
numzone);
assert(rtn!=EOF);

for(j= 0,jj= 0;j<nnsam;j++)
{
if(jj<numzone-1&&samples[j]>zonlev[jj])
{
rtn= fprintf(fp,"%d ",count);
assert(rtn>0);
count= 0;
jj++;
}
count++;

}


rtn= fprintf(fp,"%d ",count);
assert(rtn>0);

rtn= fputs("\n\n",fp);
assert(rtn!=EOF);

fvec(samples);

}/*:32*/
