/*3:*/
#line 24 "walker.w"

#include "psimpoll.h" 
#include "ppglobal.h" 

/*:3*//*4:*/
#line 29 "walker.w"

/*8:*/
#line 271 "walker.w"

static void bisplt1_s(int*x,int nnsam,int*itop,int*nsplt,real*asig,
real signif);
/*:8*//*10:*/
#line 333 "walker.w"

static void gtsplt1_s(int*x,int npnts,int*iwh,real*lmax);
/*:10*//*12:*/
#line 389 "walker.w"

static real func_s(real arg1,real arg2);
/*:12*//*14:*/
#line 420 "walker.w"

static void bisplt2_s(real*x,int low,int high,int*itop,int*nsplt,
real*asig,real signif);
/*:14*//*16:*/
#line 482 "walker.w"

static void gtsplt2_s(real*x,int npnts,int*iwh,real*cmax);
/*:16*//*18:*/
#line 574 "walker.w"

static void stats2_s(real*x,int n1,int n2,real*mean,real*sd);
/*:18*//*20:*/
#line 606 "walker.w"

static void stats1_s(int*x,int n1,int n2,real*mean,real*sd);
/*:20*/
#line 30 "walker.w"


/*:4*//*5:*/
#line 33 "walker.w"

real theta2= 0.25;


/*:5*//*7:*/
#line 42 "walker.w"

void indsplit
(
int itax,
data_t data,
file_t*stat,
real*splits
)

{
real mean= 0.0;
real mean1= 0.0;
real mean2= 0.0;
real mean3= 0.0;
real minval= FLT_MAX;
real sd= 0.0;
real signif= 0.0;
real val1= 0.0;
real val2= 0.0;

const real sig[]= 
{
0,0,0,0,9,10.5,11,13.4,14.4,15.6,16.6,
16.6,16.6,18.8,18.8,18.8,18.8,18.8,19.6,
19.6,19.6,19.6,19.6,19.6,19.6,21.0,21.0,
21.0,21.0,21.0,21.0,21.0,21.0,21.0,21.0,
22.0,22.0,22.0,22.0,22.0,22.0,22.0,22.0,
22.0,22.0,22.4,22.4,22.4,22.4,22.4,22.4,
22.4,22.4,22.4,22.4
};

int high= 0;
int low= 0;
int m= 0;
int n= 0;
int nnsam= 0;
int nsplt= 0;
int nsplt2= 0;

loop_t i= 0;
loop_t ii= 0;
loop_t j= 0;



real*asig= NULL;
real*ndatrow= NULL;
real*nalev= NULL;
int*obs1= NULL;
real*obs2= NULL;

int*ipt= NULL;
int*ipt2= NULL;
int*spltpos= NULL;

nalev= avecreal(data.nsam);
ndatrow= avecreal(data.nsam);

for(j= 0,nnsam= 0;j<data.nsam;j++)
{
if(data.levfg[j]==ON&&data.dat[itax][j]>(float)gl.neglev)
{
ndatrow[nnsam]= (real)data.dat[itax][j];
nalev[nnsam]= (real)data.alev[j];
minval= MIN(minval,ndatrow[nnsam]);
nnsam++;
}

}

asig= avecreal(nnsam);
obs2= avecreal(nnsam);
obs1= avecint(nnsam);
ipt= avecint(nnsam);
ipt2= avecint(nnsam);
spltpos= avecint(nnsam);

spltpos[0]= 0;
spltpos[1]= nnsam-1;



for(j= 0;j<nnsam;j++)
{
if(ndatrow[j]>0)obs1[j]= 1;
else obs1[j]= 0;
}



bisplt1_s(obs1,nnsam,ipt,&nsplt,asig,0.001);

m= 2;

if(nsplt==0||minval<0.0)
{
dprint(&(*stat),"Presence-absence splits not found\n");
}
else
{
dprint(&(*stat),"Presence-absence splits at ");
for(i= 0;i<nsplt;i++)
{
spltpos[m++]= ipt[i];
val1= (nalev[ipt[i]]+nalev[ipt[i]-1])/2;
splits[n++]= -val1;
dprint(&(*stat),"%.3f ",val1);
}
dprint(&(*stat),"\n");

}




for(j= 0;j<nnsam;j++)
{
if(gl.code.dat=='%')obs2[j]= ndatrow[j]/100;
else obs2[j]= ndatrow[j];
}

if(nsplt==0||minval<0.0)
{
signif= theta2*(nnsam<55?sig[nnsam]:23.0);
bisplt2_s(obs2,0,nnsam,ipt,&nsplt,asig,signif);
if(nsplt==0)dprint(&(*stat),"Quantitative splits not found\n");
else
{
dprint(&(*stat),"Quantitative splits at ");
for(i= 0;i<nsplt;i++)
{
spltpos[m++]= ipt[i];
val1= (nalev[ipt[i]]+nalev[ipt[i]-1])/2;
splits[n++]= val1;
dprint(&(*stat),"%.3f ",val1);
}

dprint(&(*stat),"\n");

}

}

else
{
ipt[nsplt]= nnsam-1;
low= 0;
for(i= 0;i<=nsplt;i++)
{
high= ipt[i];
stats1_s(obs1,low,high,&mean1,&sd);
if(i<nsplt)stats1_s(obs1,high,ipt[i+1],&mean2,&sd);
else mean2= mean3;
if(mean1<mean2)
{
low= high;
continue;
}
mean3= mean1;
if(low==0)val1= nalev[low];
else val1= (nalev[low]+nalev[low-1])/2;
if(high==nnsam-1)val2= nalev[high];
else val2= (nalev[high]+nalev[high-1])/2;
dprint(&(*stat),"Within %.3f - %.3f: ",val1,val2);

signif= theta2*(high-low<55?sig[high-low]:23.0);

bisplt2_s(obs2,low,high,ipt2,&nsplt2,asig,signif);
if(nsplt2==0)dprint(&(*stat),"quantitative splits not found\n");
else
{
dprint(&(*stat),"quantitative splits at ");
for(ii= 0;ii<nsplt2;ii++)
{
spltpos[m++]= ipt2[ii]+low;
val1= (nalev[ipt2[ii]+low]+nalev[ipt2[ii]+low-1])/2;
splits[n++]= val1;
dprint(&(*stat),"%.3f ",val1);
}

dprint(&(*stat),"\n");

}

low= high;

}

}

if(n>19)derror(15);

splits[n]= FLT_MAX;

qsort(spltpos,m,sizeof(int),compint);

dprint(&(*stat),"Section             Mean     SD\n");
for(i= 0;i<=m-2;i++)
{



low= spltpos[i];
high= spltpos[i+1];
if(i==m-2)high++;

stats2_s(obs2,low,high,&mean,&sd);

if(low==0)val1= nalev[low];
else val1= (nalev[low]+nalev[low-1])/2;
if(high==nnsam)val2= nalev[high-1];
else val2= (nalev[high]+nalev[high-1])/2;
dprint(&(*stat),"%.3f - %.3f  %.3f  %.3f\n",val1,val2,mean,sd);
}

fvec(spltpos);
fvec(ipt2);
fvec(ipt);
fvec(obs1);
fvec(obs2);
fvec(asig);
fvec(ndatrow);
fvec(nalev);

return;
}

/*:7*//*9:*/
#line 275 "walker.w"

static void bisplt1_s
(
int*x,
int nnsam,
int*itop,
int*nsplt,
real*asig,
real signif
)

{
real es= 0.0;

int bot= 1;
int iwh= 0;
int kt= 1;
int np= 0;

itop[0]= nnsam;
*nsplt= 1;

for(;;)
{
np= itop[kt-1]-bot+1;
gtsplt1_s(x+bot-1,np,&iwh,&es);
if(es>0.0)
{
es= gammq(0.5,loge(es));
if(es>0.0&&es<=(0.1/nnsam))
{
kt= (*nsplt);
(*nsplt)++;
itop[(*nsplt)-1]= itop[kt-1];
itop[kt-1]= bot+iwh-1;
asig[kt-1]= es;
}

}

if(es<=0.0||es>(0.1/nnsam))
{
if(kt==(*nsplt))break;
bot= itop[kt-1]+1;
kt--;
if(kt==0)kt= *nsplt;
if(itop[kt-1]<bot)kt= *nsplt;
}

}

(*nsplt)--;

return;
}

/*:9*//*11:*/
#line 336 "walker.w"

void gtsplt1_s
(
int*x,
int npnts,
int*iwh,
real*lmax
)

{
real c= 0.0;
real ek= 0.0;
real en= 0.0;
real l= 0.0;
real r= 0.0;
real r1= 0.0;
real r2= 0.0;

loop_t k= 0.0;

*iwh= 0;
*lmax= -1;

if(npnts<4)return;

for(k= 0;k<npnts;k++)
{
if(x[k]!=0)r= r+1.0;
}

en= (real)npnts;
if(x[0]!=0)r1= 1.0;
c= 1.0/func_s(en,r);
for(k= 2;k<=npnts-2;k++)
{
if(x[k-1]!=0)r1= r1+1.0;
r2= r-r1;
ek= (real)k;
l= func_s(ek,r1)*func_s(en-ek,r2)*c;
if(l>(*lmax))
{
*lmax= l;
*iwh= k;
}

}

return;
}

/*:11*//*13:*/
#line 392 "walker.w"

static real func_s
(
real arg1,
real arg2
)

{
real ln1= 0.0;
real ln2= 0.0;
real val= 1.0;

if(arg1==0||arg2==0||arg1==arg2)val= 1.0;
else
{
ln1= loge(arg1);
ln2= loge(arg2);
val= expe((ln2-ln1)*arg2)*
expe(((loge(arg1-arg2))-ln1)*(arg1-arg2));
}

if(val<FLT_MIN)val= 1.0;

return(val);
}


/*:13*//*15:*/
#line 424 "walker.w"

static void bisplt2_s
(
real*x,
int low,
int high,
int*itop,
int*nsplt,
real*asig,
real signif
)

{
real es= 0.0;

int bot= 1;
int iwh= 0;
int kt= 1;
int np= 0;

itop[0]= high-low;
*nsplt= 1;

for(;;)
{
np= itop[kt-1]-bot+1;
gtsplt2_s(x+low+bot-1,np,&iwh,&es);

if(es>=signif)
{
kt= (*nsplt);
(*nsplt)++;
itop[(*nsplt)-1]= itop[kt-1];
itop[kt-1]= bot+iwh-1;
asig[kt-1]= es;
}
else
{
if(kt==(*nsplt))break;
bot= itop[kt-1]+1;
for(;;)
{kt--;
if(kt==0)kt= *nsplt;
if(itop[kt-1]>=bot)break;
}

}

}

(*nsplt)--;

return;
}


/*:15*//*17:*/
#line 485 "walker.w"

static void gtsplt2_s
(
real*x,
int np,
int*iwh,
real*cmax
)

{
real ak= 0.0;
real ak1= 0.0;
real ank= 0.0;
real ank1= 0.0;
real c= 0.0;
real const1= 0.0;
real const2= 0.0;
real s= 0.0;
real s1= 0.0;
real s2= 0.0;
real sx= 0.0;
real sx1= 0.0;
real sx2= 0.0;
real sxx= 0.0;
real sxx1= 0.0;
real sxx2= 0.0;
real val= 0.0;
real vv1= 0.0;
real vv2= 0.0;

int np3= 0;

loop_t i= 0;
loop_t k= 0;

*iwh= 0;
*cmax= -1;

if(np<4)return;

np3= np-2;
val= x[0];
sx= sx1= val;
sxx= sxx1= SQUARE(val);

for(i= 1;i<np;i++)
{
val= x[i];
sx+= val;
sxx+= (SQUARE(val));
}

const1= 1.0/((real)np-2);
*cmax= -9e10F;
s= (np*sxx-(SQUARE(sx)))/((real)np*((real)np-1));
if(s<=0)const2= 0;
else const2= -((real)np-2)*loge(sqrte(s));

for(k= 2;k<=np3;k++)
{
ak= (real)k;
ank= (real)np-k;
val= x[k-1];
sx1+= val;
sxx1+= (SQUARE(val));
sx2= sx-sx1;
sxx2= sxx-sxx1;
vv1= (ak*sxx1-(SQUARE(sx1)))/(ak*(ak-1));
vv2= (ank*sxx2-(SQUARE(sx2)))/(ank*(ank-1));
s1= (vv1<=(float)0?(float)0:(loge(vv1))/2.0);
s2= (vv2<=(float)0?(float)0:(loge(vv2))/2.0);
ak1= ak-1.0;
ank1= ank-1.0;
c= 1.0F+(1.0F/ak1+1.0F/ank1-const1)/3.0F;
c= -(ak1*s1+ank1*s2+const2)/c;
if(c>(*cmax))
{
*cmax= c;
*iwh= k;
}

}

return;
}


/*:17*//*19:*/
#line 577 "walker.w"

static void stats2_s
(
real*x,
int n1,
int n2,
real*mean,
real*sd
)

{
loop_t i= 0;

*mean= 0.0;
*sd= 0.0;

for(i= n1;i<n2;i++)*mean= (real)x[i]+(*mean);
*mean/= ((real)n2-n1);

for(i= n1;i<n2;i++)*sd+= (SQUARE((x[i]-(*mean))));
*sd/= ((real)n2-n1-1);
if(*sd>0.0)*sd= sqrte((*sd));

return;
}


/*:19*//*21:*/
#line 609 "walker.w"

static void stats1_s
(
int*x,
int n1,
int n2,
real*mean,
real*sd
)

{
loop_t i= 0;

*mean= 0;
*sd= 0;

for(i= n1;i<n2;i++)*mean= (*mean)+(real)x[i];
*mean/= ((real)n2-n1);

for(i= n1;i<n2;i++)*sd+= (SQUARE(((real)x[i]-(*mean))));
*sd/= ((real)n2-n1-1);
if(*sd>0.0)*sd= sqrte((*sd));

return;
}

/*:21*/
